var eventInsideListAdding = false;
var listAddInput = "#listFriend";

jQuery.eventInsideListAddStart = function() {
    $("#eventInsideListAddTitle").dotdotdot({watch: true, wrap: 'letter'});

    initialFriends = null; //apaga cache de amigos
    $("#eventInsideListAddTitle").html(actualList.name);

    if(theme=="dark"){
        $(".loader").attr("src",darkLoader);
    }

    console.log(uEditParticipant + " @ " + actualList.isManager + " @ " + actualList.need_email + " # " + actualList.need_phone);
    if((uEditParticipant || actualList.isManager) && !actualList.need_email && !actualList.need_phone){
        $(listAddInput).hide();
        listAddInput = "#listFriends";
        $(listAddInput).show();
        $(listAddInput).parent().parent().addClass("search-big");
    }

    setTimeout(function(){
        $.eventInsideListAddUpdate();

        $(listAddInput).bind("change keyup paste cut", function() {
            //$("#containerAddFriendSuggestion").hide();
            var self = this;
            setTimeout(function(){
                var inputValue = $(self).val();
                if((uEditParticipant || actualList.isManager) && (inputValue.indexOf(",") >= 0 || inputValue.indexOf(".") >= 0 || inputValue.indexOf("\n") >= 0)){
                    inputValue = inputValue.replace(/,|;|\r\n|\n/g, ",");
                    starr = inputValue.split(",");
                    inputValue = starr.length + " nomes";
                }
                $("#addFriendNameLabel").html(inputValue);

                if(inputValue){
                    $("#btnAddTextName").show();
                    $("#btnClearProduct").show();
                } else {
                    $("#btnAddTextName").hide();
                    //$("#containerAddFriend").html("");
                    //$("#containerAddFriendSuggestion").show();
                    $.listAddInitialFriends();
                    $("#btnClearProduct").hide();
                }

            }, 100);
           //alert($(this).val());
        });
    },400);

    $("#btnAddTextName").dhoneBind(function(){
        $(listAddInput).dhoneTrim(); //retira espaços desnecessários

        function addonlist(callback, email, phone) {
            
            var names = $(listAddInput).val().replace(/,|;|\r\n|\n/g, ",").split(",");
            
            var error = 0;
            for (var index in names) {
                var name = $.trim(names[index]);
                if (name.indexOf(" ") > 0 || name.indexOf("@") == 0) {
                    
                    var subnames = name.split(" ");
                    
                    for(var i2 in subnames) {
                        var subname = subnames[i2];
                        
                        if (!isNaN(subname)) {
                            error = 2;
                            break;
                        }
                    }
                    
                } else {
                    error = 1;
                    break;
                }
            }
            
            if (error == 1) {
                $.showMsg("Erro","Todos os nomes devem conter nome e sobrenome.");
            } else if (error == 2) {
                $.showMsg("Erro","Um nome não pode ser formado de números.");
            }
            
            if (error) {
                eventInsideListAdding = false;
                return;
            }
            
            $("#nameAddName").hide();
            $("#nameAddLoading").show();

            var request = "addonlist?version=4";

            if (email) request += "&email="+email;
            if (phone) request += "&phone="+phone;

            request += "&client="+clientId+"&subscriber_id="+uUserId+"&list_id="+actualList.id+"&event_id="+actualList.event_id+"&name="+names.join(",");

            $.server(request ,function(json){
                $.eventIsideListAddListCallback(actualList.id,json,false,$(listAddInput).val());
                eventInsideListAdding = false;
                $(listAddInput).val("");
                $(listAddInput).trigger("change");
                setTimeout(callback, 200, json);
                if(json.names_not_add && json.names_not_add.length > 0){
                    if (json.names_not_add.length == 1) stMsg = " usuário não existe e não foi adicionado: ";
                    else stMsg = " usuários não existem e não foram adicionados: ";
                    $.showMsg("Alerta", json.names_not_add.length + stMsg + "<br><br><strong>" + json.names_not_add.join("</strong><br><strong>") + "</strong>");
                }
            },"modal");

        }

        if(!uUserId){
            $.modalShow("requirelogin");
            return;
        }

        if(!eventInsideListAdding){
            eventInsideListAdding = true;

            if (actualList.need_email || actualList.need_phone) {
                $.modalShow("addparticipanttolist", function(){
                    $("#addParticipantToListModalName").val($(listAddInput).val().replace(/,|;|\r\n|\n/g, ","));

                    if (actualList.need_email)
                        $("#addParticipantToListModalEmail").parent().show();
                    else
                        $("#addParticipantToListModalEmail").parent().hide();

                    if (actualList.need_phone){
                        // $("#addParticipantToListModalPhone").mask("(99) 99999-999?9").blur(function () {

                        //     var self = $(this);

                        //     var typedPhone = self.val().replace(/[_-]/, "");

                        //     if (typedPhone.length < 14) {
                        //         self.val(typedPhone.slice(0, 9)+"-"+typedPhone.slice(9));
                        //     }

                        // }).parent().show();
                        $.dhonePhone("#addParticipantToListModalPhone");
                        $("#addParticipantToListModalPhone").parent().show();
                    } else {
                        $("#addParticipantToListModalPhone").parent().hide();
                    }




                    $("#btnAddParticipantToList").dhoneBind(function(){

                        var erro = 0;

                        var email = $("#addParticipantToListModalEmail").val();
                        var phone = $("#addParticipantToListModalPhone").val();


                        if (actualList.need_email && !email.match(/^[\w\.]+@\w+(\.\w+)+$/)) {
                            //$.openInputError("#addParticipantToListModalEmailErr", true);
                            $.errorInputOpen("#addParticipantToListModalEmail", "O email deve possuir um formato v&aacute;lido." ,3000);
                            erro = 1;
                        } else {
                            $.closeInputError("#addParticipantToListModalEmailErr");
                        }

                        if (actualList.need_phone && !phone.match(/^\(\d{2}\)\s\d{4}\d?-\d{4}$/)) {
                            //$.openInputError("#addParticipantToListModalPhoneErr", true);
                            $.errorInputOpen("#addParticipantToListModalPhone", "O telefone deve estar no formato (XX) XXXXX-XXXX" ,3000);
                            erro = 1;
                        } else {
                            $.closeInputError("#addParticipantToListModalPhoneErr");
                        }

                        if (erro > 0) return;

                        $("#addParticipantToListBtnText").hide();
                        $("#addParticipantToListBtnLoading").show();

                        addonlist(function(json) {
                            $("#nameAddName").show();
                            $("#nameAddLoading").hide();
                            $("#addParticipantToListBtnText").show();
                            $("#addParticipantToListBtnLoading").hide();
                            if (!json.msg) $.modalHide();
                        }, email, phone);

                    });
                });
                eventInsideListAdding = false;
            } else {
                addonlist(function(){
                    $("#nameAddName").show();
                    $("#nameAddLoading").hide();
                });
            }
        }
    });

    //setTimeout(function(){
    //    $(listAddInput).focus();
    //}, 600);
   //$("#addFriendNameLabel").
}

//jQuery.eventInsideListAddStart = function () {
//    eventInsideListAdding = true;
//}

//jQuery.eventInsideListAddEnd = function () {
//    eventInsideListAdding = false;
//}

jQuery.eventInsideListAddUpdate = function() {
    var hash = window.location.hash;

    hash = hash.split("#");
    hash.splice(0, 4);

    $(listAddInput).autocomplete({
        //lookup: countries,
        paramName: 'search',
        params: {"user_id":uUserId},
        //serviceUrl: 'http://172.30.7.102/outgositeteste/painel/clients/pink/index.php?tipo=autocomplete',
        serviceUrl: serverURL+"userautocomplete/"+clientId+"/",
        minChars : 1,
        triggerSelectOnValidInput : false,
        container: '#containerAddFriend',
        selectFunction: '$.listAddFriend'
    });

    $.listAddInitialFriends();
    //actualList = AGENDA_JSON[hash[0]].lists[hash[1]].id; //****************************************************** RECUPERAR LISTAS AQUI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    //$("#listTitle").html(AGENDA_JSON[hash[0]].lists[hash[1]].name);
    //$.server("getlist/?client="+clientId+"&user_id="+uUserId+"&list_id="+actualList, $.loadEventList);
    //$.server();

}

jQuery.listAddFriend = function(self,id,username,name,hasphone){
    if(!uUserId){
        $.modalShow("requirelogin");
        return;
    }

    if(!eventInsideListAdding){
        if(actualEvent.time_type == "old"){
            $.showMsg("Atenção","O evento já passou");
            return;
        }
        eventInsideListAdding = true;

        function finalizeListAdd(callback, email, phone){
            extradata = "";
            if (email) extradata += "&email="+email;
            if (phone) extradata += "&phone="+phone;

            console.log(email||phone);

            $(self).find(".vertical-text").append('<button id="listAddLoadingAdd" type="button" class="btn-square btn-load"></button>');
            if(id==null){
                $.server("addonlist?version=4&client="+clientId+"&subscriber_id="+uUserId+"&list_id="+actualList.id+"&event_id="+actualList.event_id+"&name="+name+extradata,function(json){
                        $.eventIsideListAddListCallback(actualList.id,json,false,name,id,(email||phone));
                        eventInsideListAdding = false;

                        $("#listAddLoadingAdd").remove();
                        $(listAddInput).val("");
                        $(listAddInput).trigger("change");

                        if(callback) callback(json);
                },"modal");
            } else {
                $.server("addonlist?version=4&client_id="+clientId+"&user_id="+id+"&list_id="+actualList.id+"&event_id="+actualList.event_id+"&subscriber_id="+uUserId+"&name="+name+extradata, function(json){
                        $.eventIsideListAddListCallback(actualList.id,json,false,name,id,(email||phone));
                        eventInsideListAdding = false;
                        $(self).find("button").remove();
                        //TODO TESTAR <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                        //$.listAddDropDownAdd(username);
                        $("#listAddLoadingAdd").remove();
                        //$.dhoneBack();
                        //$.eventInsideListUpdate();
                        $(listAddInput).val("");
                        $(listAddInput).trigger("change");

                        if(callback) callback(json);
                    }, "modal");
            }

        }

        if((actualList.need_email && id == null) || (actualList.need_phone && !hasphone)){
            $.modalShow("addparticipanttolist", function(){
                $("#addParticipantToListModalName").val(name);

                if (actualList.need_email && id == null)
                    $("#addParticipantToListModalEmail").parent().show();
                else
                    $("#addParticipantToListModalEmail").parent().hide();

                if (actualList.need_phone && !hasphone) {
                    // $("#addParticipantToListModalPhone").mask("(99) 99999-999?9").blur(function () {

                    //     var self = $(this);

                    //     var typedPhone = self.val().replace(/[_-]/, "");

                    //     if (typedPhone.length < 14) {
                    //         self.val(typedPhone.slice(0, 9)+"-"+typedPhone.slice(9));
                    //     }

                    // }).parent().show();
                    $.dhonePhone("#addParticipantToListModalPhone");
                    $("#addParticipantToListModalPhone").parent().show();
                } else $("#addParticipantToListModalPhone").parent().hide();

                $("#btnAddParticipantToList").dhoneBind(function(){

                    var erro = 0;

                    var email = $("#addParticipantToListModalEmail").val();
                    var phone = $("#addParticipantToListModalPhone").val();


                    if (actualList.need_email && id == null && !email.match(/^[\w\.]+@\w+(\.\w+)+$/)) {
                        //$.openInputError("#addParticipantToListModalEmailErr", true);
                        $.errorInputOpen("#addParticipantToListModalEmail", "O email deve possuir um formato v&aacute;lido." ,3000);
                        erro = 1;
                    } else {
                        $.closeInputError("#addParticipantToListModalEmailErr");
                    }

                    if (actualList.need_phone && !hasphone && !phone.match(/^\(\d{2}\)\s\d{4}\d?-\d{4}$/)) {
                        //$.openInputError("#addParticipantToListModalPhoneErr", true);
                        $.errorInputOpen("#addParticipantToListModalPhone", "O telefone deve estar no formato (XX) XXXXX-XXXX" ,3000);
                        erro = 1;
                    } else {
                        $.closeInputError("#addParticipantToListModalPhoneErr");
                    }

                    if (erro > 0) return;

                    $("#addParticipantToListBtnText").hide();
                    $("#addParticipantToListBtnLoading").show();

                    finalizeListAdd(function(json) {
                        // $("#nameAddName").show();
                        // $("#nameAddLoading").hide();
                        $("#addParticipantToListBtnText").show();
                        $("#addParticipantToListBtnLoading").hide();
                        if (!json.msg) $.modalHide();
                    }, email, phone);

                });
            });
            eventInsideListAdding = false;
        } else {
            finalizeListAdd();
        }
    }
}

var dropIndex = 900;
jQuery.listAddDropDownAdd = function(name,json){
    var localDropIndex = dropIndex--;

    var dropMsg = '<h3>"'+name+'" adicionado</h3>';
    var hasDropMsg = true;

    if((uEditParticipant || actualList.isManager) && (name.indexOf(",") >= 0 || name.indexOf(".") >= 0 || name.indexOf("\n") >= 0)){
        if(json.names){
            stFix = json.qtd_add == 1 ? "" : "s";
            stFix2 = json.qtd_not_add == 1 ? "a" : "ão";
            stFix3 = json.qtd_not_add == 1 ? "" : "s";

            if(json.qtd_add == 0){
                msg = "<p>Nenhum nome foi adicionado.</p>";
            } else {
                msg = "<p>Apenas " + json.qtd_add + ' nome'+stFix+' adicionado'+stFix+'.</p>'
            }
            msg += '<p>O'+stFix3+' nome'+stFix3+' "'+ json.names +'" est'+stFix2+' adicionado'+stFix3+' à lista.</p>'
            $.showMsg("Alerta", msg);

            hasDropMsg = false;
        } else {
            name = name.replace(/,|;|\r\n|\n/g, ",");
            starr = name.split(",");
            dropMsg = '<h3>'+starr.length+' nomes adicionados</h3>';
        }
    }

    var htmlDrop =  '<div id="listAddDrop'+localDropIndex+'" class="msg confirm-color notification" style="margin-top:-50px;">'+
                        '<i class="mdi mdi-check"></i>'+
                        dropMsg+
                    '</div>';

    if(hasDropMsg) {
        setTimeout(function(){
            $("#listAddDroppContainer").append(htmlDrop);
            $('#listAddDrop'+localDropIndex).animate({marginTop:0},400);

            setTimeout(function(){
                $('#listAddDrop'+localDropIndex).animate({marginTop:-50},400,function(){
                    $(this).hide();
                });
               //$("#listAddDrop"+localDropIndex).slideUp();
            },2000);
        }, 500);
    }
}

/*
var dropIndex = 10;
var qtdEnviado = 0;
jQuery.listAddDropDownAdd = function(name){
    var localDropIndex = dropIndex++;
    console.log("enviado " + qtdEnviado);
    if(qtdEnviado == 0){
        qtdEnviado++;
        var htmlDrop = '<div id="listAddDrop'+localDropIndex+'" class="" style="position:fixed;width:100%;border-bottom: 1px solid #dfdfdf;height:47px;margin-top:3px;z-index:'+localDropIndex+'">' +
                            '<h3 style="font-size: 20px;text-align: center;padding-top: 11px;">'+name+' Adicionado</h3>' +
                        '</div>';

        $("#listAddDropContainer").append(htmlDrop);
        $("#listAddDropContainer").slideDown();
    } else {
        qtdEnviado++;
        var htmlDrop = '<div id="listAddDrop'+localDropIndex+'" class="" style="display:none;position:fixed;width:100%;border-bottom: 1px solid #dfdfdf;height:47px;margin-top:3px;z-index:'+localDropIndex+'">' +
                            '<h3 style="font-size: 20px;text-align: center;padding-top: 11px;">'+name+' Adicionado</h3>' +
                        '</div>';

        $("#listAddDropContainer").append(htmlDrop);
        $("#listAddDropContainer").slideDown();
    }
    $.listAddDropSlideUp(localDropIndex);
}

jQuery.listAddDropSlideUp = function(index){
    setTimeout(function(){
        qtdEnviado--;
        if(qtdEnviado == 0){
             $("#listAddDropContainer").slideUp(function(){
                $("#listAddDrop"+index).hide();
             });

        } else {
            $("#listAddDrop"+index).slideUp();
        }
    },1500);
}
*/

jQuery.listAddInitialFriendsCallback = function(json){
  //setTimeout(function(){
    $(".loading-general").remove();
    initialFriends = json;

    var htmlList = "";
    var selfName = uName;
    if(selfName.length > 25){
        selfName = selfName.substr(0,25)+"...";
    }
    var selfUserName = "@"+uUserName;
    if(selfUserName.length > 25){
        selfUserName = selfUserName.substr(0,25)+"...";
    }

    if(!actualList.included && uUserId){
        avatarSelf = uAvatar;
        if(theme == "dark") avatarSelf = "img/avatar-black.jpg";
        htmlList +=
            '<div class="people-timeline" tfunc="$.listAddFriend(self, '+uUserId+', \''+uUserName.replace(/'/g, "\\'")+'\', \''+uName.replace(/'/g, "\\'")+'\', '+ (uPhone?true:false) +');">' +
                '<div class="img-box circle"><img src="'+avatarSelf+'" class="circle" onload="$(this).show();"></div>' +
                '<div class="vertical-text">' +
                    '<div><div class="strong" style="margin-top:-2px;">'+selfName+'</div>'+
                    '<div class="left small" style="margin-top:-1px;">'+selfUserName+'</div></div>' +
                '</div>' +
                '<hr />' +
            '</div>';
    }

    suggestionsLoop:
    for(index in json.suggestions){
        if(json.suggestions[index].id == null){
          for(j in actualList.my_subscribers){
            if(actualList.my_subscribers[j].user_id == null){
              if(actualList.my_subscribers[j].name == json.suggestions[index].value2){
                continue suggestionsLoop;
              }
            }
          }
        }

        var avatar = "./img/avatar.jpg";
        if (theme == "dark") avatar = "./img/avatar-black.jpg";

        if(json.suggestions[index].avatar) avatar = json.suggestions[index].avatar;

        if(json.suggestions[index].inList){
            var addedClass = "added";
            var value = "Adicionado na lista";
        } else {
            var addedClass = "";
            var value = (json.suggestions[index].id==null?"":"@")+json.suggestions[index].value;
        }

        if(value.length > 25){
            value = value.substr(0,25)+"...";
        }

        var value2 = json.suggestions[index].value2;
        if(value2.length > 25){
            value2 = value2.substr(0,25)+"...";
        }

        htmlList +=
            '<div class="people-timeline '+addedClass+'" tfunc="$.listAddFriend(self, '+json.suggestions[index].id+', \''+json.suggestions[index].value+'\', \''+json.suggestions[index].value2+"', "+json.suggestions[index].hasphone+');">' +
                '<div class="img-box circle"><img src="'+avatar+'" class="circle" onload="$(this).show();"></div>' +
                '<div class="vertical-text">' +
                    '<div><div class="strong" style="margin-top:-2px;">'+value2+'</div>'+
                    '<div class="left small" style="margin-top:-1px;">'+value+'</div></div>'+
                    //'<p><strong>'+value2+'</strong><br /><small class="left">'+value+'</small></p>' +
                '</div>' +
                '<hr />' +
            '</div>';
    }

    if(htmlList == ""){
        $.post("./js/components/nofriends.html", function(data) {
            $("#containerAddFriend").html(data);
        });
    } else {
        $("#containerAddFriend").html(htmlList);
        $.dhoneStartCTEvents("#containerAddFriend");
    }

  //}, 2000);
}

var initialFriends = null;
jQuery.listAddInitialFriends = function(){
    if(uUserId){
        if(initialFriends){
            $.listAddInitialFriendsCallback(initialFriends);
        } else {
            $.server("getsuggestion?id="+clientId+"&user_id="+uUserId+"&list_id="+actualList.id+"&version=3.1", $.listAddInitialFriendsCallback, "modal");
        }
    } else {
        $(".loading-general").remove();
        htmlNoLogin =   '<div class="content scrollable no-connection-display">' +
                            '<div class="error error-connection">' +
                                '<i class="mdi mdi-account-multiple-plus icon-error" style="margin-bottom: -25px !important; margin-top: -50px !important;"></i>'+
                                '<h2>Adicione nomes acima</h2>' +
                                '<p>Ou crie conta para adicionar mais rápido.</p>' +
                                    '<div class="col-6"><button type="button" style="width:100%;" class="btn" tfunc="requireLogin=true;$.modalShow(\'login\');"><i class="mdi mdi-login"></i>Entrar</button></div>' +
                                    '<div class="col-6"><button type="button" style="width:100%;" class="btn confirm" tfunc="requireLogin=true;$.modalShow(\'createuser\');"><i class="mdi mdi-account"></i>Criar conta</button></div>' +
                            '</div>' +
                        '</div>';

        $("#containerAddFriend").html(htmlNoLogin);
        $.dhoneStartCTEvents("#containerAddFriend");
    }

}
