jQuery.eventInsideParticipantsStart = function(){
	$.eventInsideParticipantsUpdate();

	$('#eventInsideParticipantsContent').pullToRefresh({
        callback: function () {
            $('#eventInsideParticipantsContent').hide();
            $("#participantLoader").show();


            var deferred = $.Deferred();
            $.when($.server("getParticipants/"+clientId+"?device="+$.deviceId()+"&user_id="+uUserId+"&event_id="+actualEvent.event_id, $.eventParticipantLoad , "modal")).then(function() {
                deferred.resolve();
            });

            return deferred.promise();
        }
        ,hasTab:"search"
    });

    $("#eventParticipantLabelQtd").html("("+actualEventReport.participants[0].checkins+"/"+actualEventReport.participants[0].inscritos+")");

	searchInput = "#menuFindProduct";
    $(searchInput).bind("change keyup paste cut", function() {
    	if(actualTypedTimeout) clearTimeout(actualTypedTimeout);
        //$("#containerAddFriendSuggestion").hide();
        var self = this;
        var inputValue = $(self).val();
        if(inputValue){
            $("#btnClearProductParticipant").show();
        } else {
            $("#btnClearProductParticipant").hide();
        }

        actualTypedTimeout = setTimeout(function(){
            
            // if((uEditParticipant || actualList.isManager) && (inputValue.indexOf(",") >= 0 || inputValue.indexOf(".") >= 0 || inputValue.indexOf("\n") >= 0)){
            //     inputValue = inputValue.replace(/,|;|\r\n|\n/g, ",");
            //     starr = inputValue.split(",");
            //     inputValue = starr.length + " nomes";
            // }
            if (inputValue == participantLastSearch){
                // mesma consulta, não realizar
            } else {
                participantLastSearch = inputValue;
                $.eventInsideParticipantsUpdate(inputValue);    
            }
        }, 700);
       //alert($(this).val());
    });
}

var participantLastSearch = "";
var actualTypedTimeout = null;

jQuery.eventInsideParticipantsUpdate = function(search){
	if(!search) search = "";
    $("#eventInsideParticipantsContent").hide();
    $("#participantLoader").show();
	$.server("getParticipants/"+clientId+"?device="+$.deviceId()+
				"&user_id="+uUserId+
				"&event_id="+actualEvent.event_id+
				"&search="+search
			, $.eventParticipantLoad , "modal");
}

var participantsPermission = "none";
jQuery.eventParticipantLoad = function(json){
    participantsPermission = json.permission;
	participanthtml = "";

	participants = json.participants;

	$("#eventParticipantLabelQtd").html("("+json.qtd_checkin+"/"+json.qtd_participants+")");

	for(index in participants){
		participanthtml += 
		'<div class="people-timeline check-in-box">\
            <div class="vertical-text" style="">\
                <p>\
                    <strong tfunc="$.participantCheckinClick('+participants[index].id+');">'+participants[index].name+'</strong><br>\
                    <small  tfunc="$.participantCheckinClick('+participants[index].id+');" class="left">'+participants[index].origin+'</small>\
                </p>\
                <button id="checkin'+participants[index].id+'" ref="'+participants[index].id+'" tfunc="$.participantCheckin($(self).attr(\'ref\'), $(self).hasClass(\'white\'));" type="button" class="'+(participants[index].checkin ? 'confirm' : 'white')+' btn-square with-hr '+((participantsPermission == "edit" || (participantsPermission == "checkin" && !participants[index].checkin)) ? "" : "disabled\" disabled=\"disabled")+'" style="left:0px;">\
                    <img src="'+$.getLoader()+'" style="display:none;" />\
                    <i class="mdi mdi-check" style="'+(participants[index].checkin ? '' : 'display:none;')+'"></i>\
                </button>\
                <button tfunc="$.participantGetInfo('+participants[index].id+');" type="button" class="more-info">\
                    <i class="mdi mdi-eye"></i>\
                </button>\
            </div>\
            <hr>\
        </div>';
	}

	$("#eventInsideParticipantsList").html(participanthtml);
	$.dhoneStartCTEvents($("#eventInsideParticipantsList"));

    $("#participantLoader").hide();
	$("#eventInsideParticipantsContent").fadeIn();

}

jQuery.participantCheckinClick = function(participant_id){
    $.participantCheckin(participant_id, $("#checkin"+participant_id).hasClass('white'));
}

jQuery.participantCheckin = function(participant_id, checkin){
    checkinBtn = $("#checkin"+participant_id);
    if(!checkinBtn.attr("disabled") && !checkinBtn.hasClass("disabled")) {
        checkinBtn.removeClass("white");
        checkinBtn.removeClass("confirm");
        checkinBtn.find("i").hide();
        checkinBtn.find("img").show();
        checkinBtn.attr("disabled", "disabled");
    	if(participantsPermission == "edit" || participantsPermission == "checkin"){
    		$.server("checkin/"+clientId+"?device="+$.deviceId()+"&participant_id="+participant_id+"&checkin="+checkin+"&user_id="+uUserId+"&event_id="+actualEvent.event_id, $.participantCheckin2 , "modal");
    	}
    }
}

jQuery.participantCheckin2 = function(json){
	checkin = $("#checkin"+json.id);
    checkin.find("img").hide();
	if(json.checkin){
		checkin.addClass("confirm");
		checkin.removeClass("white");
		checkin.find("i").show();
        if(participantsPermission != "edit"){
            checkin.attr("disabled", true);
            checkin.addClass("disabled");
        }
	} else {
		checkin.removeClass("confirm");
		checkin.addClass("white");
		checkin.find("i").hide();
        if(json.msg){
            $.showMsg("Alerta", json.msg);
        }
	}
	$("#eventParticipantLabelQtd").html("("+json.qtd_checkins+"/"+json.qtd_participants+")");
    $("#event_participant_checkin_qtd").html(json.qtd_checkins);

    checkin.removeAttr("disabled");
}

jQuery.participantGetInfo = function(participant_id){
    $.modalShow("infoparticipant");

    $.server("getParticipantInfo/"+clientId+"?device="+$.deviceId()+"&user_id="+uUserId+"&participant_id="+participant_id, function(json){
        avatar = "./img/avatar.jpg";
        if(json.avatar) avatar = json.avatar;

        $("#participantAvatar").attr("src", avatar);
        $("#participantAddBy").html(json.add_by_name);
        $("#participantCreateAt").html(json.create_at);
        if(json.checkin_hour){
            $("#participantCheckinHour").html(json.checkin_hour);
            $("#participantCheckinHour").parent().show();
        }
        if(json.obs){
            $("#participantObs").html(json.obs);
            $("#participantObs").parent().show();
        }
        

        $("#infoParticipantLoader").hide();
        $("#participantModalContainer").fadeIn();
    } , "modal");
}