jQuery.eventInsideRelStart = function(){
	$("#eventInsideRelTitle").html("Relatórios | " + actualEvent.event_title);
	$("#eventInsideRelTitle").dotdotdot({watch: true, wrap: 'letter'});
	$.server("rel_event_seller/"+actualEvent.event_id+"?user="+uUserId, $.loadEventInsideRel, true);
}

jQuery.eventInsideRelUpdate = function(){}

jQuery.loadEventInsideRel = function(json){
    html = '<div class="panel">\
    		  <div id="" class="box-container">\
                <div class="inner-box box-header">\
                    <strong>Inscritos: </strong><strong id="" class="client-color">'+json.total_subscribers+'</strong><br>\
                    <strong>Pagantes: </strong><strong id="" class="client-color">'+json.total_payers+'</strong><br>\
                    <strong>Check-ins: </strong><strong id="" class="client-color">'+json.total_checkins+'</strong><br>\
                    <strong>Receita: </strong><strong id="" class="client-color">'+json.total_value+'</strong>\
                </div>'
              

    lp = json.seller
    if(lp) {
        for(i in lp){
            html+= '<div class="inner-box">\
                        <strong>'+lp[i].name+' <small>('+lp[i].value+')</small></strong><br>\
                        Inscritos: '+lp[i].subscribers+'<br>\
                        Pagantes: '+lp[i].payers+'<br>\
                        Check-ins: '+lp[i].checkins+'<br>\
                        <strong>Receita: </strong><strong class="client-color">'+lp[i].total_value+'</strong>\
                    </div>';
        }
    }

    html += '</div>\
          </div>';
    
    $("#eventInsideRelSellerContainer").html(html);
}

jQuery.eventInsidePromoterStart = function(){
	$.server("rel_event_promoter/"+actualEvent.event_id+"?user="+uUserId, $.loadEventInsidePromoter, true);
}

jQuery.loadEventInsidePromoter = function(json){
	console.log(json);

	html = '<div class="panel">\
			  <select onchange="$.eventInsidePromoterFilter($(this).val());">\
    		  	<option value="">Todos</option>';
   	for(i in json.promoters){
   		html +='<option value="'+json.promoters[i].id+'">'+json.promoters[i].name+'</option>';
   	}
    html +=	 '</select>\
              <div id="" class="box-container">\
                <div class="inner-box box-header promoter">\
                    <strong>Comissão total: </strong><strong id="" class="client-color">'+json.total_comission+'</strong>\
                </div>';
    
    promoter = json.promoters;
    for(i in promoter){
    	list = promoter[i].lists;
        html+= '<div class="inner-box promoter" id="promoter'+promoter[i].id+'">\
                    <strong>'+promoter[i].name+'</strong><br>';
        for(j in list){
        	html += list[j].list_name + ": " + list[j].checkins + "/" + list[j].subscribers + "<small> (%"+Math.round((list[j].checkins * 100 / list[j].subscribers)||0)+")</small><br>";
        }
        html +=    'Total: ' + promoter[i].total_checkins + '/' + promoter[i].total_subscribers + '<small> (%'+Math.round((promoter[i].total_checkins * 100 / promoter[i].total_subscribers)||0)+')</small><br>\
                    <strong>Comissão: </strong><strong class="client-color">'+promoter[i].total_comission+'</strong>\
                </div>';
    }

    html += '</div>\
          </div>';
    
    $("#eventInsideRelPromoterContainer").html(html);
}

jQuery.eventInsidePromoterFilter = function(promoter_id){
	console.log(promoter_id);
	if (promoter_id) {
		$(".promoter").hide();
		$("#promoter"+promoter_id).show();
	} else {
		$(".promoter").show();
	}
}

var eventInsideRelLoaded = [true,false];
jQuery.eventInsideRelSellectTab = function(tab){
    var actualTab = $("#eventInsideRelTabs").attr("ref");
    if(parseInt(actualTab)!=tab){
        $("#eventInsideRelTab"+actualTab).find("a").removeClass("client-color");
        $("#eventInsideRelTab"+actualTab).removeClass("active");
        $("#eventInsideRelTab").animate({marginLeft:((tab*50)+"%")},300,function(){
            $("#eventInsideRelTabs").attr("ref", tab);
            $("#eventInsideRelTab"+tab).find("a").addClass("client-color");
            $("#eventInsideRelTab"+tab).addClass("active");
        });

        if(tab == 1){
            $("#eventInsideRelSeller").fadeOut(function(){
                if(eventInsideRelLoaded[tab]) $("#eventInsideRelPromoter").fadeIn();
            });

            if(!eventInsideRelLoaded[tab]){
                eventInsideRelLoaded[tab] = true;
                $.eventInsidePromoterStart();
            }
        }
        if(tab == 0){
            $("#eventInsideRelPromoter").fadeOut(function(){
                $("#eventInsideRelSeller").fadeIn();
            });
        }
    }
}