var actualPage;
var actualEvent;
var avatarSetted = false;

jQuery.eventInsideStart = function() {
    actualPage = "eventInside";

    var hash = window.location.hash;
    hash = hash.split("#");
    hash.splice(0, 4);
    if(hash[0].substr(0,1) == "a"){
        var index = parseInt(hash[0].substring(1));
        actualEvent = ADS_JSON[index];
    } else {
        actualEvent = AGENDA_JSON[hash[0]];
    }

    //pré carregamento das informações básicas do evento
    $("#eventInsideCoverPageImg").parent().css('background-color','initial');
    $("#eventInsideCoverPageImg").attr("src", actualEvent.avatar);
    avatarSetted = true;
    $("#eventInsideTitle").html(actualEvent.event_title);
    $(".header-title").dotdotdot({watch: true, wrap: 'letter'});
    $("#eventInsideTitleFull").html(actualEvent.event_title);
    $("#eventInsideHoraI").html($.convertHour(actualEvent.starting_hour));
    if(actualEvent.finishing_hour){
        $("#eventInsideHoraF").html($.convertHour(actualEvent.finishing_hour));
        $("#eventInsideHoraF").parent().show();
    } else {
        $("#eventInsideHoraF").parent().hide();
    }
    $("#eventInsideDate").html(actualEvent.event_date);
    // **FIM informações básicas

    $.server("getEvent?point_of_sale=app&event_id="+actualEvent.event_id+(uUserId ? "&user_id="+uUserId : ""),$.eventInsideStart2,false);
}

//eventos vindo das notificações, não carrega 
jQuery.notificationEventInsideStart = function(){
    actualPage = 'notificationEventInside';
    //$.eventInsideStart2();

    var hash = window.location.hash;
    hash = hash.split("#");
    hash.splice(0, 4);

    $.server("getEvent?point_of_sale=app&event_id="+hash[0]+(uUserId ? "&user_id="+uUserId : ""),$.eventInsideStart2,false);
}

jQuery.eventInsideStart2 = function(json){
    actualEvent = json;

    var coverpageSize = $.getCoverDefaulSize();

    $.eventInsideUpdateInfos();
    $("#nameForList1").dhonePlaceHolder("Nome");
    $("#emailParaLista").dhonePlaceHolder("E-mail");
    $("#nameForList1").keyup(function() {
        $(this).val($(this).val().replace(new RegExp(/[0-9]/g), ''));
    });

    $.eventInsideAccess();

    $.startHeaderFade("client-bg", "anchor");

    $('#eventinsideSection').fadeIn();
}


jQuery.eventInsideAccess = function() {
    var deviceId;
    if(dhoneDevice == "browser"){
        deviceId = "BROWSERTEST";
    } else {
        deviceId = $.deviceId();
        $.server( "eventaccess?client="+clientId+"&device="+deviceId+"&event="+actualEvent.event_id , function(json){}, false);
        //$.post( serverURL+"eventaccess", { client: clientId, device: deviceId, event: eventId } );//  <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<AUDITORIA EVENTO
    }
}

jQuery.eventInsideReadMore = function(){
    $("#eventInsideDescricao").trigger("destroy");
    $('#eventInsideDescricao').css('height','initial');
    $(".readmore").hide();
}

var tLink;
var tEmbeded;
//preenche a página com as informações do JSON
jQuery.eventInsideUpdateInfos = function() {
    var eventId = actualEvent.event_id;
    tLink = actualEvent.ticket_link;
    tEmbeded = actualEvent.ticket_embed;

    //---***<<<DADOS BASICOS>>>***---
    $.eventInsideBasicData();

    //--**<<ORGANIZADORES>>**--
    $.eventInsideOrganizers();

    //***************LIKES*************************
    if (!cLikes) {
        $("#eventInsideLikesContainer").hide();
    } else {
        $.renderLikeContainer(actualEvent);
        $("#eventInsideLikesContainer").show();
    }
    
    //***************LOCATION**********************
    $.eventInsideLocation();

    //**************SOUNDCLOUD**********************
    if(actualEvent.soundcloud){

        $("#eventInsideSoundCloud").find(".avatar").attr('src',actualEvent.avatar);
        $("#eventInsideSoundCloud").show();

        jQuery.showSoundCloud = function(){
            var soundcloudhtml = '<iframe style="margin-bottom:15px;" width="100%" height="97" scrolling="no" frameborder="no" src="https://w.soundcloud.com/player/?url=https%3A//api.soundcloud.com/tracks/'+actualEvent.soundcloud+'&amp;auto_play=true&amp;hide_related=true&amp;liking=false&amp;show_comments=false&amp;show_user=false&amp;show_reposts=false&amp;visual=false&amp;show_artwork=false&amp;download=false&amp;color='+clientColor+'&amp;font=Dosis-Light"></iframe>';

            $("#eventInsideSoundCloud").removeClass();
            $("#eventInsideSoundCloud").html(soundcloudhtml);
        }
    }

    //---***<<< GALERIA >>>***---
    $.eventInsideGallery();
    
    var qtdButtons = 0; //Utilizado para ajustar botoes inferiores
    // ------******<<<<<< INGRESSOS >>>>>*****-----
    qtdButtons = $.eventInsideTickets(qtdButtons);

    // ------******<<<<<< LISTAS >>>>>*****-----
    qtdButtons = $.eventInsideListsInit(qtdButtons);

    //AJUSTES DOS BOTõES INFERIORES
    if(qtdButtons > 0){
        $("#eventInsideTable").remove(); //ainda não implementado


        var buttonClass = "col-6";
        if(qtdButtons == 1) buttonClass = "col-12";

        $("#eventInsideLists").addClass(buttonClass);
        $("#eventInsideTicket").addClass(buttonClass);

        if($("#eventInsideTicket").length == 0){
            $("#eventInsideLists").addClass("last");
        }
        $("#eventinsideBottomHack").show();
    } else {
        $("#eventInsideButtons").remove();
        $("#eventinsideBottomHack").hide();
    }

    if(actualEvent.isOld){
        $("#eventInsideButtons").hide();
    }

    $.eventInsideMoreInit();

    //ESPERA PARA APARECER OS DADOS. Evita que a animação ocorra durante o slide da página
    setTimeout(function(){
        if(actualEvent.location) $("#eventInsideLocationContainer").show();//fadeIn(fadeTime);
        $("#eventInsideLoad").remove();
        $("#eventInsideInfo").show();
            $("#eventInsideButtons").animate({bottom:0},fadeTime,function(){
                $.eventInsideMoreFix();
                if(actualEvent.avatarFull){
                  $("#eventInsideCoverPageImg").dhoneBind(function(){
                    $("body").dGallery([actualEvent.avatarFull], 1);
                  });
                }
            });
        //});
        setTimeout(function(){
            $('#eventInsideCoverPage').fadeIn(fadeTime);
            $("#eventInsideCoverPage").css("background-image", "url('"+actualEvent.avatar+"')");
            $("#eventInsideCoverPage").css("-webkit-filter", "blur(20px)");
            $("#eventInsideCoverPage").css("filter", "blur(20px)");
        },fadeTime*2);
    },420);
}

jQuery.eventInsideBasicData = function(){
    if(!avatarSetted){
        $("#eventInsideCoverPageImg").parent().css('background-color','initial');
        $("#eventInsideCoverPageImg").attr("src", actualEvent.avatar);
    }

    if(actualEvent.reports.participant_type){
        $("#eventInsideUserType").text(actualEvent.reports.participant_type);
        $("#eventInsideCoverContainer").css("padding-bottom", "35px");
        $(".cover-footer").fadeIn(fadeTime);
    }

    if(actualEvent.reports.promoter_info){
        $("#eventPromoterInfo").show();

        $("#eventInsidePromoterSubscriber").text(actualEvent.reports.promoter_info.total_subscribers);
        $("#eventInsidePromoterPayers").text(actualEvent.reports.promoter_info.total_payers);
        $("#eventInsidePromoterChekins").text(actualEvent.reports.promoter_info.total_checkins);
        $("#eventInsidePromoterTotalComissions").text(actualEvent.reports.promoter_info.total_value);

        lp = actualEvent.reports.promoter_info.lists
        if(lp) {
            for(i in lp){
                html = '<div class="inner-box">\
                            <strong>'+lp[i].list_name+' <small>('+lp[i].list_value+')</small></strong><br>\
                            Inscritos: '+lp[i].subscribers+'<br>\
                            Pagantes: '+lp[i].payers+'<br>\
                            Check-ins: '+lp[i].checkins+'<br>\
                            Comissão por pagante: '+lp[i].comissionSale+'<br>\
                            <strong>Comissão: </strong><strong class="client-color">'+lp[i].comissionTotal+'</strong>\
                        </div>';
                $("#eventInsidePromoterInfoBox").append(html);
            }
        }
    }

    $("#eventInsideTitle").html(actualEvent.event_title);
    $(".header-title").dotdotdot({watch: true, wrap: 'letter'});
    $("#eventInsideTitleFull").html(actualEvent.event_title);
    $("#eventInsideHoraI").html($.convertHour(actualEvent.starting_hour));
    if(actualEvent.finishing_hour){
        $("#eventInsideHoraF").html($.convertHour(actualEvent.finishing_hour));
        $("#eventInsideHoraF").parent().show();
    } else {
        $("#eventInsideHoraF").parent().hide();
    }

    if ($.trim(actualEvent.event_description) != "") {
        $("#eventInsideDescricao").show();
        $("#eventInsideDescricao").html($.dhoneLinkify($.formatText(actualEvent.event_description)));
    }else {
        //$("#eventInsideDescriptionContainer").hide();
        $("#eventInsideDescricao").hide();
        $("#eventInsideDescricao").html("");
    }

    $("#eventInsideDate").html(actualEvent.event_date);

    $(".dotdotdot-more").dotdotdot({watch: true, wrap: 'letter', ellipsis: '... ', after: 'a.readmore'});
}

jQuery.eventInsideOrganizers = function(){
    if (actualEvent.organizers && actualEvent.organizers.length > 0) {
        var organizerNames = "";

        for(var i = 0; i<actualEvent.organizers.length; i++) {
            organizerNames += actualEvent.organizers[i].name;
            if (i == actualEvent.organizers.length-2) organizerNames += " e ";
            else if (i != actualEvent.organizers.length-1) organizerNames += ", ";
        }

        $("#eventInsideOrganizadores").show();
        $("#eventInsideOrganizadores").html("<strong>Organizadores:</strong> "+organizerNames);
    } else {
        $("#eventInsideOrganizadores").hide();
        $("#eventInsideOrganizadores").html("");
    }

    if ($.trim(agendaType) == "") {
        if (!actualEvent.list_id || ( (parseInt(actualEvent.entries_qtd) >= parseInt(actualEvent.entries_limit)) && parseInt(actualEvent.entries_limit) > 0 ) ) {
            $("#addListNameContainer").hide();
        }else {
            $("#listaId").val(actualEvent.list_id);
            $("#addListNameContainer").show();
            $("#eventInsideListTitle").html(actualEvent.list_title);
            $("#eventInsideListDescription").html($.formatText(actualEvent.list_description));
        }
    }else {
        $("#addListNameContainer").hide();
    }
}

jQuery.eventInsideLocation = function(){
    if(actualEvent.location){

        if (actualEvent.location.avatar) {
            $("#eventInsideLocationAvatar").attr("src", actualEvent.location.avatar);
        } else {
            if(theme=="dark"){
                $("#eventInsideLocationAvatar").attr("src", "img/avatar-location-black.jpg");
            } else {
                $("#eventInsideLocationAvatar").attr("src", "img/avatar-location.jpg");
            }
        }

        $("#eventInsideLocationName")   .text(actualEvent.location.name);
        $("#eventInsideLocationAddress").text(actualEvent.location.address);
        $("#eventInsideLocationPhone")  .html($.dhoneLinkify(actualEvent.location.phone));

        //$("#eventInsideLocationContainer").show();
    }
}

jQuery.eventInsideGallery = function(){
    $("#eventInsideGalery").html("");

    var maxPhotos = 5;
    if(actualEvent.photos.length == 6){
        maxPhotos = 6;
    }

    var imagesGallery = [];
    var imagesGalleryThumb = [];
    var imagesGalleryId = [];
    for (i in actualEvent.photos) {
        if(i >= maxPhotos) break;
        //imagesGallery.push(serverURL+clientFolder+'/img/agenda/gallery/'+actualEvent.photos[i]);
        if(actualEvent.photos[i] != null){
            if(actualEvent.photos_gallery){
                imagesGallery.push(actualEvent.photos_gallery[i]);
            } else {
                imagesGallery.push(actualEvent.photos[i]);
            }
            imagesGalleryThumb.push(actualEvent.photos[i]);

            imagesGalleryId.push(actualEvent.photoId[i]);
        }
    }

    if (actualEvent.photos.length > 0) {
        $("#galleryLabel").show();
    }else {
        $("#galleryLabel").hide();

    }

    //CODIGO DE CORREÇÕES do tamanho da galeria
    var screenWidth = $.getWindowSize()['w'];
    var gallerySizeX = (screenWidth-25)/3;
    var gallerySizeY = gallerySizeX - 15;

    $("#eventInsideGalery").html();
    for (i in imagesGallery) {

        var tag = '<span class="col-4 mb-20 thumb-gallery-correction" ref="'+i+'">'+
                        '<div class="img-box radius" style="height:'+gallerySizeY+'px;">'+
                            '<img class="full radius img-nobox" onload="$(this).fadeIn(fadeTime);" src="'+imagesGalleryThumb[i]+'" style="width:100%;height:100%;" />'+
                        ' </div>'+
                    '</span>';
        var imgGallery = $(tag);

        imgGallery.dhoneBind(function(obj){
            var start = parseInt($(obj).attr("ref"));
            actualPhotoId = imagesGalleryId[start];
            actualPhotoUrl = imagesGallery[start];
            actualPhotoPosition = start;
            $.dhoneNavigate("#photoDetail#slide#go");
            //$("body").dGallery(imagesGallery, start);
        });
        //setTimeout(function(){
            $("#eventInsideGalery").append(imgGallery);
            $("#eventInsideGaleryTitle").show();
        //}, 400);
    }

    if(actualEvent.photos.length > 6){
        var tag =   '<span class="col-4 mb-15 thumb-gallery-correction">'
                   +    '<div class="img-box radius" style="height:'+gallerySizeY+'px;">'
                   +        '<div class="mask-more-photo"><span>+'+(actualEvent.photos.length - 6)+'</span></div>'
                   +        '<img class="full radius img-nobox" onload="$(this).fadeIn(fadeTime);" src="'+actualEvent.photos[7]+'" style="width:100%;height:100%;">'
                   +    '</div>'
                   +'</span>'
        var imgGallery = $(tag);

        imgGallery.dhoneBind(function(obj){
            $.dhoneNavigate("#album#slide#go");
        });
            $("#eventInsideGalery").append(imgGallery);
    }
}

jQuery.eventInsideTickets = function(qtdButtons){
    var hasTicket = false; var hasList = false;
    if(cIngresso){
        $("#eventInsideTicket").dhoneBind(function(){
            $.eventInsideTicket();
        });

        if((tLink || actualEvent.tickets.length > 0) && !actualEvent.isOld){
            $("#eventInsideTicket").removeClass("disable");
            qtdButtons++; hasTicket = true;

        } else {
            //$("#eventInsideTicket").addClass("disable");
            $("#eventInsideTicket").remove();
        }

        actualEventReport = actualEvent.reports;
        var ticketsHtml = "";
        var qtdTotal = 0;
        var valTotal = 0;

        if (actualEventReport["tickets"].length > 0) {
          //$("#ticketsDisplay").show();
          $("#eventInsideMyTicketsAdmin").show();
          for (t in actualEventReport["tickets"]) {
            ticketsHtml += actualEventReport["tickets"][t]["name"]+": "+actualEventReport["tickets"][t]["qtdSold"] + "<br>";
            qtdTotal += parseInt(actualEventReport["tickets"][t]["qtdSold"]);
            valTotal += parseFloat(actualEventReport["tickets"][t]["totalValue"]);
          }

          ticketsHtml = ticketsHtml.substr(0, ticketsHtml.length-4);
          $("#ticketsQtds").html(ticketsHtml);
          $("#totalTicketMoney").html("R$ "+$.MaskMonetarioSemRS(String(valTotal)));
          $("#totalSoldTickets").html(qtdTotal);

          $("#eventRel").show();
        } else {
            $("#totalTicketMoney").html("R$ 0,00");
            $("#totalSoldTickets").html("0");
        }

        if (actualEventReport["participants"].length > 0) {
            $.eventInsideParticipantsInit(actualEventReport);

            $("#event_participant_inscribed_qtd").html(actualEventReport["participants"][0]["inscritos"]);
            $("#event_participant_checkin_qtd").html(actualEventReport["participants"][0]["checkins"]);

            if(actualEventReport["participants_permission"] == "edit" || actualEventReport["participants_permission"] == "view" || actualEventReport["participants_permission"] == "checkin"){
                $("#eventInsideParticipantsBtn").show();
            }

            //$("#event_participant_qtds").show();
            $("#eventRel").show();
        } else {
            $("#event_participant_inscribed_qtd").html("0");
            $("#event_participant_checkin_qtd").html("0");
        }
    } else {
        $("#eventInsideTicket").remove();
    }

    return qtdButtons;
}

jQuery.eventInsideListsInit = function(qtdButtons){
    if(cListas){
        var eventLists = actualEvent.lists;

        if(eventLists.length > 0){
            actualListId = eventLists[0].id;
            $.loadEventList(eventLists[0]);

            $("#eventInsideLists").removeClass("disable");

            if(eventLists.length > 1){
                var stListBase = '<button type="button" ref="&&ref" class="btn-action touch" tfunc="var selected=$(self).attr(\'ref\');$.modalHide(function(){$.eventInsideListAddFriend(selected);});">&&name <i class="mdi mdi-chevron-right right"></i></button>';

                $("#eventInsideLists").dhoneBind(function(){
                    var htmlListButtons = "";
                    for(var theList in actualEvent.lists){
                        //if(actualEvent.lists[theList].isPrivate != 1){ ###################isPrivate não é enviado ################
                        if(actualEvent.lists[theList].can_add){
                            htmlListButtons += stListBase.replace("&&listId",theList).replace("&&name",actualEvent.lists[theList].name).replace("&&ref",theList);
                        }
                    }
                    if(htmlListButtons == ""){
                        $.showMsg("Alerta", "Não existem listas disponíveis para adicionar nomes.");
                    } else {
                        $.eventOpenListOfLists(htmlListButtons);
                    }
                });
            } else {
                $("#eventInsideLists").dhoneBind(function(){
                    $.eventInsideListAddFriend();
                });
            }
            
            if(actualEvent.time_type == "old"){
                $("#eventInsideLists").remove();
            } else {
                qtdButtons++; hasList = true;
            }
        } else {
            $("#eventInsideLists").remove();
        }
    } else {
        $("#eventInsideLists").remove();
    }

    return qtdButtons;
}

//AJUSTE DE VER MAIS DA DESCRIÇAO
jQuery.eventInsideMoreFix = function() {
    var isTruncated = $("#eventInsideDescricao").triggerHandler("isTruncated");
    if ( !isTruncated ) {
        $("#eventInsideDescricao").trigger("destroy");
        $('#eventInsideDescricao').css('height','initial');
        $(".readmore").hide();
    }
}

//AJUSTE INICIAL PARA VER MAIS DA DESCRIÇAO
jQuery.eventInsideMoreInit = function() {
    if(actualEvent.event_description.length > 200) {
        $("#eventInsideDescricao").dotdotdot({watch: true, wrap: 'letter', ellipsis: '... ', after: 'a.readmore', 
            callback: function( isTruncated, orgContent ) {
                 if(!isTruncated){
                    // $("#eventInsideDescricao").trigger("destroy");
                    // $('#eventInsideDescricao').css('height','initial');
                    // $(".readmore").hide();
                }
            }
        });
    } else {
        $("#eventInsideDescricao").trigger("destroy");
        $('#eventInsideDescricao').css('height','initial');
        $(".readmore").hide();
    }
}

jQuery.eventInsideLists = function(listId){
    var hash = window.location.hash;

    hash = hash.split("#");
    hash.splice(0, 4);

    $.modalHide(function(){
        $.dhoneNavigate("#eventInsideList#slide#go#"+hash[0]+"#"+listId);
    });
}

jQuery.eventOpenListOfLists = function(htmlListButtons){
    $.modalShow("listselector", function(){
        $("#listNameList").html(htmlListButtons);
    });
}

jQuery.eventInsideTicket = function(){
    if(tLink){
        //window.open($.toUrl(tLink), '_system');
        $.openUrl($.toUrl(tLink));
    } else if(actualEvent.tickets.length > 0){
        $.dhoneNavigate("#tickets#slide#go");
    }

    // if(tLink){
    //     window.open($.toUrl(tLink), '_system');
    // } else if(tEmbeded){
    //     $.dhoneNavigate("#ticketEvent#slide#go#");
    // }
}

jQuery.likeEvent = function(thisButton){

    var liked = $(thisButton).hasClass("liked");

    if (uUserId) {
        $.server("like_event?event_id="+actualEvent.event_id+"&user_id="+uUserId+"&like="+(!liked), function(response){

            var qtdLikes = parseInt($("#eventInsideLikesContainer").find(".qtdLikes").text());

            $.renderLikeContainer({
                liked: response,
                likes: (response ? qtdLikes+1 : qtdLikes - 1)
            }, true);

        });
    } else {
        $.modalShow('requirelogin');
    }

}

jQuery.renderLikeContainer = function(likeObject, animate) {

    var likesContainer = $("#eventInsideLikesContainer");
    var right = likesContainer.find(".right");
    var left = likesContainer.find(".left");

    likesContainer.find(".qtdLikes").text(likeObject.likes);

    if (likeObject.likes == 0) {
        right.hide();
    } else {

        if (likeObject.likes == 1) {
            right.find(".label").text("curtida");
        } else {
            right.find(".label").text("curtidas");
        }

        right.show();
    }


    if (likeObject.liked) {
        if(animate){
            left.find(".mdi").css("transform", "scale(1.4)");
            left.find(".mdi").bind('transitionend otransitionend webkitTransitionEnd', function() { 
                left.find(".mdi").css("transform", "scale(1)");
            });
        }
        left.addClass("liked");
        left.find(".label").text("Descurtir");
    }
    else {
        if(animate){
            left.find(".mdi").css("transform", "scale(0.6)");
            left.find(".mdi").bind('transitionend otransitionend webkitTransitionEnd', function() { 
                left.find(".mdi").css("transform", "scale(1)");
            });
        }
        // setTimeout(function(){ left.find(".mdi").css("transform", "scale(1)"); }, 150);
        left.removeClass("liked");
        left.find(".label").text("Curtir");
    }

    likesContainer.show();
}


/******************************************* LIST METHODS ************************************************************/

var eventIsideListToUpdate = $.eventIsideListToUpdate; //qual a função a ser usada para atualizar

var listFirstAnimate = false;
var listFristAnimateId = null;
var listDalayAnimate = false;
var actualList , actualListId;
var eventInsideListStarted = false;

jQuery.eventInsideListUpdate = function() {
    var hash = window.location.hash;

    hash = hash.split("#");
    hash.splice(0, 4);

    actualList = actualEvent.lists[hash[1]].id; //****************************************************** RECUPERAR LISTAS AQUI <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    actualListId = actualList;
    //$("#listTitle").html(AGENDA_JSON[hash[0]].lists[hash[1]].name);
    if(!eventInsideListStarted) $("#listTitle").html((actualEvent.lists[hash[1]].name.length > maxTitleLength)?actualEvent.lists[hash[1]].name.substr(0,maxTitleLength)+"...":actualEvent.lists[hash[1]].name);
    $.loadEventList(actualEvent);
    //$.server("getlist/?client="+clientId+"&user_id="+(uUserId==null?"":uUserId)+"&list_id="+actualList, $.loadEventList, false);
    //$.server();
    eventInsideListStarted = true;
}

jQuery.eventIsideListToUpdate = function(){
    $.loadEventList(actualList);
}

jQuery.loadEventList = function(){
    $("#eventInsidePanelLists").html("");
    var listnumber = 0; actualListList = [];
    $("#listEventInside").html("");
    for(list in actualEvent.lists){
        $.loadEventList2(actualEvent.lists[list], listnumber++);
    }
}

var actualListList = [];
var listShow = false;
var listQtdPerson = 0;
jQuery.loadEventList2 = function(json, listnumber){
    listShow = false;
    //actualList = json;
    actualListList.push(actualList);

    var html = '<div class="title-box">\
                    <h3><i class="mdi mdi-content-paste client-color"></i> <span id="listName'+listnumber+'">Listas</span> <button class="btn small" style="display:none;">Detalhes</button></h3>\
                </div>\
            <div class="panel">\
                <p id="listIsPrivate'+listnumber+'" class="is-private"><i class="mdi mdi-lock"></i><strong>Lista privada</strong></p>\
                <div id="listEventInside'+listnumber+'" style="display:none;">\
                <div id="listIsPromoter'+listnumber+'" class="mb-15" style="display:none;"><small><strong>\
                    <i class="mdi mdi-account-star-variant important-color"></i>Você é um promoter nesta lista.\
                </strong></small></div>\
                <p id="listDescription'+listnumber+'" style="display:none;"></p>\
                <div id="listBoxOn'+listnumber+'" class="">\
                    <span id="listQtdCheckingP'+listnumber+'" class="litle-box mr-10"><strong>Check-ins: <span class="client-color" id="listQtdChecking'+listnumber+'"></span></strong></span>\
                    <span id="listQtdParticipantP'+listnumber+'" class="litle-box mr-10"><strong>Inscritos: <span class="client-color" id="listQtdParticipant'+listnumber+'"></span></strong></span>\
                    \
                    <span id="listEntranceValueP'+listnumber+'" class="litle-box mr-10"><strong>Valor da entrada: <span class="client-color" id="listEntranceValue'+listnumber+'"></span></strong></span>\
                    <span id="listMaxUserP'+listnumber+'" class="litle-box mr-10"><strong>Máx. de inscritos: <span class="client-color" id="listMaxUser'+listnumber+'"></span></strong></span>\
                    <span id="listMaxCheckinP'+listnumber+'" class="litle-box mr-10"><strong>Máx. de entradas: <span class="client-color" id="listMaxCheckin'+listnumber+'"></span> <span class="client-color">primeiras pessoas</span></strong></span>\
                    <span id="listDateAddP'+listnumber+'" class="litle-box mr-10"><strong>Hora limite de inscrição: <span class="client-color" id="listDateAdd'+listnumber+'"></span></strong></span>\
                    <span id="listDateCheckinP'+listnumber+'" class="litle-box mr-10"><strong>Hora limite de entrada: <span class="client-color" id="listDateCheckin'+listnumber+'"></span></strong></span>\
                </div>\
                <div class="clear"></div>\
                <button class="btn small mb-10 btn-block" id="listAddNameBtn'+listnumber+'" style="display:none;"><i class="mdi mdi-account-plus"></i>Adicionar nome</button>\
                <div class="clear mb-5"></div>\
                <div class="clear"></div>\
                <div id="listAdds'+listnumber+'" class="participants clear">\
                    <hr class="mt-10 left clear" />\
                    <h3>Você adicionou:</h3>\
                    <ul id="listAddeds'+listnumber+'">\
                    </ul>\
                    <a href="javascript:void(0);" tfunc="$.dhoneNavigate(\'#eventInsideList#slide#go#'+listnumber+'\');" class="btn small btn-detail-participant">Ver</a>\
                </div>\
                <div class="clear"></div>\
                <div id="listPromoters'+listnumber+'">\
                    <hr class="mt-10 left clear" />\
                    <h3>Promoters:</h3>\
                    <span id="listPromotersAvatar'+listnumber+'"></span>\
                    <a id="listPromotersDetails'+listnumber+'" href="javascript:void(0);" class="btn small btn-detail-participant">Ver</a>\
                </div>\
                </div>\
            </div>';

    $("#listEventInside").append(html);
    if(json.can_add && !actualEvent.isOld){
        $("#listAddNameBtn"+listnumber).show();
        $("#listAddNameBtn"+listnumber).dhoneBind(function(obj){
            $.eventInsideListAddFriend(listnumber);
        });
    } else {
        $("#listAddNameBtn"+listnumber).hide();
    }

    if(json.fullList){
        $("#eventInsideListNotification"+listnumber).show();
    }

    $("#listName"+listnumber).html(json.name);
    
    if (json.isPrivate) {
        $("#listIsPrivate"+listnumber).show();
    } else {
        $("#listIsPrivate"+listnumber).hide();
    }

    $("#listDescription"+listnumber).html($.formatText(json.description));
    if($.trim(json.description)) {
        $("#listDescription"+listnumber).show();
    }
    listShow = true;

    $("#listBoxOn"+listnumber).find("hr").remove();
    var boxOn = false;
    if(json.qtd_checkins){
        $("#listQtdChecking"+listnumber).html(json.qtd_checkins);
        $("#listQtdCheckingP"+listnumber).show();
        boxOn = true;
    } else {
        $("#listQtdCheckingP"+listnumber).hide();
    }

    if(json.qtd_participants){
        $("#listQtdParticipant"+listnumber).html(json.qtd_participants);
        $("#listQtdParticipantP"+listnumber).show();
        boxOn = true;
    } else {
        $("#listQtdParticipantP"+listnumber).hide();
    }

    if(json.price){
        $("#listEntranceValue"+listnumber).html(json.price);
        $("#listEntranceValueP"+listnumber).show();
        boxOn = true;
    } else {
        $("#listEntranceValueP"+listnumber).hide();
    }

    if(json.maxUsers){
        $("#listMaxUser"+listnumber).html(json.maxUsers);
        $("#listMaxUserP"+listnumber).show();
        if(boxOn){
            $("#listMaxUserP"+listnumber).before("");
        }
        boxOn = true;
    } else {
        $("#listMaxUserP"+listnumber).hide();
    }

    if(json.maxCheckin){
        $("#listMaxCheckin"+listnumber).html(json.maxCheckin);
        $("#listMaxCheckinP"+listnumber).show();
        if(boxOn){
            $("#listMaxCheckinP"+listnumber).before("");
        }
        boxOn = true;
    } else {
        $("#listMaxCheckinP"+listnumber).hide();
    }

    if(json.dateAdd){
        $("#listDateAdd"+listnumber).html(jQuery.dateTimeFormat(json.dateAdd));
        $("#listDateAddP"+listnumber).show();
        if(boxOn){
            $("#listDateAddP"+listnumber).before("");
        }
        boxOn = true;
    } else {
        $("#listDateAddP"+listnumber).hide();
    }

    if(json.dateCheckin){
        $("#listDateCheckin"+listnumber).html(jQuery.dateTimeFormat(json.dateCheckin));
        $("#listDateCheckinP"+listnumber).show();
        if(boxOn){
            $("#listDateCheckinP"+listnumber).before("");
        }
        boxOn = true;
    } else {
        $("#listDateCheckinP"+listnumber).hide();
    }

    if(boxOn){
        $("#listBoxOn"+listnumber).show();
        listShow = true;
    } else {
        $("#listBoxOn"+listnumber).hide();
    }

    if (json.promoters && json.promoters.length > 0) {
        var promoterAvatars = $("#listPromotersAvatar"+listnumber);
        totalPromoters = json.promoters.length;
        if (totalPromoters > 4) {
            maxPromoters = 3;
        } else {
            maxPromoters = totalPromoters;
        }
        for (var i = 0; i < maxPromoters; i++) {
            
            if (json.promoters[i].avatar){
                promoterAvatars.append('<img class="circle mr-10" style="width: 30px; height: 30px;" src="'+json.promoters[i].avatar+'">');
            } else {
                promoterAvatars.append('<span class="name-avatar mr-10">'+$.getInitials(json.promoters[i].name)+'</span>');
            }
            
        }
        if(totalPromoters > 4){
            promoterAvatars.append('<span class="more-participants client-bg">+'+(totalPromoters-3)+'</span>');
        }

        $("#listPromotersDetails"+listnumber).dhoneBind(function(){
            $.listPromotersDetails(json.promoters);
        });

        $("#listPromoters"+listnumber).show();
    } else {
        $("#listPromoters"+listnumber).hide();
        $("#listPromotersAvatar"+listnumber).html("");
    }
    
    if (json.is_promoter) {
        $("#listIsPromoter"+listnumber).show();
    } else {
        $("#listIsPromoter"+listnumber).hide();
    }

    $.eventInsideActualizeAdders(json, listnumber);

    if(listShow){
        $("#listEventInside"+listnumber).show();
        $("#listEventInside").show();
    }

}

jQuery.eventInsideActualizeListById = function(listId){
    $.server("getlist/?client="+clientId+"&user_id="+uUserId+"&list_id="+listId, $.eventInsideActualizeList, "modal");
}

jQuery.eventInsideActualizeList = function(theList){
    if(!theList){
        return;
    }

    var listIndex = null;
    for (index in actualListList){
        if(actualListList[index].id == theList.id){
            listIndex = index;
            break;
        }
    }

    if (listIndex){
        $.eventInsideActualizeAdders(theList,listIndex);
    }
}

jQuery.eventInsideParticipantsInit = function(report){
    participant = report.eps.participants;

    html = "";
    for(i in participant){
        if(participant[i].avatar){
            html += '<li><img src="'+participant[i].avatar+'"></li>';
        } else {
            html += '<li><span class="name-avatar">'+$.getInitials(participant[i].name)+'</span></li>';
        }
    }

    if(report.eps.participants.length < report.eps.subscribers){
        qtd = report.eps.subscribers-report.eps.participants.length
        if (qtd > 999) qtd = "999+";
        else qtd = "+" + qtd;
        
        html += '<li><span class="more-participants client-bg">'+qtd+'</span></li>';
    }

    $("eventinsideParticipantQtd").html("("+report.eps.subscribers+")");

    $("#eventParticipantsUsers").html(html);
    $("#eventParticipants").show();
}

//Função para atualizar quem foi adicionado a lista
jQuery.eventInsideActualizeAdders = function(jsonList, listnumber){
    actualListList[listnumber] = jsonList;
    jsonList = $.extend(true, {}, jsonList);
    jsonList.my_subscribers = $.grep(jsonList.my_subscribers,function(n){ return(n) });
    var adds = ""; var qtdadds = 0; var maxAdds = 3;
    if(jsonList.my_subscribers.length == 4) maxAdds = 4;

    if(jsonList.included){
        if(!uAvatar || uAvatar == "img/avatar.jpg"){
            adds +='<li><span class="name-avatar">'+$.getInitials(uName)+'</span></li>';
        } else {
            adds += '<li><img src="'+uAvatar+'"></li>';
        }
        qtdadds++;
    }

    for(index in jsonList.my_subscribers){
        if(qtdadds >= maxAdds) break;
        if(jsonList.my_subscribers[index].user_id == uUserId) continue;

        if(jsonList.my_subscribers[index].avatar){
            adds += '<li><img src="'+jsonList.my_subscribers[index].avatar+'"></li>';

            qtdadds++;
        }
    }

    for(index in jsonList.my_subscribers){
        if(qtdadds >= maxAdds) break;
        if(jsonList.my_subscribers[index].user_id == uUserId) continue;

        if(!jsonList.my_subscribers[index].avatar){
            adds +='<li><span class="name-avatar">'+$.getInitials(jsonList.my_subscribers[index].name)+'</span></li>';

            qtdadds++;
        }
    }

    if(qtdadds < jsonList.my_subscribers.length){
        var qtd = jsonList.my_subscribers.length-qtdadds;
        if(jsonList.included){
            var includeSelf = false;
            for(index in jsonList.my_subscribers){
                if(jsonList.my_subscribers[index].user_id == uUserId){
                    includeSelf = true;
                    break;
                }
            }
            if(!includeSelf){
                qtd++; //Correção de valor quando você aparece visualmente mas não foi adicionado por si mesmo
            }
        }
        adds += '<li><span class="more-participants client-bg">+'+(qtd)+'</span></li>';
    }

    if(adds){
        $("#listAddeds"+listnumber).html(adds);
        $.dhoneStartCTEvents($("#listAdds"+listnumber));
        $("#listAdds"+listnumber).show();
        listShow = true;
    } else {
        $("#listAdds"+listnumber).hide();
    }
}

var removeSelf = false;
var executeRemove = false;
jQuery.listRemoveParticipant = function(index,listnumber){
    if(!executeRemove){
        if(index == "_1") removeSelf = true; //index _1 utilizado para identificar a si mesmo
        executeRemove = true;
        var participantId = index=="_1"?actualListList[listnumber].included_id:actualListList[listnumber].my_subscribers[index].event_participant_id;

        if(removeSelf){
            $("#listContentSelf"+listnumber).find("button").addClass("btn-load");
        } else {
            $('#'+listnumber+'listAddedPerson'+ (index)).find("button").addClass("btn-load");
        }


    //setTimeout(function(){
        $.server("removeonlist?client="+clientId+"&subscriber_id="+uUserId+"&event_participant_id="+participantId+"&list_id="+actualListList[listnumber].id, function(json){
            var erro = false;

            if(json.eventOld){
                $.showMsg("Atenção","O evento já acabou.")
                erro = true;
            }

            if(json.credencial){
                $.showMsg("Atenção","Você não tem permissão para remover da lista.");
                erro = true;
            }

            if(json.checkin){
                $.showMsg("Atenção","A pessoa já entrou no evento.");
                erro = true;
            }

            if(erro){
                if(removeSelf){
                    $("#listContentSelf"+listnumber).find("button").removeClass("btn-load");
                } else {
                    $('#'+listnumber+'listAddedPerson'+ (index)).find("button").removeClass("btn-load");
                }
                return;
            }

            //{checkin: 0, credencial: 0}
            $('#'+listnumber+'listAddedPerson'+index).css({'transform':'scale(0)','-webkit-transform':'scale(0)'});
            $('#'+listnumber+'listAddedPerson'+index).one('transitionend webkitTransitionEnd', function(){
                $('#'+listnumber+'listAddedPerson'+index).animate({'margin-top':'-78px'},75,function(){
                    if(removeSelf){
                        $("#listContentSelf"+listnumber).hide();
                        removeSelf = false;
                    }
                    if(listQtdPerson == 0){
                        $("#listAdds"+listnumber).slideUp();
                    }
                });
                if($('#'+listnumber+'listAddedPerson'+index).hasClass("last")){
                    $('#'+listnumber+'listAddedPerson'+ (index-1)).addClass("last");
                    $('#'+listnumber+'listAddedPerson'+ (index-1)).find(".with-hr").removeClass("with-hr");
                    $('#'+listnumber+'listAddedPerson'+ (index-1)).find("hr").remove();
                }

            });

            executeRemove = false;
            if(!removeSelf) listQtdPerson--;

            actualListList[listnumber].fullList = false;
            actualListList[listnumber].isTimeout = json.isTimeout;
            actualListList[listnumber].included = json.included;
            if(actualListList[listnumber].fullList || actualListList[listnumber].isTimeout){
                $("#listAddSelf"+listnumber).addClass("disable");
                $("#listAddFriend"+listnumber).addClass("disable");
            } else {
                 if(actualList.included){
                    $("#listAddSelf"+listnumber).addClass("disable");
                } else {
                    $("#listAddSelf"+listnumber).removeClass("disable");
                }
                $("#listAddFriend"+listnumber).removeClass("disable");
            }
        },"modal");
    //},2000);

    }
}


jQuery.eventInsideListAddFriend = function(listnumber){
    if(!listnumber) listnumber = 0; //<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
    actualList = actualListList[listnumber];
    if(!actualList.fullList && !actualList.isTimeout && actualEvent.time_type != "old" && actualList.can_add) {
        var hash = window.location.hash.split("#");
        $.dhoneNavigate("#eventInsideListAdd#slide#go#"+decodeURI(hash[4])+"#"+listnumber);
    } else {
        if(actualEvent.time_type == "old"){
            $.showMsg("Atenção","O evento já passou");
        } else if(actualList.fullList){
            $.showMsg("Atenção","A lista está cheia.");
        } else if(actualList.isTimeout){
            $.showMsg("Atenção","O evento já passou.");
        } else if(!actualList.can_add){
            $.showMsg("Atenção","Não pode adicionar nomes à lista.");
        }
    }
}

jQuery.dateTimeFormat = function(stdate){
    if(stdate.lenght < 19) { return stdate; }

    return $.convertHour(stdate) + " - " + $.convertDate(stdate);
}

jQuery.listDateFormat = function(stDate){
    if(stDate == null || stDate.length < 19) {return stDate;}
    /*01/07/14 às 18:53
    2015-02-16T23:43:21.338-02:00
    01234567890123456789012345678*/
    return stDate.substr(8,2) + "/" + stDate.substr(5,2) + "/" + stDate.substr(0,4) + " às " + stDate.substr(11,5);
}

jQuery.eventIsideListAddListCallback = function(listId, json, addSelf, name, id, atModal){
    //TODO VERIFICAR
    var title = "Alerta";
    if(addSelf){
        var errIsFriendIncluded = "<p>Você já está inscrito.</p>";
    } else {
        var errIsFriendIncluded = "<p>Esse nome já está inscrito.</p>";
    }
    //var errIncluded = "<p>Você já está inscrito.</p>";
    var errIsTimeout = "<p>Já passou do tempo de inscrição.</p>";
    var errIsFull = "<p>Lista cheia.</p>";
    var errIsNameIncluded = '<p>O nome "'+name+'" já foi adicionado à lista.</p>';

    var errFinal = "";
    if(json.isFriendIncluded){
        errFinal += errIsFriendIncluded;
    }
    if(json.isTimeout){
        errFinal += errIsTimeout;
    }
    if(json.isFull){
        errFinal += errIsFull;
    }
    if(json.isNameIncluded){
        errFinal += errIsNameIncluded;
    }
    if(json.error){
        errFinal += '<p>' + json.msg + '</p>';
    }

    if (errFinal == ""){
        listFirstAnimate = false;
        $.listAddDropDownAdd(name,json);
        if(uUserId) $.eventInsideActualizeListById(listId); //$.eventIsideListToUpdate();
        listDalayAnimate = false;
        if(id == uUserId) {
            actualList.included = true;
        }
        else if(name && uUserId){
            for (i = 0; i < initialFriends.suggestions.length; i++) {
                if(id){
                    if(initialFriends.suggestions[i].id == id){
                        initialFriends.suggestions[i].inList = true;
                        break;
                    }
                } else {
                    if(initialFriends.suggestions[i].value2 == name){
                        initialFriends.suggestions[i].inList = true;
                        break;
                    }
                }
            }
        }
    } else {
        if(atModal){
            if(json.emailErr){
                $.errorInputOpen("#addParticipantToListModalEmail", "Email já está na lista" ,3000);
            }

            if(json.phoneErr){
                $.errorInputOpen("#addParticipantToListModalPhone", "Telefone já está na lista" ,3000);
            }
        } else {
            $.showMsg(title,errFinal);   
        }
    }
}

jQuery.eventInsideParticipants = function(){
    $.dhoneNavigate("#eventInsideParticipants#slide#go");
}

var currentListPromoters = {};
jQuery.listPromotersDetails = function (promoters) {
    currentListPromoters = promoters;
    $.dhoneNavigate("#listPromotersDetails#slide#go");
}

// **************** FUNCOES DEPRECATED ***********************************
jQuery.eventInsideUpdate = function() {
    actualPage = 'eventInside';
    var hash = window.location.hash;

    hash = hash.split("#");
    hash.splice(0, 4);

    actualEvent = AGENDA_JSON[hash[0]];

    $.eventInsideUpdateInfos();
    $.startHeaderFade("client-bg", "anchor");
}

jQuery.notificationEventInsideUpdate = function() {
    actualPage = 'notificationEventInside';
    actualEvent = '{"event_id":0,"event_title":"Carregando...","event_date":"","starting_hour":"","finishing_hour":"","avatar":null,"coverpage":null,"lists":[],"event_description":"","photos":[],"entries_limit":0,"entries_qtd":0,"ticket_link":"","ticket_embed":""}';
    actualEvent = eval("(" + actualEvent + ")");

    $.eventInsideUpdateInfos();
    $.startHeaderFade("client-bg", "anchor");
}