jQuery.notificationsStart = function() {
	/*$("#btnClearNotificationsFind").hide();
	$("#notificationsFind").dhonePlaceHolder("Buscar notificação");
	$("#notificationsFind").bind("keyup", $.notificationsFindAction);

    $("#btnClearNotificationsFind").click(function(e) {
        $("#notificationsFind").val("").trigger("blur");
        $(this).hide();
    });*/

    if(theme=="dark"){
        $(".loader").attr("src",darkLoader);
    }

    if(uUserId){
      $("#notificationsOptions").show();
    }

    $('#notificationSection').pullToRefresh({
        callback: function () {
            $('#notificationSection').fadeOut();
            $.server("readnotifications?company_user_id="+uClientUserId,function(){
                $.notificationUpdate(0);
                $.profileUpdate();
            },true);

            var deferred = $.Deferred();
            $.when($.server("notifications?client_user_id="+uClientUserId+"&client="+clientId, $.loadNotification, true)).then(function() {
                deferred.resolve();
            });

            return deferred.promise();
        }
    });

    $.notificationsUpdate();
    
    //Apagando a badge de notificações.
    if (push) {
        
        push.setApplicationIconBadgeNumber(function(){
            
        }, function(){
            console.log("Erro ao atualizar o número de notificações.");
        }, 0);
        
    } else {
        console.log("O objeto 'push' não está acessível na página de notificações.");
    }
}

jQuery.notificationsUpdate = function() {
	$.server("notifications?client_user_id="+uClientUserId+"&client="+clientId, $.loadNotification);
    $.server("readnotifications?company_user_id="+uClientUserId,function(){
        $.notificationUpdate(0);
        //$.profileUpdate();
    },true);
}

jQuery.loadNotification = function(json){
    $("#notificationLoad").remove();

    var htmlNotifications = "";

    if(json.length == 0){
        $.post("./js/components/nonotifications.html", function(data) {
            html = data;

            if(!configs.jPages["notifications"]) return;
            configs.jPages["notifications"].find(".content").html(html);

        });
    }

    for(index in json){
        var stNotification =
            '<div class="col-12 people-timeline">'+
            '    <div class="circle img-box"><img src="¬IMG¬" class="circle" onload="$(this).fadeIn(fadeTime);" /></div>'+
            '    <div class="vertical-text">'+
            '        <h3>¬NAME¬</h3>'+
            '        <p>¬MESSAGE¬</p>'+
            '        <small class="left">¬DATE¬</small>'+
            '    </div>'+
            '    <hr /> '+
            '</div>';

        var notificationDescription = $.dhoneLinkify(json[index].description);
        json[index].variables = eval ( "["+json[index].variables+"]" )[0];
        if(json[index].variables){
            if(json[index].variables.list)
            //    notificationDescription = notificationDescription.replace(/\{list\}/g, '<a tfunc="$.dhoneNavigate(\'#notificationEventInsideList#slide#go#'+json[index].variables.list.exibitionname+'#'+json[index].variables.list.id+'\');">' + json[index].variables.list.exibitionname + '</a>');
                notificationDescription = notificationDescription.replace(/\{list\}/g, json[index].variables.list.exibitionname);
            if(json[index].variables.event)
                notificationDescription = notificationDescription.replace("{event}", '<a tfunc="$.dhoneNavigate(\'#notificationEventInside#slide#go#'+json[index].variables.event.id+'\');">' + json[index].variables.event.exibitionname + '</a>');
            if(json[index].variables.user)
                notificationDescription = notificationDescription.replace("{user}", json[index].variables.user.exibitionname);
            if(json[index].variables.status){
                notificationDescription = notificationDescription.replace("{status}", json[index].variables.status.exibitionname);
            }
        }

        notificationDescription = $.formatText(notificationDescription);

        if(json[index].variables && json[index].variables.title){
            stNotification = stNotification.replace("¬NAME¬",json[index].variables.title)
        }
        else if(json[index].type_id == 3){
            stNotification = stNotification.replace("¬NAME¬",clientName);
        } else if (json[index].type_id == 4) {
            stNotification = stNotification.replace("¬NAME¬","Atualização na compra");
        } else {
            stNotification = stNotification.replace("¬NAME¬",json[index].user_name_origin.replace(/\{user\}/g, json[index].variables.user.exibitionname));
        }
        stNotification = stNotification.replace("¬MESSAGE¬",notificationDescription);
        stNotification = stNotification.replace("¬DATE¬",$.notificationDateFormat(json[index].creation_date));

        console.log(json[index].image);
        var image;
        if (json[index].image == "user") {

            image = "img/avatar.jpg";
            if (theme == "dark") image = "img/avatar-black.jpg";

        } else if(json[index].image == "company") {

            image = "client/init-icon.png";

        } else {
            image = json[index].image;
            if (!image && (json[index].type_id == 1 || json[index].type_id == 2)){
                image = "img/avatar.jpg";
                if (theme == "dark") image = "img/avatar-black.jpg";
            }
        }
        stNotification = stNotification.replace("¬IMG¬", image);

        htmlNotifications += stNotification;
    }

    $(".loading-general").remove();
    $('#notificationSection').find(".wrap").html('<div class="container">'+htmlNotifications+"</div>");
    //$("#notificationContainer").html(htmlNotifications);
    $.dhoneStartCTEvents("#notificationSection");

    $('#notificationSection').fadeIn();
}

jQuery.notificationDateFormat = function(stDate){
    if(stDate == null || stDate.length < 19) {return stDate;}
    /*01/07/14 às 18:53
    2015-02-16T23:43:21.338-02:00
    01234567890123456789012345678*/
    return stDate.substr(8,2) + "/" + stDate.substr(5,2) + "/" + stDate.substr(0,4) + " às " + stDate.substr(11,5);
}

jQuery.notificationsFindAction = function() {

    if ($.trim($(this).val()) == "") {
        $("#btnClearNotificationsFind").hide();
        //$.buildFunction@##$$%%%();
        return false;
    }

   $("#btnClearNotificationsFind").show();

}

jQuery.notificationSwitchButton = function(id){
    var button = $("#notificationConfig"+id);
    notificationOptions[id] = !notificationOptions[id];

    if(button.hasClass('btn-yes')){
        button.addClass('btn-no negative');
        button.find('i').addClass('btn-left');
        button.removeClass('btn-yes confirm');
        button.find('i').removeClass('btn-right');
        button.find('span').html("Não");
    } else {
        button.addClass('btn-yes confirm');
        button.find('i').addClass('btn-right');
        button.removeClass('btn-no negative');
        button.find('i').removeClass('btn-left');
        button.find('span').html("Sim")
    }
}

var notificationOptions;
jQuery.notificationOptions = function(){
    notificationOptions = [];
    $.modalShow('notificationsconfig', function(){
        $.server("getNotificationTypes?id="+clientId+"&user_id="+uUserId,function(json){
            var first = true;
            var html = '<h2 id="" class="mb-15">Configurações</h2><hr>';
            for(index in json){
                var classesButton; var classesI; var textBtn;
                if(json[index].rejected){
                    classesButton = "btn-no negative";
                    classesI = "btn-left";
                    textBtn = "Não";
                    notificationOptions[json[index].id] = json[index].rejected;
                } else {
                    classesButton = "btn-yes confirm"
                    classesI = "btn-right";
                    textBtn = "Sim";
                }
                if(!first) html += "<hr>";
                first = false;

                html +=
                    '<div class="row">'+
                        '<div class="col-8">'+
                            '<p>'+json[index].description+'</p>'+
                        '</div>'+
                        '<div class="col-4">'+
                            '<button id="notificationConfig'+json[index].id+'" type="button" class="btn '+classesButton+' right btn-animation" tfunc="$.notificationSwitchButton(\''+json[index].id+'\');"><span>'+textBtn+'</span><i class="mdi mdi-menu '+classesI+'"></i></button>'+
                        '</div>'+
                    '</div>';
            }

            $("#notificationConfigSwitches").html(html);

            $.dhoneStartCTEvents("#notificationConfigSwitches");

            $("#notificationConfigLoad").remove();
            $("#notificationConfigContent").fadeIn();
        }, "modal");
    });
}

jQuery.notificationGetRejectedList = function(){
    var rejected_list = "";
    for(index in notificationOptions){
        if(notificationOptions[index]){
            rejected_list += index+",";
        }
    }
    rejected_list = rejected_list.substr(0, rejected_list.length-1);
    return rejected_list;
}

jQuery.notificationConfigSave = function(){
    $.server("savenotificationconfigs?company_user_id="+uClientUserId+"&rejected_list="+$.notificationGetRejectedList(),function(){
        $.modalHide();
    }, false);
}
