var isOpenMenu          = false; // Indica se o menu está aberto ou fechado
var dragMenu            = false; // Indica se o menu está sendo puxado
var dragMenuBack        = false; // Indica se o menu está sendo puxado de volta
var starty              = 0;     // (Android 2.2) Indica a posição vertical (y) do dedo na lista
var dist                = 0;     // (Android 2.2) Indica a distância vertical entre o ponto inicial e o ponto até onde a lista foi arrastada
var size                = null;  // Indica o tamanho horizontal e vertical da tela do aparelho (size['w'] ou size['h'])
var speedAsideAnimation = 220;   // Indica a velocidade padrão da animação de abertura e fechamento do menu
var asideTouchStartPos  = 20;    // Indica a posição em px até onde é possível puxar o menu lateral
var delayCorrection     = 25;    // Ajusta o tamanho do pulo quando o asideMenu esta sendo aberto via drag
var updateList          = [];    // Vetor que contem a referencia das paginas que serão atualizadas no lançamento do metodo dhoneUpdate
var pageNow             = "";    // indica a pagina atual
var configs             = null;  // Recebe o obj de configuração das paginas na inicialização
var generalLoading      = false; // Auxiliar global para saber se o app ainda esta no processo de carregamento de informações solicitadas
var imgsToPreload       = [];    // Lista de imagens que serão atualizadas
var isPreloading        = false; // Controla quando uma nova imagem entra no preload para que o preload não seja iniciado duas vezes ou mais
var clickToCloseTimer   = 0;     // Auxiliar para simular o click recebendo os milesegundos para fazer o cauculo
var isSplashHide        = false;
var isAnimating         = false;
var dhoneTouchTimer     = false;
var dhoneTouchTimeout   = 500;
var dhoneTouchTolerance = 15;
var push_token          = "";
//var notificationOpened  = false; // Informa se o usuario tocou na notificacao para abrir o app

var pixelFade           = 100; //qtd de pixels para aparição total do header-fade
var fadeTime            = 400; //tempo de fade das imagens ao carregar

var defaultAvatar = "img/avatar.jpg";

var coverPatternSize = [1000,700];

var maxTitleLength = 23; // qtd máxima de letras no título

var uNewNotification = 0; // notificações de usuários
var idLoginNotification = null; // id do setinterval da atualização das notifications

var pagseguroLoad = false; //caso a biblioteca pagseguro já está carregada

var defaultLoader = "img/loader.gif";
var darkLoader    = "img/loader-black.gif";

//Variável utilizada para verificar se existe algum módulo carregando, para evitar travamento nas trocas de módulos
var loadingModules = true; // Inicia carregando o módulo de agenda

//variável que indica que o aplicativo está rodando
var appReady = false;

jQuery.changeModule = function(module){
    if (!loadingModules){
        loadingModules = true;
        $.dhoneNavigate('#' + module);
    }
}

jQuery.getOrigin = function(){
  if ($.isAndroid()){
    return "APP_ANDROID";
  } else if ($.isIos()){
    return "APP_IOS";
  } else {
    return "APP_MOBILE";
  }
}

jQuery.getLoader = function(){
    if(theme == "dark"){
        return darkLoader;
    } else {
        return defaultLoader;
    }
}

// Inicia todas as funcionalidades
jQuery.dhone = function() {
    var userName = '@'+window.localStorage.getItem('userName');
    if (userName >= 14)
        userName = userName.substr(0, 14) + '...';

    $("#userName").html(userName);
    var userImg = window.localStorage.getItem('userImage');
    if(userImg != null && userImg != ""){
        $("#userImage").attr("src",userImg);
    }

    $.getScript("./js/pagesActions.js", function() {
        $.getScript("./js/dslider.js", function() {
          configs = new PagesConfig();
          $.getScript("./js/dhoneConfig.js", function(){
            $.getScript("./client/config.js", function() {
                    //THEME
                    if(theme == "dark"){
                        $('head').append('<link rel="stylesheet" type="text/css" href="css/black-theme.css" />');
                    }

                    // $.extend($.scrollTo.defaults, {
                    //   //axis: 'y',
                    //   duration: 400
                    // });
                    //if(typeof Keyboard !== 'undefined') Keyboard.shrinkView(true);

                    //CARREGAR MÓDULOS
                    $.dhoneInitComponents(function(){
                        $("#asideClientName").html(clientName);

                        //verifica dados de usuario e retoma o login se possivel
                        //obs. abre a página inicial somente depois do login
                        $.loginLoadSession(function(){
                            $.pageChange();
                            pageNow     = configs.getDefaultPage();
                            size        = $.getWindowSize();
                            $("#aside").css("overflow", "auto");

                            $("body").css("max-width", size["w"]);

                            //verifica o tipo de aplicativo
                            if(appType=="producer"){
                                $("#suggestEventsAside").show();
                            } else { // tipo place
                                $("#suggestEventsAside").hide();
                            }

                            //carregar função de animação da página inicial para abrir o aside
                            $.slideOpenAside();
                        });

                        setTimeout(function(){
                            appReady = true;
                            $.dhoneInitPush();
                        }, 2000);

                        //auditoria de acesso
                        $.appAccess();

                        //verifica acesso vindo de push e adiciona evento caso aconteça depois do app estar aberto
                        //$.verifyPush();
                        document.addEventListener("resume", $.verifyPush, false);

                        // $.getScript("./js/dhone.push.js", function() {
                        //     //Registra para push
                        //     if($.isIos() || $.isAndroid()){
                        //         register();
                        //     }
                        // });

                        $.ajaxSetup({ cache: false });
                        
                        document.dispatchEvent(new Event("dhone-configloaded"));
                    });


            });
          });

        });

    });

}

jQuery.dhoneInitPush = function(count){
    if (!count) count = 1;
    console.log("initpush - " + count);
    if (count > 5) return;
    if(uUserId && configs.getPageNow()){
        $.verifyPush();
    } else {
        setTimeout(function(){$.dhoneInitPush(count + 1);}, 2000);
    }
}

jQuery.verifyPush = function(){
    if(uUserId && appReady){
        if(window.localStorage.getItem("push")){
            window.localStorage.removeItem("push");
            //window.localStorage.setItem("push",null);
            if(pageNow != "notifications"){
                $.dhoneNavigate("#notifications");
            }
        }
    }

}

jQuery.isIos = function(){
    return (dhoneDevice == "iPhone" || dhoneDevice == "iPad" || dhoneDevice == 'iPhone Simulator' || dhoneDevice == "iPod");
}

jQuery.isAndroid = function(){
    return (dhoneDevice == "Android");
}

jQuery.startHeaderFade = function(subClass, classFinish) {
    configs.jPages[configs.getPageNow()].find(".content").unbind("scroll");
    configs.jPages[configs.getPageNow()].find(".content").bind("scroll", function() {
        var topVal = configs.jPages[configs.getPageNow()].find(".content").scrollTop()/pixelFade;
        if(topVal < 0) topVal = configs.jPages[configs.getPageNow()].find(".content").scrollTop()/70*(-1);

        configs.jPages[configs.getPageNow()].find(".header-fade").find("."+subClass).css("opacity", topVal);
        //$("h1").html(configs.jPages[configs.getPageNow()].find(".content").scrollTop());
    });

    configs.jPages[configs.getPageNow()].find(".header-fade").find("."+subClass).css("opacity", 0);
}

jQuery.deviceId = function() {
    var deviceId;
    if(dhoneDevice == "browser"){
        deviceId = "BROWSERTEST";
    } else {
        deviceId = device.uuid;
    }
    return deviceId;
}

// Auditoria de acesso
jQuery.appAccess = function() {
    if(dhoneDevice != "browser"){
        $.server("appaccess?client="+clientId+"&device="+$.deviceId()+"&os="+device.platform+"&push_token="+push_token, function(JSON){}, true);
    }
}

jQuery.sendPushToken = function(){
    var deviceId = $.deviceId();

    //if(!(window.localStorage.getItem('push_token') == push_token)){
        $.server("updatedevice?device="+$.deviceId()+"&client="+clientId+"&os="+device.platform+"&push_token="+push_token, function(JSON){
            //window.localStorage.setItem('push_token', push_token);
        }, true);
    //}

}

jQuery.generatePostData = function(url){
    var urlArr = url.split("?");
    var response = {};
    response["url"] = urlArr[0];
    if (urlArr.length > 1) {
        queryString = urlArr[1];
        var data = {};
        var variables = queryString.split("&");
        for(i in variables) {
            item = variables[i].split("=");
            if (item.length > 1)
                data[item[0]] = item[1];
        }
        response["data"] = data;
    } else {
        response["data"] = {};
    }
    return response;
}

//Faz requisições ao servidor verificando conexão e recebendo uma função de callback
//TYPELOADING - "screen" = carregar na tela | "modal" = carregar no modal
jQuery.server = function(linkPage, callback, noLoading, retry, post) {
    var typeLoad = noLoading;

    if (!post){
        post = false;
    }

    if (!retry) {
        retry = false;

    }

    if (!noLoading) {
        noLoading = false;
        typeLoad = "none";
    } else if(noLoading == true){
        //typeLoad = "screen";
    }


    var dConnectionType;
    var ConnectionNONE;
    if (dhoneDevice != "browser") {
        dConnectionType = navigator.network.connection.type;
        ConnectionNONE = Connection.NONE;
    }else {
        dConnectionType = "wifi";
        ConnectionNONE = "none";
    }

    var deferred = $.Deferred();

    //verifica a conexão // Connection.NONE == none
    if(dConnectionType == ConnectionNONE){
        //Sem conexão
        if(typeLoad == "screen"){
            //Requisita o html de falha de conexão
            $.post("./js/components/connection.html", function(data) {
                var btn = $(data);
                /*
                if(dhoneDevice == "browser"){
                    btn.find("button.btn").on("click", function() {
                        $.server(linkPage, callback, noLoading, true);
                    });
                } else {
                    btn.find("button.btn").on("touchend", function() {
                        $.server(linkPage, callback, noLoading, true);
                    });
                }
                */
                btn.find("button.btn").dhoneBind(function(){
                    $.server(linkPage, callback, noLoading, true);
                });

                configs.jPages[configs.getPageNow()].find(".content").hide();
                configs.jPages[configs.getPageNow()].append(btn);
                configs.jPages[configs.getPageNow()].show();
                configs.jPages[configs.getPageNow()].find(".content").show();
                //$.dhoneUpdate();
                deferred.resolve();
            });
        } else if(typeLoad == "modal"){
            $.showMsg("Rede não encontrada.","Conecte-se à Internet e tente novamente.");
            deferred.resolve();
        } else {
            deferred.resolve();
        }
    }else{
        //com conexão

        if (retry) {
            configs.jPages[configs.getPageNow()].find(".content").show();
            configs.jPages[configs.getPageNow()].find(".no-connection-display").remove();

        }

        //requisirta o html de carregando
        $.post("./js/components/loading.html", function(data) {
            if (typeLoad == "screen") {
                generalLoading = true;
                if (!configs.jPages[configs.getPageNow()].find(".wrap")) {
                    configs.jPages[configs.getPageNow()].find(".content").html(data);
                }else {
                    configs.jPages[configs.getPageNow()].find(".wrap").html(data);
                }
            } else if(typeLoad == "modal"){
                //CARREGAR NO MODAL
            }

            var data = {}
            if (true) {
                urlHash = $.generatePostData(linkPage);
                data = urlHash["data"];
                linkPage = urlHash["url"];
            }

            $.post(serverURL+clientFolder+"/"+linkPage, data, function(JSON) {
                generalLoading = false;
                callback(JSON);
                deferred.resolve();
            }).fail(function() {

                $.getJSON('http://anyorigin.com/get?url=google.com&callback=?', function(){
                    if (typeLoad == "screen") {
                        $.post("./js/components/noserver.html", function(data) {
                            var btn = $(data);
                            btn.find("button.btn").dhoneBind(function(){
                                $.server(linkPage, callback, noLoading, true);
                            });
                            /*
                            if(dhoneDevice == "browser"){
                                btn.find("button.btn").on("click", function() {
                                    $.server(linkPage, callback, noLoading, true);
                                });
                            } else {
                                btn.find("button.btn").on("touchend", function() {
                                    $.server(linkPage, callback, noLoading, true);
                                });
                            }
                            */
                            configs.jPages[configs.getPageNow()].find(".content").hide();
                            configs.jPages[configs.getPageNow()].append(btn);
                            configs.jPages[configs.getPageNow()].show();
                            configs.jPages[configs.getPageNow()].find(".content").show();
                            //$.dhoneUpdate();
                            deferred.resolve();
                        });
                    }else if(typeLoad == "modal"){
                        $.showMsg("Sem conexão com o servidor","O aplicativo não conseguiu se conectar.");
                        deferred.resolve();
                    }else{
                        deferred.resolve();

                    }

                }).fail(function() {
                    if(typeLoad == "screen"){
                        //Requisita o html de falha de conexão
                        $.post("./js/components/connection.html", function(data) {
                            var btn = $(data);
                            btn.find("button.btn").dhoneBind(function(){
                                $.server(linkPage, callback, noLoading, true);
                            });
                            /*
                            if(dhoneDevice == "browser"){
                                btn.find("button.btn").on("click", function() {
                                    $.server(linkPage, callback, noLoading, true);
                                });
                            } else {
                                btn.find("button.btn").on("touchend", function() {
                                    $.server(linkPage, callback, noLoading, true);
                                });
                            }
                            */

                            configs.jPages[configs.getPageNow()].find(".content").hide();
                            configs.jPages[configs.getPageNow()].append(btn);
                            configs.jPages[configs.getPageNow()].show();
                            configs.jPages[configs.getPageNow()].find(".content").show();
                            //$.dhoneUpdate();
                            deferred.resolve();
                        });
                    } else if(typeLoad == "modal"){
                        $.showMsg("Rede não encontrada.","Conecte-se à Internet e tente novamente.");
                        deferred.resolve();
                    } else {
                        deferred.resolve();
                    }

                });

            });
        });


        return deferred.promise();

    }

}


jQuery.serverSend = function(linkPage, numberOfTries, retrySleepTime) {
    var MAX_TRY = 10;
    if (!numberOfTries)
        numberOfTries = 0;
    if(!retrySleepTime)
        retrySleepTime = 1000;

    var dConnectionType;
    var ConnectionNONE;
    if (dhoneDevice != "browser") {
        dConnectionType = navigator.network.connection.type;
        ConnectionNONE = Connection.NONE;
    }else {
        dConnectionType = "wifi";
        ConnectionNONE = "none";
    }

    //verifica a conexão // Connection.NONE == none
    if(dConnectionType == ConnectionNONE){
        //Sem conexão
        numberOfTries++;
        retrySleepTime = Math.floor(retrySleepTime+(retrySleepTime/4));
        var retry = setInterval(function() {
            if (numberOfTries<=MAX_TRY) {
                $.serverSend(linkPage, numberOfTries, retrySleepTime);
            }
            clearInterval(retry);
        }, retrySleepTime);

    }else{
        //com conexão
        $.getJSON(serverURL+clientFolder+"/"+linkPage).fail(function() {
            numberOfTries++;
            retrySleepTime = Math.floor(retrySleepTime+(retrySleepTime/4));
            var retry = setInterval(function() {
                if (numberOfTries<=MAX_TRY) {
                    $.serverSend(linkPage, numberOfTries, retrySleepTime);
                }
                clearInterval(retry);
            }, retrySleepTime);
        });

    }

}


jQuery.toQueryString = function(paramiter) {
    var executed = false;
    var queryString = "";
    for (var i in paramiter) {
        if (!executed) {
            executed = true;
            queryString += "?"+i+"="+paramiter[i];
            continue;
        }

        queryString += "&"+i+"="+paramiter[i];
    }

    return queryString;

}


//Adciona uma pagina e sua função de update ao update geral
jQuery.addUpdate = function(action, func, param) {
    if (!updateList[action]) {
        if (param) {
            updateList[action] = {"function": func, "paramiters": param};
        }else {
            updateList[action] = {"function": func};
        }
    }

}

// Reseta todas as variáveis sendo ela o modo de update geral
jQuery.dhoneUpdate = function(softUpdate) {
    $("#general-content").addAnimation(0, "ease");
    $(".screen-size").addAnimation(0, "ease");

    size            = $.getWindowSize();
    $("body").css("max-width", size["w"]);

    //UPDATE DA GALERIA
    if ($(".dhoneGallery").length){
        $("body").dGallery("update");
    }

    $("#general-content").addAnimation(0, "ease");

    if(!softUpdate){
        isOpenMenu = true;
        $.slideMenu(size, configs.getContentSizeOnAside(), 0);
    }

    $("#general-content").css("max-width", size["w"]+"px");
    $("#general-content").width(size["w"]+"px");

    $(".content").css("max-width", size["w"]+"px");
    $(".content").width(size["w"]+"px");
    $(".content2").css("max-width", size["w"]+"px");
    $(".content2").width(size["w"]+"px");

    $("#general-content").css("max-height", size["h"]+"px");
    $("#general-content").height(size["h"]+"px");

    $(".screen-size").css("min-width", size["w"]+"px");
    $(".screen-size").width(size["w"]+"px");
    $(".screen-size").css("min-height", size["h"]+"px");
    var originalH = size["h"]-configs.getHeaderSize(pageNow);

    /*
    if($.isIos() && pageNow == "agenda"){
        //retira os 20px do topo
        $(".content").height((originalH-40)+"px");
        $(".nav").height((originalH-40)+"px");
    } else {
        */
        //$(".content").height(originalH+"px");
        configs.jPages[configs.getPageNow()].find(".content").height(originalH+"px");
        //$(".nav").height(originalH+"px");
        configs.jPages[configs.getPageNow()].find(".nav").height(originalH+"px");
    //}

    $("body").width(size["w"]+"px");
    $("body").height(size["h"]+"px");
    //$("#dhoneModal").width(size["w"]+"px");
    $("#dhoneModal").height((size["h"])+"px");
    $("html").height((size["h"])+"px");


    if ($("#aside").css("display") == "none") {
        $("#aside").css("display", "inherit");

    }

    //if(!softUpdate){
        $.dhoneStartCTEvents(); //eventos de toutchend
    //}

    //executa a função update da pagina em visualização se ela o tiver
    if (!softUpdate && updateList[pageNow]) {
        if (updateList[pageNow]["paramiters"]) {
            updateList[pageNow]["function"](updateList[pageNow]["paramiters"]);

        }else {
            updateList[pageNow]["function"]();

        }

    }
}

//Atualiza tamanho maximo dos box que abrem e fecham
jQuery.fn.dhoneDropInfoUpdate = function() {
    return this.each(function(){

        $(this).addAnimation(0, "");
        $(this).css({"height": "auto", "overflow": "inherit"});
        $(this).attr("savedHeight", $(this).height() + 15);

        $(this).addAnimation(300, "");
        $(this).css("overflow", "hidden");

        if ($(this).attr("isOpen") == "true") {
            $(this).css({"height": $(this).attr("savedHeight")+"px"});

        }else {
            $(this).css({"height": "57px"});

        }



    });


}


//Inicializa os box que abrem e fecham
jQuery.fn.dhoneDropInfo = function() {
    return this.each(function(){

        if (!$(this).attr("savedHeight")) {
            $(this).attr("savedHeight", $(this).height());
        }
        $(this).css({"height": "57px"});

        $(this).attr("isOpen", "false");
        $(this).addAnimation(300, "");

        //$(this).find("h2.dropInfoContainerBtn").unbind("touchend");
        //$(this).find("h2.dropInfoContainerBtn").bind("touchend", function(){
        $(this).dhoneBind(function(obj){
            //alert($(this).parent().parent().attr("savedHeight"));

            if ($(obj).attr("isOpen") == "true") { //FECHAR
                $(obj).find(".icon-arrow-top").addClass("icon-arrow-down").removeClass("icon-arrow-top");
                $(obj).css({"height": "57px"});
                $(obj).attr("isOpen", "false");
            }else { //ABRIR
                $(obj).find(".icon-arrow-down").addClass("icon-arrow-top").removeClass("icon-arrow-down");
                $(obj).css({"height": $(obj).attr("savedHeight")+"px"});
                $(obj).attr("isOpen", "true");

                /*var topToScroll = configs.jPages[configs.getPageNow()].find(".content").scrollTop() + parseFloat($(this).parent().parent().attr("savedHeight"));
                setTimeout(function() {
                    configs.jPages[configs.getPageNow()].find(".content").scrollTop(topToScroll);
                }, 330);*/

            }

            //var aTag = $("a[name='"+ aid +"']");
            //$('html,body').animate({scrollTop: aTag.offset().top},'slow');

        });

    });
}


function execMenuSlideBtn() {
    if (configs.pageHasAside(pageNow)) {
        //alert("function " + size + " - " + configs.getContentSizeOnAside());
        $.slideMenu(size, configs.getContentSizeOnAside(), 150);
    }
}

var TouchStart;
//Inicializa os eventos padrões do DHONE
jQuery.dhoneGeneralEvents = function(asideTouchStart) {
    TouchStart = asideTouchStart;


    //cancela eventos anteriormente inicializados
    $(".container").unbind("touch")
    $(window).unbind("resize");
    $(document).unbind("touchstart");
    $(document).unbind("touchmove");
    $(document).unbind("touchend");
    $(window).unbind('hashchange');
    $(document).unbind("backbutton");


    //Quando muda de pagina
    $(window).on('hashchange', $.pageChange);

    //Atuva o botão de voltar para seguir o historico do dhone
    $(document).bind("backbutton", function(evt) {
        $.dhoneBack();
    });


    //botão que abre o aside
    $(".menu-nav").dhoneBind("execMenuSlideBtn()");

    //quando o aparelho muda de posição
    $(window).bind("resize", function(evt) {
        $.dhoneUpdate(true);//SOFTUPDATE
        if($(":focus").is("input")){
            if(pageNow == "ticketPaymentMethod") {
                $('#'+pageNow+' .scrollable').scrollTo($(":focus").parent().find("label").first());
            } else {
                $('#'+pageNow+' .scrollable').scrollTo(":focus");
            }
        }
    });

    //Inicio do evento de arrastar o aside para abrir
    $(".screen-size").bind("touchstart", function(evt) {
        $.slideOpenAsideTouchStart(this,evt);
    });

    //SLIDEASIDE
    $.slideOpenAside();

    //ajusta problemas de scroll do android 2
    $(".scrollable").android2xScrollCorrection();

}

jQuery.slideOpenAsideTouchStart = function(that, evt){
    var self = $(that);
    if(!self.hasClass("screen-size")) self = self.parent();
    //if(!self.hasClass("screen-size")) alert(self.html());

    if(self.attr("id") == pageNow || isOpenMenu){ // Somente inicia o evento caso seja feita na página atual

        //jQuery("h1").html(configs.pageHasAside(pageNow) + " " + dragMenu + " " + dragMenuBack);
        if (configs.pageHasAside(pageNow)) {
            var touchobj = evt.originalEvent.changedTouches[0];

            if (touchobj.clientY > configs.getHeaderSize(pageNow)) {
                if (isOpenMenu) {
                    $("#general-content").addAnimation(0, "ease");
                    $("#asideAnimation").addAnimation(0, "ease");
                    dragMenu        = true;
                    dragMenuBack    = true;

                    clickToCloseTimer = evt.timeStamp;

                    evt.preventDefault();

                }else {
                    if (touchobj.clientX < TouchStart) {
                        evt.preventDefault();
                        $("#general-content").addAnimation(0, "ease");
                        $("#asideAnimation").addAnimation(0, "ease");
                        dragMenu = true;
                    }
                }

            }

        }else if(configs.getPageFather(pageNow) != null) {
            var touchobj = evt.originalEvent.changedTouches[0];

            if (touchobj.clientX < TouchStart) {

                evt.preventDefault();
                self.addAnimation(0, "ease");
                configs.jPages[configs.getPageFather(pageNow)].addAnimation(0, "ease");
                dragMenu = true;
            }

            configs.jPages[configs.getPageFather(pageNow)].find(".transparent-fg").removeClass("animate");
        }
    }
}

jQuery.slideOpenAsideTouchMove = function(that, evt){
    var self = $(that);
    if(!self.hasClass("screen-size")) self = self.parent();
    //if(!self.hasClass("screen-size")) alert(self.html());

    if(self.attr("id") == pageNow || isOpenMenu){

        if (configs.pageHasAside(pageNow) ) {

            var touchobj = evt.originalEvent.changedTouches[0];

            if (dragMenu && (touchobj.clientX-delayCorrection > -1)) {
                evt.preventDefault();

                var percentAnimationAside = (touchobj.clientX / (size["w"]-(configs.getContentSizeOnAside() - 10)) );

                if (percentAnimationAside > 1) {
                    percentAnimationAside = 1;
                }


                var animationAsideDeg = (-10*(1-percentAnimationAside));
                $("#asideAnimation").css("transform", "perspective(100px) rotateY("+animationAsideDeg+"deg)");

                $("#asideAnimation").css("opacity", percentAnimationAside);

                /*
                var asideWidth = $("#aside").css("width");
                asideWidth = asideWidth.substr(0,asideWidth.length - 2);
                //$("h1").html(((1-percentAnimationAside)*parseInt(asideWidth)) + "px");
                $("#aside").css("margin-left" , ((1-percentAnimationAside)*parseInt(asideWidth)*-1.1) + "px");
                */

                //$("#asideAnimation").css("margin-left" , (percentAnimationAside*$("#aside").css("width")) + "px");

                //var blurPost = Math.floor(5-(5 * percentAnimationAside));
                //$("#asideAnimation").css("-webkit-filter", "blur("+blurPost+"px)");

                $("#general-content").css("-webkit-transform", "translate3d("+(touchobj.clientX-delayCorrection)+"px, 0, 0)");
                $("#general-content").css("transform", "translate3d("+(touchobj.clientX-delayCorrection)+"px, 0, 0)");

            }
        }else if(configs.getPageFather(pageNow) != null) {
            //Movimento de volta arrastando
            var touchobj = evt.originalEvent.changedTouches[0];

                if (dragMenu && touchobj.clientX-delayCorrection > -1) {

                    if (touchobj.clientX-delayCorrection > -1 && evt.originalEvent.touches.length <= 1) {
                        dragMenu = true;

                        evt.preventDefault();

                        var percentAnimationAside = (touchobj.clientX / (size["w"]-(configs.getContentSizeOnAside() - 10)) );

                        if (percentAnimationAside > 1) {
                            percentAnimationAside = 1;
                        }

                        //configs.jPages[configs.getPageFather(pageNow)].css("-webkit-filter", "brightness("+percentAnimationAside+")");
                        //configs.jPages[configs.getPageFather(pageNow)].find(".transparent-fg").css("opacity", 0.8-(percentAnimationAside-0.2));

                        self.css("-webkit-transform", "translate3d("+(touchobj.clientX-delayCorrection)+"px, 0, 0)");
                        self.css("transform", "translate3d("+(touchobj.clientX-delayCorrection)+"px, 0, 0)");

                    }
                }


            }
    }

}

jQuery.slideOpenAsideTouchEnd = function(that, evt){
    var self = $(that);
    if(!self.hasClass("screen-size")) self = self.parent();
    //if(!self.hasClass("screen-size")) alert(self.html());

    if(self.attr("id") == pageNow || isOpenMenu){

        if (configs.pageHasAside(pageNow) && dragMenu) {
            var touchobj = evt.originalEvent.changedTouches[0];
            var areaMin = (size["w"]-configs.getContentSizeOnAside())/2;

            clickToCloseTimer = evt.timeStamp - clickToCloseTimer;

            if (isOpenMenu && clickToCloseTimer < 150) { //150 eh o tempo do click
                //Fecha o aside quando clica no conteudo
                if (!dhoneTouchTimer)
                    $.slideMenu(size, configs.getContentSizeOnAside(), 150);

            }else {
                //caso não tenha sido um click
                if (!dragMenuBack) {
                    if (touchobj.clientX >= areaMin) {
                        isOpenMenu = false;
                        $.slideMenu(size, configs.getContentSizeOnAside(), 150);
                    }else {
                        isOpenMenu = true;
                        $.slideMenu(size, configs.getContentSizeOnAside(), 150);
                    }
                }else {
                    area = (size["w"]-configs.getContentSizeOnAside())+10;
                    if (touchobj.clientX >= area) { // ABERTO
                        isOpenMenu = false;
                        $.slideMenu(size, configs.getContentSizeOnAside(), 80);
                    }else {
                        isOpenMenu = true;
                        $.slideMenu(size, configs.getContentSizeOnAside(), 150);

                    }

                }

            }

            dragMenuBack    = false;
            dragMenu    = false;

        }else if(configs.getPageFather(pageNow) != null && dragMenu) {
            dragMenu    = false;
            var touchobj = evt.originalEvent.changedTouches[0];
            var areaMin = (size["w"]-configs.getContentSizeOnAside())/2;

            area = (size["w"]-configs.getContentSizeOnAside())-(size["w"]/2);
            if (touchobj.clientX >= area) { //NÃO VOLTOU
                self.addAnimation(150, "ease");
                $.dhoneBack();
                return false;

            }else { //VOLTOU
                self.addAnimation(150, "ease");
                self.css("-webkit-transform", "translate3d(0, 0, 0)");
                self.css("transform", "translate3d(0, 0, 0)");

            }

        }
    }

}

jQuery.slideOpenAside = function(){
    //Arrastando para abrir o aside
    $(".screen-size").bind("touchmove", function(evt) {
        $.slideOpenAsideTouchMove(this,evt);
    });


    //quando solta o aside
    $(".screen-size").bind("touchend", function(evt) {
        $.slideOpenAsideTouchEnd(this, evt);
    });
}

// Abre e fecha o menu lateral
jQuery.slideMenu = function(size, imgSize, speed) {

    $("#general-content").addAnimation(speed, "ease");
    $("#asideAnimation").addAnimation(speed, "ease");

    if (isOpenMenu) {//FECHAR

        //$("#general-content").width(size["w"]);
        $("#general-content").css("-webkit-transform", "translate3d(0, 0, 0)");
        $("#general-content").css("transform", "translate3d(0, 0, 0)");

        $("#asideAnimation").css("transform", "perspective(50px) rotateY(-10deg)");
        $("#asideAnimation").css("opacity", 0);

        isOpenMenu = false;

        configs.jPages[pageNow].find(".transparent-fg").remove();
    }else {//ABRIR
        if($("#transparentFg").length == 0){
            htmlTransparentFg = '<div id="transparentFg" class="transparent-fg" style="z-index:99999999999;" />';
            //$("#general-content")
            configs.jPages[pageNow].append(htmlTransparentFg);
            //configs.jPages[pageNow].find(".transparent-fg").show();

            $(".transparent-fg").dhoneBind(function(){
                //alert("TRANSP - " + size + " - " + imgSize)
                $.slideMenu(size,imgSize,speed);
            });
            //$("#transparentFg").bind("click",function(){
            //    alert("TRANSP - " + size + " - " + imgSize)
            //    $.slideMenu(size,imgSize,speed);
            //});

            //Arrastando para abrir o aside
            $("#transparentFg").bind("touchmove", function(evt) {
                    $.slideOpenAsideTouchMove(this,evt);
            });
            //quando solta o aside
            $("#transparentFg").bind("touchend", function(evt) {
                    $.slideOpenAsideTouchEnd(this, evt);
            });
            //Inicio do evento de arrastar o aside para abrir
            $("#transparentFg").bind("touchstart", function(evt) {
                    $.slideOpenAsideTouchStart(this,evt);
            });
        }


        //$("#general-content").width(imgSize);
        $("#general-content").css("-webkit-transform", "translate3d("+(size["w"]-imgSize)+"px, 0, 0)");
        $("#general-content").css("transform", "translate3d("+(size["w"]-imgSize)+"px, 0, 0)");

        $("#asideAnimation").css("transform", "perspective(50px) rotateY(0deg)");
        $("#asideAnimation").css("opacity", 1);

        isOpenMenu = true;

        $("#asideAnimation").one("transitionend webkitTransitionEnd" , function(){
            setTimeout(function(){
                $.dhoneNotification();
            }, 250);
        });


    }

    //engatilha o evento onmenuchange para o app
    var dhoneEvent = jQuery.Event( "onmenuchange" );
    dhoneEvent.isOpened = isOpenMenu;
    $( "body" ).trigger(dhoneEvent);

}

// Captura o tamanho horizontal e vertical da tela do aparelho
jQuery.getWindowSize = function(){
    var d       = document;
    var root    = d.documentElement;
    var body    = d.body;
    var wid     = root.clientWidth;
    var hi      = root.clientHeight;

    return {"w": wid, "h": hi};

};

jQuery.getCoverDefaulSize = function(){
    var windowsSize = $.getWindowSize();
    var cwidith = windowsSize["w"];
    var cheight = windowsSize["w"]*coverPatternSize[1]/coverPatternSize[0];
    return [cwidith,cheight];
}

// Altera a animação de um objeto
jQuery.fn.addAnimation = function(tp, ev){
    return this.each(function(){
        $(this).css("-webkit-transition", "all "+tp+"ms "+ev);
        $(this).css("-moz-transition", "all "+tp+"ms "+ev);
        $(this).css("-ms-transition", "all "+tp+"ms "+ev);
        $(this).css("-o-transition", "all "+tp+"ms "+ev);
        $(this).css("transition", "all "+tp+"ms "+ev);
    });
};

// Corrige o problema de falta de scroll em divs no Android 2.x, colocando a classe .scrollable
jQuery.fn.android2xScrollCorrection = function(){
    return this.each(function(){

        var versao = navigator.userAgent.substr(navigator.userAgent.toLowerCase().indexOf("android")+"android".length+1, 5);
        if (versao[0] == "2" && navigator.userAgent.toLowerCase().indexOf("android") > -1) {
            $(this).bind("touchstart", function(evt) {
                var touchobj = evt.originalEvent.changedTouches[0];
                starty = $(this).scrollTop()+touchobj.pageY;

            });

            $(this).bind("touchmove", function(evt) {
                if (!dragMenu) {
                    evt.preventDefault();
                    var touchobj = evt.originalEvent.changedTouches[0];

                    var expr = starty-touchobj.pageY;
                    $(this).scrollTop(expr);
                }

            });

        }



    });
};


//compnente de atualização por drag and drop
var isDraggingPullToRefresh = false;
jQuery.fn.pullToRefresh = function( options , wrap ) {
    var touchInitialPos = 0;
    var touchFinalPos = 0;
    var colseAnimationSpeed = 200;

    var scrollLocker = false;
    isDraggingPullToRefresh = false;

    var pullhack = "";
    if(wrap) pullhack = 'style="top:0px;"';
    if(wrap && configs.actualPageHasTabs()) pullhack = 'style="top:50px;"';
    if(!wrap && configs.actualPageHasTabs()) pullhack = 'style="top:100px;"';

    var isTouch = !!('ontouchstart' in window),
        cfg = $.extend(true, {
          message: {
            pull: configs.getLoadingMessage("pull"),
            release: configs.getLoadingMessage("release"),
            loading: configs.getLoadingMessage("loading")
            }
        }, options),
        html = '<div class="pull-to-refresh" '+pullhack+'>' +
            '<div class="icon"></div>' +
                '<div class="message">'+
                    '<i class="arrow"></i>'+
                    '<i class="spinner"></i>'+
                    '<span class="pull">' + cfg.message.pull + '</span>' +
                    '<span class="release">' + cfg.message.release + '</span>' +
                    '<span class="loading">' + cfg.message.loading + '</span>' +
                '</div>' +
            '</div>';


        $(this).parent().append(html);
        if(!wrap){
          $(this).html("<div class='wrap' id='"+pageNow+"Wrap'>"+$(this).html()+'</div><div class="space-nav-bottom hack wrap-hack"></div>');
        }


    return this.each(function() {
        if (!isTouch) {
            return;
        }

        var e = $(this),
            content = e.find('.wrap'),
            ptr = e.parent().find('.pull-to-refresh'),
            arrow = e.parent().find('.arrow'),
            spinner = e.parent().find('.spinner'),
            pull = e.parent().find('.pull'),
            release = e.parent().find('.release'),
            loading = e.parent().find('.loading'),
            ptrHeight = ptr.height(),
            arrowDelay = ptrHeight / 3 * 2,
            isActivated = false,
            isLoading = false;

        ptr.hide();

        content.on('touchstart', function (ev) {
            if (isLoading) { // se ja estiver acrregando não fazer nada
                return true;
            }
            if(ev.originalEvent.touches.length >1){// previne o duplo touch
                return false;
            }

            ptr.hide();
            arrow.hide();
            spinner.hide();
            pull.hide();
            release.hide();
            loading.hide();
            scrollLocker = false;
            isDraggingPullToRefresh = false;
            var touchobj = ev.originalEvent.changedTouches[0];
            starty = touchobj.pageY;
            touchInitialPos = content.offset().top-touchobj.pageY;
            touchFinalPos   = content.offset().top + 50;
            content.addAnimation(0, "ease");
        }).on('touchmove', function (ev) {

            if (isLoading || generalLoading || isAnimating) { // se ja estiver acrregando ou animando não fazer nada
                return false;
            }

            var touchobj = ev.originalEvent.changedTouches[0];
            if (e.scrollTop() === 0 && (starty-touchobj.clientY) < 0) {
                scrollLocker = true;
                isDraggingPullToRefresh = true;
            }else {
                scrollLocker = false;
                isDraggingPullToRefresh = false;
                return true;
            }

            if (cfg.hasTab) {
                if(cfg.hasTab == "search") var expr = (touchobj.pageY+touchInitialPos) - 65;
                else var expr = (touchobj.pageY+touchInitialPos) - 66;
            }
            else var expr = (touchobj.pageY+touchInitialPos) - 13;

            var h = $.getWindowSize()["h"];
            /*
            var exprAux = expr;
            expr = (150 * (expr / h));
            $("h1").html(exprAux + " " + expr + " " + h);
            */
            //$("h1").html(expr);
            var pos = expr-50;
            var deg = ((180 *pos) / touchFinalPos);
            if (deg > 180) {
                deg = 180;
            }else {
                if (deg < 0) {
                    deg = 0;
                }
            }

            deg += 180;

            arrow.show();
            arrow.css('transform', 'rotate('+ deg + 'deg)'); //move arrow
            //spinner.hide();


            if (dragMenu) {
                return true;
            }

            if (ptr.css("display") == "none") {
                ptr.show();
            }



            if (scrollLocker) {
                ev.preventDefault();

                //Move o conteudo de acordo com o drag
                var h = $.getWindowSize()["h"];
                var contentMove = (150 * ((expr-54) / h));
                //$("h1").html(contentMove + " " + expr + " " + h);
                content.css("margin-top", (contentMove)+"px");

                if ((touchFinalPos+120) >= expr) { //Puxando

                    var posSeta = expr;
                    if (posSeta > 104) {
                        posSeta = 104;
                    }
                        //ptr.css('margin-top', posSeta+"px");




                    //release.hide();
                    //loading.show();
                    pull.show();


                    isActivated = false;

                }else { //Soltar para abrir

                    //release.show();
                    pull.show();
                    //loading.show();

                    isActivated = true;

                }

            }



        }).on('touchend', function(ev) {
            if (ev.originalEvent.touches.length >= 1) {
                return false;
            }

            var top = e.scrollTop();
            scrollLocker = false;
            isDraggingPullToRefresh = false;

            if (isActivated) {// ao terminar fica carregando
                content.addAnimation(colseAnimationSpeed, "ease");
                ptr.css('position', 'static');
                ptr.css('margin-top', "0px");
                content.css("margin-top", "0px");

                isLoading = true;
                isActivated = false;

                //release.hide();
                //pull.show();
                //loading.show();

                //arrow.show();
                //spinner.show();

                //$(".eventDisplay").css("opacity","");
                //configs.jPages[configs.getPageNow()].find(".wrap").find("*").css("opacity", "");
                //$("#slide").animate({width:'toggle'},350);
                cfg.callback().done(function() {
                    ptr.animate({
                        height: 10
                    }, 'fast', 'linear', function () {
                        ptr.css({
                            position: 'absolute',
                            height: ptrHeight
                        });
                        isLoading = false;
                        ptr.hide();
                    });
                });
            }else { //se soltar sem carregar
                content.addAnimation(colseAnimationSpeed, "ease");
                ptr.css('position', 'absolute');
                ptr.css('margin-top', "0px");
                content.css("margin-top", "0px");
                ptr.hide();

            }

        });
    });

};

jQuery.convertImgToBase64URL = function(url, callback){
    outputFormat = "image/jpg";
    var img = new Image();
    img.crossOrigin = 'Anonymous';
    img.onload = function(){
        var canvas = document.createElement('CANVAS'),
        ctx = canvas.getContext('2d'), dataURL;
        canvas.height = this.height;
        canvas.width = this.width;
        ctx.drawImage(this, 0, 0);
        dataURL = canvas.toDataURL(outputFormat);
        callback(dataURL);
        canvas = null;
    };
    img.src = url;
}

jQuery.galleryDownload = function(){
    var actualImage = positionX/size['w'];
    //alert(actualImage);
    if($.isArray(galleryImageArray) && galleryImageArray.length > actualImage){
        //var urlImage = galleryImageArray[actualImage].split("?");
        //urlImage = urlImage[0] + "?" + encodeURIComponent(urlImage);
        //var urlImage = "https://upload.wikimedia.org/wikipedia/commons/c/cd/Panda_Cub_from_Wolong,_Sichuan,_China.JPG";//galleryImageArray[actualImage];
        var urlImage = galleryImageArray[actualImage];

        $.convertImgToBase64URL(urlImage, function(base64Img){
            var photoname = galleryImageArray[actualImage].split("?");
            photoname = photoname[0].split("/");
            if(photoname.length > 1){
                photoname = photoname[photoname.length-1];
            } else {
                photoname = "photo.jpg";
            }

            window.plugins.socialsharing.share(null, 'Android filename', base64Img, null);
            //window.plugins.socialsharing.share(null, 'Android filename', 'data:image/png;base64,'+base64Img, null);
        });
        //alert(urlImage);
        //alert('window.plugins.socialsharing.share(null, null, '+galleryImageArray[actualImage]+', null);');
        //window.plugins.socialsharing.share(null, null, urlImage, null);
        //alert(actualImage + " --- " + galleryImageArray[actualImage]);
    }
}

var galleryImageArray = null;
var positionX = 0;
//Componente de galeria de imagem
jQuery.fn.dGallery = function(imageArray, listPostStart) {
    var touches = 0; var width = 300; var height = 300; var rotation = 0; var touchStartPosX = null;


    if (imageArray == "update") {

        if ($(".dhoneGallery").length){

            var redimentionImgs     = 0.95;
            var dGallery            = $(".dhoneGallery");

            var galleryContainer    = dGallery.find("div.dhoneGalleryContainer");
            var galleryScroll       = dGallery.find("div.dhoneGalleryScroll");
            var imgsFrame           = dGallery.find("div.dgalleryImg");
            var imgs                = dGallery.find("img.dgalleryImgContent");
            var miniGallery         = dGallery.find("div.dhoneGalleryImgList");

            var accPage = Math.round(galleryScroll.scrollLeft()/dGallery.width());

            var size    = $.getWindowSize();

            dGallery.width(size["w"]);
            dGallery.height(size["h"]);
            galleryScroll.width(size["w"]);
            galleryScroll.height(size["h"]);

            miniGallery.css("margin-top", (size["h"]-miniGallery.height()-10));
            miniGallery.width(size["w"]);

            galleryContainer.width(size["w"]*imgs.length);
            imgsFrame.width(size["w"]);
            imgsFrame.height(size["h"]);

            galleryScroll.scrollLeft(accPage*size["w"]);

            imgs.each(function() {
                if ($(this).width() > $(this).height()) { // imagens para ser grande em portrat
                    if (size["w"] > size["h"]) { //portrat
                        $(this).width(((size["w"]*0.8)*redimentionImgs)+"px");
                        $(this).height((size["h"]*redimentionImgs)+"px");


                    }else { // normal
                        $(this).width((size["w"]*redimentionImgs)+"px");
                        $(this).height(((size["w"]*0.6)*redimentionImgs)+"px");

                    }

                }else if ($(this).width() == $(this).height()) {
                    if (size["w"] > size["h"]) { //portrat
                        $(this).width((size["h"]*redimentionImgs)+"px");
                        $(this).height((size["h"]*redimentionImgs)+"px");


                    }else { // normal
                        $(this).width((size["w"]*redimentionImgs)+"px");
                        $(this).height((size["w"]*redimentionImgs)+"px");

                    }

                }else { // imagens para ser grande normal
                    if (size["w"] > size["h"]) { //portrat
                        $(this).width(((size["h"]*0.8)*redimentionImgs)+"px");
                        $(this).height((size["h"]*redimentionImgs)+"px");

                    }else { // normal
                        $(this).width((size["w"]*redimentionImgs)+"px");
                        $(this).height((size["h"]*redimentionImgs)+"px");

                    }

                }
            });

        }else {
            return false;

        }


    }else {//FIM DO UPDATE


        var size    = $.getWindowSize();

        if ($.isArray(imageArray)) {
            galleryImageArray = imageArray;
            var images      = "";
            var imagesSmall = "";
            for (img in imageArray) {
                images += "<div class='dgalleryImg' align='center' style='width: "+size["w"]+"px; height: "+size["h"]+"px;'><img src='"+imageArray[img]+"' class='dgalleryImgContent' width='95%' border='0' /></div>";
                imagesSmall += "<div id='dhoneMiniGaleryImg"+img+"' ref='"+img+"' class='dhoneGalleryThumbList' style='background-image: URL("+imageArray[img]+");'></div>";
            };

            //retirado as miniaturas
            imagesSmall = '';//'<button class="btn btn-download" onclick="$.galleryDownload();"><i class="icon-share"></i>Compartilhar</button>';

            if ($(".dhoneGallery").length){
                var dGallery = $(".dhoneGallery");
                dGallery.find("div.dhoneGalleryContainer").html(images).width(size["w"]*imageArray.length);
                dGallery.find("div.dhoneGalleryImgListScroll").html(imagesSmall);

            }else {
                var dGallery = $("<div class='dhoneGallery'>"+
                                    '<button type="button" class="btn-close-photo"><i class="mdi mdi-close-circle"></i></button>'+
                                    //"<a href='javascript: void(0);' class='dgalleryBtnClose transparent'><i class='icon-no'></i></a>"+
                                    "<div class='dhoneGalleryScroll'>"+
                                        "<div style='width: "+(size["w"]*imageArray.length)+"px;' class='dhoneGalleryContainer'>"+/*images+*/
                                        "</div>"+
                                    "</div>"+
                                    "<div class='dhoneGalleryImgList'>"+
                                        "<div class='dhoneGalleryImgListScroll'>"+imagesSmall+"</div>"+
                                    "</div>"+
                                    //INChERTO COM O BOTÃO DE DOWNLOAD --------------------------------------------------------------------------------------
                                    '<button class="btn btn-download" tfunc="$.galleryDownload();" style="z-index:999;"><i class="mdi mdi-share-variant"></i>Compartilhar</button>'+
                                "</div>"
                                );
                $.dhoneStartCTEvents(dGallery);
            }

        }else if(imageArray == "close"){
            if ($(".dhoneGallery").length){
                var dGallery = $(".dhoneGallery");
                $(document).unbind("backbutton");
                $(document).bind("backbutton", function(evt) { $.dhoneBack(); });
                dGallery.fadeOut(300, function() {
                    dGallery.remove();
                });
            }else {
                return false;
            }

        }


    }



    var claseButton         = dGallery.find(".btn-close-photo");//dGallery.find("a.dgalleryBtnClose");
    var shareButton         = dGallery.find(".btn-download");
    var galleryContainer    = dGallery.find("div.dhoneGalleryContainer");
    var galleryScroll       = dGallery.find("div.dhoneGalleryScroll");
    var imgsFrame           = dGallery.find("div.dgalleryImg");
    var imgs                = dGallery.find("img.dgalleryImgContent");
    var miniGallery         = dGallery.find("div.dhoneGalleryImgList");
    var miniGalleryScroll   = dGallery.find("div.dhoneGalleryImgListScroll");
    var isFastTouch         = null;

    dGallery.width(size["w"]);
    dGallery.height(size["h"]);
    galleryScroll.width(size["w"]);
    galleryScroll.height(size["h"]);
    miniGallery.width(size["w"]);
    //miniGalleryScroll.width(72*imageArray.length);


    return this.each(function() {
        $(this).append(dGallery);
        dGallery.fadeIn(300, function() {
            dGallery.find("div.dhoneGalleryContainer").html(images).width(size["w"]*imageArray.length);
            dGallery.find("div.dhoneGalleryImgListScroll").html(imagesSmall);



            $(document).unbind("backbutton");
            $(document).bind("backbutton", function(evt) {
                evt.preventDefault();
                $(document).unbind("backbutton");
                $(document).bind("backbutton", function(evt) { $.dhoneBack(); });
                dGallery.fadeOut(300, function() {
                    dGallery.remove();
                });

                return false;
            });


            miniGallery.css("margin-top", (size["h"]-miniGallery.height()-10));

            if (listPostStart) {
                if (listPostStart < 1) {
                    listPostStart = 1;
                }else if (listPostStart > imageArray.length) {
                    listPostStart = imageArray.length;
                }

                listPostStart -= 1;

                galleryScroll.scrollLeft(listPostStart*size["w"]);

                miniGallery.find(".dhoneGalleryThumbList").removeClass("active");
                $("#dhoneMiniGaleryImg"+listPostStart).addClass("active");

                //var miniListPos = $("#dhoneMiniGaleryImg"+listPostStart).offset().left;
                //miniGallery.scrollLeft(miniListPos);

                positionX = listPostStart*size["w"]

            }else {
                miniGallery.find(".dhoneGalleryThumbList:first").addClass("active");

                positionX = 0;
            }


            miniGallery.find(".dhoneGalleryThumbList").unbind("click");
            miniGallery.find(".dhoneGalleryThumbList").bind("click", function(evt) {
                miniGallery.find(".dhoneGalleryThumbList").removeClass("active");
                $(this).addClass("active");
                galleryScroll.animate({scrollLeft: $(this).attr("ref")*size["w"]}, 300);
                return false;
            });

            imgs.unbind("load");
            imgs.bind("load", function() {
                if ($(this).width() > $(this).height()) { // imagens para ser grande em portrat
                    if (size["w"] > size["h"]) { //portrat
                        $(this).width(((size["w"]*0.8)*redimentionImgs)+"px");
                        $(this).height((size["h"]*redimentionImgs)+"px");


                    }else { // normal
                        $(this).width((size["w"]*redimentionImgs)+"px");
                        $(this).height(((size["w"]*0.6)*redimentionImgs)+"px");

                    }

                }else if ($(this).width() == $(this).height()) {
                    if (size["w"] > size["h"]) { //portrat
                        $(this).width((size["h"]*redimentionImgs)+"px");
                        $(this).height((size["h"]*redimentionImgs)+"px");


                    }else { // normal
                        $(this).width((size["w"]*redimentionImgs)+"px");
                        $(this).height((size["w"]*redimentionImgs)+"px");

                    }

                }else { // imagens para ser grande normal
                    if (size["w"] > size["h"]) { //portrat
                        $(this).width(((size["h"]*0.8)*redimentionImgs)+"px");
                        $(this).height((size["h"]*redimentionImgs)+"px");

                    }else { // normal
                        $(this).width((size["w"]*redimentionImgs)+"px");
                        $(this).height((size["h"]*redimentionImgs)+"px");

                    }

                }

            });


            var galleryTouchStart = 0;
            var galleryActualPage = 0;
            //Responsável pela passagem de imagens com drag
            galleryScroll.unbind("touchstart touchmove touchend");
            galleryScroll.bind("touchstart touchmove touchend", function(evt){
                var orig = evt.originalEvent;

                if(evt.type == 'touchstart'){
                    if(orig.touches.length == 1){
                        var touchobj = orig.changedTouches[0];
                        galleryTouchStart = touchobj.clientX;
                        galleryActualPage = Math.round($(this).scrollLeft()/size["w"]);

                        touchStartPosX = $(this).scrollLeft()+touchobj.pageX;
                    }else if(orig.touches.length == 2){
                        return false;
                    }
                }else if(evt.type == 'touchmove'){
                    if(orig.touches.length == 1){
                        evt.preventDefault();
                        var touchobj = orig.changedTouches[0];

                        var expr = touchStartPosX-touchobj.pageX;
                        $(this).scrollLeft(expr);
                    }
                }else if(evt.type == 'touchend') {
                    if(orig.touches.length == 0){
                        //galleryTouchStart;
                        var touchobj = orig.changedTouches[0];
                        var galleryTouchFinal = touchobj.clientX;

                        var galleryScroll = (galleryTouchFinal - galleryTouchStart) / size['w'];

                        var listPos = galleryActualPage;
                        if(galleryScroll < -0.2){
                            listPos++;
                        }
                        if(galleryScroll > 0.2){
                            listPos--;
                        }

                        //var listPos = Math.round($(this).scrollLeft()/size["w"]);
                        $(this).animate({scrollLeft: listPos*size["w"]}, 300, function(){
                            var listPos = Math.round($(this).scrollLeft()/size["w"]);
                            positionX = listPos*size["w"];
                        });
                        miniGallery.find(".dhoneGalleryThumbList").removeClass("active");
                        $("#dhoneMiniGaleryImg"+listPos).addClass("active");

                        var miniListPos = $("#dhoneMiniGaleryImg"+listPos).offset().left;
                        miniGallery.animate({scrollLeft: miniListPos}, 100);
                    }
                }


            });

            /*
            $(".dgalleryImg").bind("touchstart touchmove touchend", function(e){
                var orig = e.originalEvent;

                if(e.type == 'touchstart'){
                    if(orig.touches.length == 1){
                        touches = 1;
                        var touchobj = orig.changedTouches[0];
                        touchStartPosX = $(this).scrollTop()+touchobj.pageX;
                    }else if(orig.touches.length == 2){
                        touches = 2;
                    }
                }else if(e.type == 'touchmove'){
                    e.preventDefault();
                    if(touches == 2){
                        $(this).css("width", parseFloat(width) * orig.scale);
                        $(this).css("height", parseFloat(height) * orig.scale);
                        $(this).css("-webkit-transform","rotate(" + ((parseFloat(rotation) + orig.rotation) % 360) + "deg)");
                    }else if (touches == 1) {
                        e.preventDefault();
                        var touchobj = orig.changedTouches[0];

                        var expr = touchStartPosX-touchobj.pageX;
                        dGallery.scrollLeft(expr);
                    }
                }
            });
            */

            claseButton.unbind("click");
            claseButton.bind("click", function() {
                $(document).unbind("backbutton");
                $(document).bind("backbutton", function(evt) { $.dhoneBack(); });
                dGallery.fadeOut(300, function() {
                    dGallery.remove();
                });
                return false;
            });


            dGallery.unbind("click");
            dGallery.bind("click", function(evt) {


                if (claseButton.css("display") == "none") {
                    claseButton.fadeIn(200);
                    miniGallery.fadeIn(200);
                    shareButton.fadeIn(200);
                }else {
                    claseButton.fadeOut(200);
                    miniGallery.fadeOut(200);
                    shareButton.fadeOut(200);
                }


            });


        });



    });
}

//EXTRA FACEBOOK
jQuery.fbInit = function(app_id) {
    window.fbAsyncInit = function() {
        FB.init({
            appId      : app_id, // App ID
            status     : true, // check login status
            cookie     : true, // enable cookies to allow the server to access the session
            xfbml      : true  // parse XFBML
        });
    };

    // Load the SDK Asynchronously
    (function(d){
        var js, id = 'facebook-jssdk'; if (d.getElementById(id)) {return;}
        js = d.createElement('script'); js.id = id; js.async = true;
        js.src = "http://connect.facebook.net/en_US/all.js";
        d.getElementsByTagName('head')[0].appendChild(js);
    }(document));

    $('<div />').attr('id','fb-root').appendTo('body');
};

//Função padrão de navegação para links externos não abrirem dentro do navegador da aplicação
jQuery.openUrl = function(URL, external) {
    external = typeof external !== 'undefined' ? external : false;
    if(($.isIos() || $.isAndroid()) && !external )
        window.open(URL, "_blank", "closebuttoncaption=Fechar");
    else
        window.open(URL, "_system");
}

//Simula o place holder para um componente de texto
jQuery.fn.dhonePlaceHolder = function(text) {
    var textToHold = text;
    return this.each(function() {

        $(this).unbind("focus blur");
        $(this).val("");

        $(this).bind("focus", function() {
            $(this).removeClass("dhonePlaceholder");
            //$(".icon-search-input").hide();
            if ($.trim($(this).val()) == textToHold) {
                $(this).val("");

            }

        });

        $(this).bind("blur", function() {
            if ($.trim($(this).val()) == "") {
                $(".icon-search-input").show();
                $(this).addClass("dhonePlaceholder");
                $(this).val(textToHold);

            }

        });


        $(this).trigger("blur");

    });
}

//abre e fecha o modal
jQuery.fn.dhoneModal = function(action) {

    return this.each(function() {

        var modalBg = $(this);
        if (action == "show") {
            modalBg.fadeIn(200, function() {
                modalBg.find(".modal").fadeIn(400);

            });

        }else if (action == "hide") {

            modalBg.find(".modal").fadeOut(200, function() {modalBg.fadeOut(400);});

        }



    });

}

//adiciona uma imagem para a execução do preloader caso o preloader não esteja em execução ela tambem da inicio
jQuery.dhonePreloadPush = function(image) {
    imgsToPreload.push(image);

    if (!isPreloading) {
        $.dhonePreloadActionStart();
    }

}

//Carregando a imagem no aplicativo
jQuery.dhonePreloadActionStart = function() {

    if (imgsToPreload.length > 0) {
        var imgPath = imgsToPreload.shift();
        var image = new Image();
        image.onload = function() {
            $.dhonePreloadActionStart();
        };
        image.src = imgPath;
        isPreloading = true;

    }else {
        isPreloading = false;
    }

}

jQuery.dhoneLinkify = function(text) {

    var SCHEME = "[a-z\\d.-]+://";
    var IPV4 = "(?:(?:[0-9]|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5])\\.){3}(?:[0-9]|[1-9]\\d|1\\d{2}|2[0-4]\\d|25[0-5])";
    var HOSTNAME = "(?:(?:[^\\s!@#$%^&*()_=+[\\]{}\\\\|;:'\",.<>/?]+)\\.)+";
    var TLD = "(?:ac|ad|aero|ae|af|ag|ai|al|am|an|ao|aq|arpa|ar|asia|as|at|au|aw|ax|az|ba|bb|bd|be|bf|bg|bh|biz|bi|bj|bm|bn|bo|br|bs|bt|bv|bw|by|bz|cat|ca|cc|cd|cf|cg|ch|ci|ck|cl|cm|cn|coop|com|co|cr|cu|cv|cx|cy|cz|de|dj|dk|dm|do|dz|ec|edu|ee|eg|er|es|et|eu|fi|fj|fk|fm|fo|fr|ga|gb|gd|ge|gf|gg|gh|gi|gl|gm|gn|gov|gp|gq|gr|gs|gt|gu|gw|gy|hk|hm|hn|hr|ht|hu|id|ie|il|im|info|int|in|io|iq|ir|is|it|je|jm|jobs|jo|jp|ke|kg|kh|ki|km|kn|kp|kr|kw|ky|kz|la|lb|lc|li|lk|lr|ls|lt|lu|lv|ly|ma|mc|md|me|mg|mh|mil|mk|ml|mm|mn|mobi|mo|mp|mq|mr|ms|mt|museum|mu|mv|mw|mx|my|mz|name|na|nc|net|ne|nf|ng|ni|nl|no|np|nr|nu|nz|om|org|pa|pe|pf|pg|ph|pk|pl|pm|pn|pro|pr|ps|pt|pw|py|qa|re|ro|rs|ru|rw|sa|sb|sc|sd|se|sg|sh|si|sj|sk|sl|sm|sn|so|sr|st|su|sv|sy|sz|tc|td|tel|tf|tg|th|tj|tk|tl|tm|tn|to|tp|travel|tr|tt|tv|tw|tz|ua|ug|uk|um|us|uy|uz|va|vc|ve|vg|vi|vn|vu|wf|ws|xn--0zwm56d|xn--11b5bs3a9aj6g|xn--80akhbyknj4f|xn--9t4b11yi5a|xn--deba0ad|xn--g6w251d|xn--hgbk6aj7f53bba|xn--hlcj6aya9esc7a|xn--jxalpdlp|xn--kgbechtv|xn--zckzah|ye|yt|yu|za|zm|zw)";
    var HOST_OR_IP = "(?:" + HOSTNAME + TLD + "|" + IPV4 + ")";
    var PATH = "(?:[;/][^#?<>\\s]*)?";
    var QUERY_FRAG = "(?:\\?[^#<>\\s]*)?(?:#[^<>\\s]*)?";
    var URI1 = "\\b" + SCHEME + "[^<>\\s]+";
    var URI2 = "\\b" + HOST_OR_IP + PATH + QUERY_FRAG + "(?!\\w)";
    var MAILTO = "mailto:";
    var EMAIL = "(mailto:)?(mailto: )?([a-zA-Z0-9_\\-\\.]+)@((\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.)|(([a-zA-Z0-9\\-]+\\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})";
    var TEL = "tel:";
    var PHONE = "(\\(\\d{2,3}\\) )?(\\(\\d{2,3}\\))?(\\d)?(\\d )?\\d{4,5}( |-|.)?\\d{4,5}|^\\d{2,3}( |-|.)?\\d{4,5}( |-|.)?\\d{4,5}";
    var PHONE_T = /(\(\d{2,3}\) )?(\(\d{2,3}\))?(\d)?(\d )?\d{4,5}( |-|.)?\d{4,5}|^\d{2,3}( |-|.)?\d{4,5}( |-|.)?\d{4,5}/;

    var URI_RE = new RegExp( "(?:" + URI1 + "|" + URI2 + "|" + EMAIL + "|" + PHONE + ")", "ig" );
    var SCHEME_RE = new RegExp(SCHEME, "i" );
    var finalTag;

    var lastIndex = "first";
    var textToReturn = "";
    var finalText = "";

    while ( arr = URI_RE.exec( text ) ) {
        link = arr[0];
        idx_last = URI_RE.lastIndex;
        idx = idx_last - link.length;

        word = link;
        finalTag = "";

        if (!SCHEME_RE.test( word )) {
            if (word.indexOf( '@' ) !== -1) {
                //EMAILS
                if (!word.indexOf(MAILTO)) {
                    finalTag = "";
                }else {
                    finalTag = MAILTO;
                }
                finalTag += word;
                finalTag = "<a href='"+finalTag+"'>"+word+"</a>";

            }else if(PHONE_T.test(word)) {
                //TELEFONES
                finalTag = TEL;
                finalTag += word;
                finalTag = "<a href='"+finalTag+"'>"+word+"</a>";

            }else {
                //LINKS
                finalTag = "http://";
                finalTag += word;
                finalTag = "<a href=\"javascript: $.openUrl('"+finalTag+"');\">"+word+"</a>";

            }
        } else {
            finalTag = "<a href=\"javascript: $.openUrl('"+word+"');\">"+word+"</a>";
        }

        if (lastIndex == "first") {
            textToReturn += text.substr(0, idx) + finalTag;
        }else {
            textToReturn += text.substr(lastIndex, idx-lastIndex) + finalTag;
        }
        lastIndex = idx_last;
        finalText = text.substr(idx_last);

    }

    if($.trim(textToReturn) == ""){
        return text;
    } else {
        textToReturn += finalText;
    }

    return textToReturn;
}

//var cComponentsArrayLocal;
var cAgenda = true;
var cListas = false;
var cIngresso = false;
var cUsuarios = false;
var cCardapio = false;
var cFacebook = false;
var cInstitucional = false;
var cPhotos = false;
var cNews = false;
var cLikes = false;
jQuery.getDhoneComponents = function(cComponentsArray, callback){
    window.localStorage.setItem('cComponentsArray', cComponentsArray);

    if($.inArray("events", cComponentsArray)>-1){
        cAgenda = true;
        if($.inArray("lists", cComponentsArray)>-1){
            cListas = true;
        }
        if($.inArray("tickets", cComponentsArray)>-1){
            cIngresso = true;
        }
    }

    if($.inArray("users_app", cComponentsArray)>-1){
        cUsuarios = true;
    } else {
        $("#initUsuarios").hide();
    }
    if($.inArray("menu", cComponentsArray)>-1){
        cCardapio = true;
    } else {
        $("#initCardapio").hide();
    }
    if($.inArray("feed", cComponentsArray)>-1){
        cFacebook = true;
    } else {
        $("#initFacebook").hide();
    }
    if($.inArray("institutional", cComponentsArray)>-1){
        cInstitucional = true;
    } else {
        $("#initInstitucional").hide();
    }
    if($.inArray("photos", cComponentsArray)>-1){
        cPhotos = true;
    } else {
        $("#initPhotos").hide();
    }
    if($.inArray("posts", cComponentsArray)>-1){
        cNews = true;
    } else {
        $("#initNews").hide();
    }

    if($.inArray("likes", cComponentsArray)>-1){
        cLikes = true;
    } else {
        $("#initLikes").hide();
    }

    callback();
    //TODO messages = push
}

jQuery.dhoneInitComponents = function(callback){
    //$.getDhoneComponents(["events","tickets","menu","institutional","feed","users_app","messages","lists","participant","dashboard"]);
    //$.getDhoneComponents(["events","feed", "list", "institutional"]);
    $.ajax(serverURL+"modules/"+clientId+"?version=2", {timeout:'6000'})
        .done(function(json) {
            appType=json.type;
            window.localStorage.setItem("appType", appType);
            $.getDhoneComponents(json.modules,callback);
        })
         .fail(function() {
            if(window.localStorage.getItem("appType"))
                appType = window.localStorage.getItem("appType");
            var cComponentsArray = window.localStorage.getItem('cComponentsArray');
            if(cComponentsArray){
                var modules = cComponentsArray.split(",");
                $.getDhoneComponents(modules,callback);
            } else {
                alert( "Que pena! Não foi possível se conectar por problemas de Internet ou servidor. Aperte OK para tentar novamente ou feche o app para tentar mais tarde." );
                $.dhoneInitComponents(callback);
            }
        })
    /*
    $.server("modules/"+clientId, function(json){
        $.getDhoneComponents(json,callback);
    }, true);
    */
}

jQuery.alerta = function(){
    alert("alerta");
}

jQuery.convertDate = function(date){
    return date.substr(8,2)+"/"+date.substr(5,2)+"/"+date.substr(0,4);
}

jQuery.convertHour = function(date){
    return date.substr(11,2)+"h"+((date.substr(14,2) == "00")? "" : date.substr(14,2));
}


var timeFade = 300;
var delayFade =150;
var perspective = 650;
var modalinit = false;
var modalFlip = false; // false caso o lado A seja o de cima
var modalOppened = false;
var modalFlipped = 0;
jQuery.modalShow = function(modal,cb) {
    //$("body").css({"position":"fixed" , "overflow" : "hidden"});

    if(!modalinit){
        var tela = $.getWindowSize();
        var xModal = tela["w"] * 80 / 100;
        var marginXModal = tela["w"] / 10;
        var marginYModal = tela["h"] / 10;

        $(".flip-container").css("margin-top",marginYModal);
        $(".flip-container").css("margin-left",marginXModal);
        $(".flip-container").css("width",xModal);
        $(".front").css("width",xModal);
        $(".back").css("width",xModal);

        modalinit = true;
    }

    if(modalOppened){
        modalFlip = !modalFlip;
        $.modalChangeModal(modal, function(){
            if (cb) { cb(); }

            modalFlipped += 1;

            var rotatePos = modalFlipped * 180;

            var transformAttributesA = "scale(1) perspective("+perspective+"px) rotateY(" + rotatePos + "deg)";
            var transformAttributesB = "scale(1) perspective("+perspective+"px) rotateY(" + (rotatePos + 180) + "deg)";

            $("#modalA").css({"transform": transformAttributesA, "-webkit-transform":transformAttributesA});
            $("#modalB").css({"transform": transformAttributesB, "-webkit-transform":transformAttributesB});

            $("#modalB").one("transitionend webkitTransitionEnd", function(){
                var modaltoflip = "#modalA";
                if(!modalFlip){ modaltoflip = "#modalB"; }
                $(modaltoflip).html("");
            });
        });
    } else {

        //$.dhoneUpdate();
        //$.slideMenu(size, configs.getContentSizeOnAside(), 80);

        $.modalChangeModal(modal, function(){
            if(cb) { cb(); }

            var modalBg = $("#dhoneModal");
            modalBg.fadeIn(timeFade);//, function() {
            setTimeout(function(){
                var transformAttributesA = "scale(1) perspective("+perspective+"px) ";
                var transformAttributesB = transformAttributesA;
                var rotatePos = modalFlipped * 180;
                transformAttributesA += "rotateY(" + rotatePos + "deg)";
                transformAttributesB += "rotateY(" + (rotatePos + 180) + "deg)";

                $("#modalA").css({"transform":transformAttributesA, "-webkit-transform":transformAttributesA, "opacity": 1});
                $("#modalB").css({"transform":transformAttributesB, "-webkit-transform":transformAttributesB, "opacity": 1});

            }, delayFade);
        });
    }

    modalOppened = true;
}

jQuery.modalChangeModal = function(modal, callback){
    var modaltoflip;
    if(modalFlip){
        modaltoflip = "#modalB";
    } else {
        modaltoflip = "#modalA";
    }

     $.post("./js/modal/"+modal+".html", function(data) {
        $(modaltoflip).html(data);

        callback();

        $.dhoneStartCTEvents("#dhoneModal");
        /*
        var modalBg = $("#dhoneModal");
        modalBg.fadeIn(75, function() {
            modalBg.find(".flipper").slideDown(425);
        });
        */
    });
}

jQuery.modalHide = function(cb) {
    var modalBg = $("#dhoneModal");

    setTimeout(function(){
        modalBg.fadeOut(timeFade, function(){
            if(cb){cb();}
        });
    }, delayFade);

    var transformAttributesA = "scale(0.7) perspective("+perspective+"px) ";
    var transformAttributesB = transformAttributesA;
    var rotatePos = modalFlipped * 180;
    transformAttributesA += "rotateY(" + rotatePos + "deg)";
    transformAttributesB += "rotateY(" + (rotatePos + 180) + "deg)";

    $("#modalA").css({"transform":transformAttributesA, "-webkit-transform":transformAttributesA, "opacity": 0});
    $("#modalB").css({"transform":transformAttributesB, "-webkit-transform":transformAttributesB, "opacity": 0});

    //modalBg.find(".modal").removeClass("show");
    //modalBg.removeClass("show");

    /*$(modalBg.find("#modalB")).one("transitionend" , function(){
    });*/

    //$("body").css({"position":"" , "overflow" : ""});
    //$.dhoneUpdate(true);
    modalOppened = false;
}

jQuery.helpShow = function(help) {
    console.log(help);
    $.post("./js/help/"+help+".html", function(data) {
        $("#dhoneHelp").html(data);

        //callback();
        $.dhoneStartCTEvents("#dhoneHelp");

        $("#dhoneHelp").fadeIn(fadeTime);
    });
}

jQuery.helpHide = function(help){
    $("#dhoneHelp").fadeOut(fadeTime);
}

jQuery.showMsg = function(title, message){
    $.modalShow("msg", function(){
        $("#mainMessageTitle").html(title);
        $("#mainMessage").html(message);
    });
}

jQuery.modalChoice = function(title, message, callbackYes, callbackNo){
    $.modalShow("choice", function(){
        $("#choiceMessageTitle").html(title);
        $("#choiceMessage").html(message);

        if(callbackYes){
            $("#choiceYes").dhoneBind(function(){
                callbackYes();
                $.modalHide();
            });
        } else {
            $("#choiceYes").dhoneBind(function(){
                $.modalHide();
            });
        }

        if(callbackNo){
            $("#choiceNo").dhoneBind(function(){
                callbackNo();
                $.modalHide();
            });
        } else {
            $("#choiceNo").dhoneBind(function(){
                $.modalHide();
            });
        }

    });
}

var alertDeffered = [];
var alertTimeOut = null;
jQuery.alertOpen = function(title, message){
  //var oldAlertDeffered = alertDeffered;
  var alertDefferedAux = $.Deferred();
  alertDefferedAux.promise();
  alertDeffered.push(alertDefferedAux);
  if (alertDeffered.length > 1){
    $.when(alertDeffered[alertDeffered.length-2]).done(function(){
        $.alertShow(title, message);
    });
  } else {
    $.alertShow(title, message);
  }
}

//NAO UTILIZAR DIRETAMENTE ESTA FUNÇÃO POIS É ASSINCRONA
//UTILIZE $.alertOpen() PARA EXECUTAR NA SINCRONIA
jQuery.alertShow = function(title, message){
  $("#pushAlert h2").html(title);
  $("#pushAlert p").html(message);

  //$("#pushAlert").slideDown();
  $("#pushAlert").css("margin-top","-"+$("#pushAlert").outerHeight()+"px");
  $("#pushAlert").show();
  $("#pushAlert").animate({marginTop:"0px"});
  alertTimeOut = setTimeout(function(){
    $.alertClose();
  },4000);
}

var alertDeferredDoNotClose = null;
jQuery.alertClose = function(){
  if(alertDeferredDoNotClose){
    $.when(alertDeferredDoNotClose).done(function(){
      alertDeferredDoNotClose = null;
      $.alertForceClose();
    });
  } else {
    $.alertForceClose();
  }
}

$("#pushAlert").bind("touchstart", function(){
  alertDeferredDoNotClose = $.Deferred();
  alertDeferredDoNotClose.promisse();
});
$("#pushAlert").bind("touchend", function(){
  alertDeferredDoNotClose.resolve();
});

jQuery.alertForceClose = function(){
  //$("#pushAlert").css("margin-top",$("#pushAlert")."-"+height()+"px");
  $("#pushAlert").animate({marginTop:"-"+$("#pushAlert").outerHeight()+"px"}, function(){
  //$("#pushAlert").slideUp(function(){
    $("#pushAlert").hide();
    if(alertDeffered.length>0){
      alertDeffered[0].resolve();
      alertDeffered.splice(0,1);
    }
  });
  if(alertTimeOut){
    clearTimeout(alertTimeOut);
    alertTimeOut=null;
  }
}

jQuery.dhoneNotification = function(){
    //$("#asideprofile_notification").css("transform", "translate(25px,25px)");
    if(uUserId && uNewNotification && uNewNotification > 0){
        $("#asideprofile_notification").html(uNewNotification);
        //$("#asideprofile_notification").css({"width":"25px","height":"25px","font-size":"14px", "margin-top":"0"});
        //$("#asideprofile_notification").css({"transform":"scale(1)"});
        $("#asideprofile_notification").addClass("active");
    }
}


jQuery.dhoneEventHandler = function(funcStr, self, event) {
   if (!dhoneTouchTimer) {

        dhoneTouchTimer = true;

        if($.isFunction(funcStr)){
            funcStr.call(self, self, event);
        } else {

            function evalWithThis() {
                eval(funcStr);
            }

            evalWithThis.call(self, funcStr);
        }
        setTimeout(function() { dhoneTouchTimer = false; }, dhoneTouchTimeout);
   }
}
/* DOUGs : REVISAR ESSA FUNÇÃO
jQuery.fn.dhoneBind = function(funcStr) {
   return this.each(function() {
       if (dhoneDevice != "browser") {
           var posStartX, posStartY;
           $(this).unbind("touchstart");
           $(this).bind("touchstart", function(e) {
                var touchobj = e.originalEvent.changedTouches[0];
                var orig = e.originalEvent;
                if (orig.touches.length == 0) {
                    posStartX = touchobj.clientX;
                    posStartY = touchobj.clientY;
                }
           });
       }
       $(this).unbind(((dhoneDevice == "browser")?"click":"touchend"));
       $(this).bind(((dhoneDevice == "browser")?"click":"touchend"), function(e) {
            if (dhoneDevice != "browser") {

                var orig = e.originalEvent;
                if (orig.touches.length == 0) {

                   var touchobj = e.originalEvent.changedTouches[0];
                   var accept = true;

                   if (posStartX > touchobj.clientX) {
                       if (touchobj.clientX < (posStartX - dhoneTouchTolerance)) {
                           accept = false;
                       }
                   }else if(posStartX < touchobj.clientX) {
                       if (touchobj.clientX > (posStartX + dhoneTouchTolerance)) {
                           accept = false;
                       }
                   }
                   if (posStartY > touchobj.clientY) {
                       if (touchobj.clientY < (posStartY - dhoneTouchTolerance)) {
                           accept = false;
                       }
                   }else if(posStartY < touchobj.clientY) {
                       if (touchobj.clientY > (posStartY + dhoneTouchTolerance)) {
                           accept = false;
                       }
                   }

                   if (accept) {
                        if($.isFunction(funcStr)){
                            funcStr(this);
                        } else {
                            $.dhoneEventHandler(funcStr, this);
                        }
                   }
               }

            } else {
                    //alert($.isFunction(funcStr));
                    if($.isFunction(funcStr)){
                        funcStr(this);
                    } else {
                        $.dhoneEventHandler(funcStr, this);
                    }
               }


       });
   });
}
*/

var resendingVoucher = false;
jQuery.resendVoucher = function(userId, eventId, purchaseId){
    if(!resendingVoucher){
        resendvoucher = true;
        $.server("resendvoucher?id="+userId+"&eventId="+eventId+"&purchaseId="+purchaseId, function(json){
            if(json){
                $.showMsg("Sucesso", "Voucher enviado com sucesso para "+json+".");
            }else{
                $.showMsg("Atenção", "Não foi possível enviar o voucher. Tente novamente mais tarde.");
            }
        resendingVoucher = false;
        }, "modal");
    }

}

jQuery.fn.dhoneBind = function(funcStr) {
   return this.each(function() {
       if (dhoneDevice != "browser") {
           var posStartX, posStartY;
           $(this).unbind("touchstart");
           $(this).bind("touchstart", function(e) {
                var touchobj = e.originalEvent.changedTouches[0];
                posStartX = touchobj.clientX;
                posStartY = touchobj.clientY;

                $(this).removeClass("animation traslation");
                $(this).addClass("bg-hover", function() {
                    $(this).addClass("animation traslation");
                });
           });
       }

       $(this).unbind(((dhoneDevice == "browser")?"click":"touchend"));
       $(this).bind(((dhoneDevice == "browser")?"click":"touchend"), function(e) {
           if (dhoneDevice != "browser") {
               $(".bg-hover").removeClass("bg-hover");

               var touchobj = e.originalEvent.changedTouches[0];
               var accept = true;

               if (posStartX > touchobj.clientX) {
                   if (touchobj.clientX < (posStartX - dhoneTouchTolerance)) {
                       accept = false;
                   }
               }else if(posStartX < touchobj.clientX) {
                   if (touchobj.clientX > (posStartX + dhoneTouchTolerance)) {
                       accept = false;
                   }
               }
               if (posStartY > touchobj.clientY) {
                   if (touchobj.clientY < (posStartY - dhoneTouchTolerance)) {
                       accept = false;
                   }
               }else if(posStartY < touchobj.clientY) {
                   if (touchobj.clientY > (posStartY + dhoneTouchTolerance)) {
                       accept = false;
                   }
               }

               if (accept) {
                    //$(".bg-hover").removeClass("bg-hover");
                    //$(this).removeClass("animation traslation");
                    //$(this).addClass("bg-hover", function() {
                    //    $(this).addClass("animation traslation");
                    //});

                    $.dhoneEventHandler(funcStr, this);
               }
           }else {
                $(this).removeClass("animation traslation");
                $(".bg-hover").removeClass("bg-hover");
                $(this).addClass("bg-hover", function() {
                    $(this).addClass("animation traslation");
                });


                //alert($.isFunction(funcStr));
                $.dhoneEventHandler(funcStr, this, e);
           }
       });
   });
}

jQuery.dhoneStartCTEvents = function(obj) {
    if(obj){
        $(obj).find("[tfunc]").each(function(){
           $(this).dhoneBind($(this).attr("tfunc"));
        });
    } else {
        $("[tfunc]").each(function() {
           $(this).dhoneBind($(this).attr("tfunc"));
        });
    }
}

jQuery.toUrl = function(url){
    if(url.substr(0,4) != 'http'){
        url = 'http://' + url;
    }
    return url;
}

jQuery.formatText = function(text){
    var textAux = text.replace("**", "<strong>");
    if(textAux == text) return text;
    else {
        var textAux2 = textAux.replace("**", "</strong>");
        if(textAux2 == textAux) return text;
        else {
            return $.formatText(textAux2);
        }
    }
}

//Inclui trocar quebra de linha por br
jQuery.formatText2 = function(text){
    text = $.formatText(text);
    return text.replace(/\n/g,"<br>");
}

jQuery.cpfValidator = function(strCPF) {
    strCPF = strCPF.replace(/\.|-/g, "");

    var Soma;
    var Resto;
    Soma = 0;
    if (strCPF == "00000000000") return false;

    for (i=1; i<=9; i++) Soma = Soma + parseInt(strCPF.substring(i-1, i)) * (11 - i);
    Resto = (Soma * 10) % 11;

    if ((Resto == 10) || (Resto == 11))  Resto = 0;
    if (Resto != parseInt(strCPF.substring(9, 10)) ) return false;

    Soma = 0;
    for (i = 1; i <= 10; i++) Soma = Soma + parseInt(strCPF.substring(i-1, i)) * (12 - i);
    Resto = (Soma * 10) % 11;

    if ((Resto == 10) || (Resto == 11))  Resto = 0;
    if (Resto != parseInt(strCPF.substring(10, 11) ) ) return false;
    return true;
}

//retorna string com valor xx,xx (com duas casas decimais)
jQuery.valueRound = function(number, separator){
    if(!separator) separator = ",";

    if(number == 0) return "0"+separator+"00";

    var num = Math.round(number * 100) + "";

    num = num.substr(0, num.length-2) + separator + num.substr(num.length-2,2);

    return num;
}

jQuery.sendSupport = function(msg){
  if(!msg) msg = "Suporte";

  $.server("institutional/"+clientId, function(json){
    subject = msg + ' - App ' + clientName;
    body = '';
    link = "mailto:"+json["email"]+"?subject="+subject+"&body="+body;

    window.open(link, "_system");

    // window.plugins.socialsharing.shareViaEmail(
    //   '', // content
    //   msg + ' - App ' + clientName,
    //   [json["email"]], // TO: must be null or an array
    //   ["contato@outgo.com.br"], // CC: must be null or an array
    //   null, // BCC: must be null or an array
    //   null, // FILES: can be null, a string, or an array
    //   null, // called when sharing worked, but also when the user cancelled sharing via email (I've found no way to detect the difference)
    //   null // called when sh*t hits the fan
    // );
  },"modal");
}

jQuery.dhoneGetCards = function(index) {
    if (uUserId != null) {
        var cards = localStorage.getItem("myCards"+uUserId);

        if (cards == null || cards == "") {
            cards = [];
        }else {
            var decrypted = CryptoJS.AES.decrypt(cards, $.deviceId());
            cards = JSON.parse(decrypted.toString(CryptoJS.enc.Utf8));
        }
    }else {
        return [];
    }

    if (index) {
        return cards[index];
    }
    return cards;

}

jQuery.dhoneAddCardToMemory = function(number, name, expire, cpf, brand, birthday, phone, zip, street, addressnumber, district, complement, city, state) {
    if (uUserId != null && number && name) {
        var cards = localStorage.getItem("myCards"+uUserId);

        if (cards == null || cards == "") {
            cards = [{"number": number, "name": name, "expire": expire, "cpf": cpf, "brand": brand, "birthday": birthday, "phone" : phone, "zip" : zip, "street" : street, "addressnumber" : addressnumber, "district" : district, "complement" : complement, "city" : city, "state" : state}];
            var encrypted = CryptoJS.AES.encrypt(JSON.stringify(cards), $.deviceId());
            localStorage.setItem("myCards"+uUserId, encrypted.toString());
        }else {
            var decrypted = CryptoJS.AES.decrypt(cards, $.deviceId());
            cards = JSON.parse(decrypted.toString(CryptoJS.enc.Utf8));
            
            var cardIndex = cards.findIndex(function( obj ) {
              return obj.number == number;
            });

            if (cardIndex >= 0){ // REMOVE CARTÃO ATUAL PARA SUBSTITUIR
                cards.splice(cardIndex, 1);
            } 

            cards.push({"number": number, "name": name, "expire": expire, "cpf": cpf, "brand": brand, "birthday": birthday, "phone" : phone, "zip" : zip, "street" : street, "addressnumber" : addressnumber, "district" : district, "complement" : complement, "city" : city, "state" : state});    

            var encrypted = CryptoJS.AES.encrypt(JSON.stringify(cards), $.deviceId());
            localStorage.setItem("myCards"+uUserId, encrypted.toString());
        }

        return true;
    }
    
    return false;
}

jQuery.dhoneRemoveCardFromMemory = function(index, container) {
    if (uUserId != null) {
        if (!isNaN(index)) {
            $.modalChoice("Atenção", "Deseja remover o cartão?", function(){
                var cards = localStorage.getItem("myCards"+uUserId);

                var decrypted = CryptoJS.AES.decrypt(cards, $.deviceId());
                cards = JSON.parse(decrypted.toString(CryptoJS.enc.Utf8));
                var removedCard = cards.splice(index, 1);

                var encrypted = CryptoJS.AES.encrypt(JSON.stringify(cards), $.deviceId());
                localStorage.setItem("myCards"+uUserId, encrypted.toString());

                if (container)
                    $.dhoneDrawCards(container, true, false, true);
            });
        }else {
            return [];
        }
    }else {
        return [];
    }

    return [];
}

jQuery.dhoneRemoveAllCardFromMemory = function() {
    if (uUserId != null) {
        localStorage.removeItem("myCards"+uUserId);
    }else {
        return false;
    }
    return true;
}

jQuery.dhoneGetCardBrand = function(number) {
    brands = [];
    brands["34"] = "ae";
    brands["37"] = "ae";
    brands["40"] = "visa";
    brands["41"] = "visa";
    brands["42"] = "visa";
    brands["43"] = "visa";
    brands["44"] = "visa";
    brands["45"] = "visa";
    brands["46"] = "visa";
    brands["47"] = "visa";
    brands["48"] = "visa";
    brands["49"] = "visa";
    brands["51"] = "mastercard";
    brands["52"] = "mastercard";
    brands["53"] = "mastercard";
    brands["54"] = "mastercard";
    brands["55"] = "mastercard";
    brands["65"] = "discover";

    var brand = brands[number[0]+number[1]];
    if (typeof brand === "undefined") {
        brand = "desconhecido";
    }

    return brand;
}

jQuery.dhoneDrawCards = function(container, canDelete, canSelect, hasNoCardComponent) {
    var cards = $.dhoneGetCards();
    cards.reverse();
    var html = "";
    for (i in cards) {
        var left4 = cards[i].number.split(" ");
        left4 = left4[left4.length -1];

        var tagContainer = "div";
        if (canSelect)
            tagContainer = "label";

        html += '<'+tagContainer+' class="box-card">';
            if (canSelect)
                html += '<input type="radio" name="'+container+'RadioCard" class="card-selector" id="'+container+'RadioCard'+i+'" value="'+i+'" />';
            html += '<img src="./img/'+cards[i].brand+'.png">'+
                    '<div style="margin-top:-3px;">'+cards[i].name+'<br>**** **** **** <span>'+left4+'</span></div>';
            if (canDelete)
                html += '<button tfunc="$.dhoneRemoveCardFromMemory('+i+', \''+container+'\');" type="button" class="negative btn-square"><i class="mdi mdi-close"></i></button>';
        html += '</'+tagContainer+'>';
    }

    if(hasNoCardComponent){
        if(html == ""){
            html =  '<div class="col-12 small-timeline" style="max-height: 300px; z-index: 9999;">\
                        <div class="content scrollable no-connection-display">\
                            <div class="error error-connection">\
                                <i class="mdi mdi-emoticon-sad icon-error"></i>\
                                <h2>Nenhum cartão cadastrado.</h2>\
                                <p></p>\
                            </div>\
                        </div>\
                    </div>';
        }
        else {
            html = "<h3>Cartões cadastrados</h3>" + html;
        }
    }

    $("#"+container).html(html);
    $.dhoneStartCTEvents(configs.jPages[pageNow].find(".content"));
    if (canSelect)
        $.dhoneInitCardSelector();
}

jQuery.dhoneInitCardSelector = function() {
    $(".card-selector").unbind("change");
    $(".card-selector").bind("change", function() {
        $(".card-selector").parent().removeClass("selected");
        $(this).parent().addClass("selected");
    });
}

jQuery.valData = function(data){//dd/mm/aaaa
    day = data.substring(0, 2);
    month = data.substring(3, 5);
    year = data.substring(6, 10);

    if ((month == 01) || (month == 03) || (month == 05) || (month == 07) || (month == 08) || (month == 10) || (month == 12)) { //mes com 31 dias
        if ((day < 01) || (day > 31)) {
            return false;
        }
    } else

    if ((month == 04) || (month == 06) || (month == 09) || (month == 11)) { //mes com 30 dias
        if ((day < 01) || (day > 30)) {
            return false;
        }
    } else

    if ((month == 02)) { //February and leap year
        if ((year % 4 == 0) && ((year % 100 != 0) || (year % 400 == 0))) {
            if ((day < 01) || (day > 29)) {
                return false;
            }
        } else {
            if ((day < 01) || (day > 28)) {
                return false;
            }
        }
    }

    return true;
}

jQuery.valDataExpire = function(data){//mm/aa
    month = data.substring(0, 2);
    year = 20 + data.substring(3, 5);

    if ((month != "01") && (month != "02") && (month != "03") && (month != "04") && (month != "05") && (month != "06") && (month != "07") && (month != "08") && (month != "09") && (month != "10") && (month != "11") && (month != "12")) { //mes com 31 dias
        return false;
    }

    var d = new Date();
    var y = d.getFullYear();

    if (parseInt(year) < parseInt(y)) {
        return false;
    }

    return true;
}

jQuery.fn.dhoneCheckbox = function(checked){
    //<button type="button" class="confirm btn-square with-hr" style="right:30px;"><i class="mdi mdi-check"></i></button>
    //<button type="button" class="white btn-square with-hr" style="right:30px;"></button>
    return this.each(function(){
        if(checked){
            $(this).html('<button type="button" class="confirm btn-square with-hr" style="position: initial;margin-right: 10px;margin-top: -5px;float: left;"><i class="mdi mdi-check"></i></button>');
            $(this).attr("dhoneCheck","true");
        } else {
            $(this).html('<button type="button" class="white btn-square with-hr" style="position: initial;margin-right: 10px;margin-top: -5px;float: left;"></button>');
            $(this).attr("dhoneCheck","false");
        }

        $(this).dhoneBind(function(self){
            $(self).toogleCheckbox();
            // if($(self).attr("dhoneCheck")=="true"){
            //     $(self).html('<button type="button" class="white btn-square with-hr" style="position: initial;margin-right: 10px;margin-top: -5px;float: left;"></button>');
            //     $(self).attr("dhoneCheck","false");
            // } else {
            //     $(self).html('<button type="button" class="confirm btn-square with-hr" style="position: initial;margin-right: 10px;margin-top: -5px;float: left;"><i class="mdi mdi-check"></i></button>');
            //     $(self).attr("dhoneCheck","true");
            // }
        });
    });
}

jQuery.fn.toogleCheckbox = function(){
    if(this.attr("dhoneCheck")=="true"){
        this.html('<button type="button" class="white btn-square with-hr" style="position: initial;margin-right: 10px;margin-top: -5px;float: left;"></button>');
        this.attr("dhoneCheck","false");
    } else {
        this.html('<button type="button" class="confirm btn-square with-hr" style="position: initial;margin-right: 10px;margin-top: -5px;float: left;"><i class="mdi mdi-check"></i></button>');
        this.attr("dhoneCheck","true");
    }
}

var month = {
     "01":"Janeiro"
    , "1":"Janeiro"
    ,"02":"Fevereiro"
    , "2":"Fevereiro"
    ,"03":"Março"
    , "3":"Março"
    ,"04":"Abril"
    , "4":"Abril"
    ,"05":"Maio"
    , "5":"Maio"
    ,"06":"Junho"
    , "6":"Junho"
    ,"07":"Julho"
    , "7":"Julho"
    ,"08":"Agosto"
    , "8":"Agosto"
    ,"09":"Setembro"
    , "9":"Setembro"
    ,"10":"Outubro"
    ,"11":"Novembro"
    ,"12":"Dezembro"
}
//2014-06-08T21:32:51.000Z
//012345678901234567890123
jQuery.dhoneFormatDate = function(date){
    return date.substr(8,2) + " de " + month[date.substr(5,2)] + " de " + date.substr(0,4) + " às " + date.substr(11,2) + "h" + date.substr(14,2);
}

/*
Sugestão de evento - App [Nome da Company]

Título: \nData e hora: \nLocal: \nDescrição: \n(Adicionar imagem em anexo)
*/
jQuery.dhoneSendEventSuggestion = function(){
    $.server("institutional/"+clientId, function(json){
        if($.isAndroid()){
            window.plugins.socialsharing.shareViaEmail(
                '<strong>Título</strong>: <br><strong>Data e hora</strong>: <br><strong>Local</strong>: <br><strong>Descrição</strong>: <br><br>(Adicionar imagem em anexo)', // can contain HTML tags, but support on Android is rather limited:  http://stackoverflow.com/questions/15136480/how-to-send-html-content-with-image-through-android-default-email-client
                'Sugestão de evento - App ' + clientName,
                [json["email"]], // TO: must be null or an array
                null, // CC: must be null or an array
                null, // BCC: must be null or an array
                null, // FILES: can be null, a string, or an array
                null, // called when sharing worked, but also when the user cancelled sharing via email (I've found no way to detect the difference)
                null // called when sh*t hits the fan
            );
        } else {
            subject = 'Sugestão de evento - App ' + clientName;
            body = '<strong>Título</strong>: <br><strong>Data e hora</strong>: <br><strong>Local</strong>: <br><strong>Descrição</strong>: <br><br>(Adicionar imagem em anexo)';
            link = "mailto:"+json["email"]+"?subject="+subject+"&body="+body;

            window.open(link, "_system");
        }
        /*
        window.plugins.socialsharing.shareViaEmail(
            '<strong>Título</strong>: <br><strong>Data e hora</strong>: <br><strong>Local</strong>: <br><strong>Descrição</strong>: <br><br>(Adicionar imagem em anexo)', // can contain HTML tags, but support on Android is rather limited:  http://stackoverflow.com/questions/15136480/how-to-send-html-content-with-image-through-android-default-email-client
            'Sugestão de evento - App ' + clientName,
            [json["email"]], // TO: must be null or an array
            null, // CC: must be null or an array
            null, // BCC: must be null or an array
            null, // FILES: can be null, a string, or an array
            null, // called when sharing worked, but also when the user cancelled sharing via email (I've found no way to detect the difference)
            null // called when sh*t hits the fan
          );
        */
    },"modal");
}

jQuery.dhoneParseDateUTCLiteral = function(dateUTC){
    //2015-09-23T13:02:33.000Z
    //1234567890123456789
    var GMT_BSB = -3;
    var dateAux = $.dhoneParseDate(GMT_BSB, dateUTC.substr(0,19));
    var stDate = dateAux.getDate() + " de " + month[(dateAux.getMonth()+1).toString()] + " de " + dateAux.getFullYear() + " às " + (dateAux.getHours()<10?("0"+dateAux.getHours()):dateAux.getHours()) + "h" + (dateAux.getMinutes()<10?("0"+dateAux.getMinutes()):dateAux.getMinutes());

    return stDate;
}

jQuery.dhoneParseDateUTC = function(dateUTC){
    //Wed, 07 Oct 2015 20:30:48 +0000
    //0123456789012345678901234567890
    var GMT_BSB = -3;
    var dateAux = $.dhoneParseDate(GMT_BSB,dateUTC.substr(12,4),monthForDate[dateUTC.substr(8,3)],dateUTC.substr(5,2),dateUTC.substr(17,2),dateUTC.substr(20,2),dateUTC.substr(23,2));
    var stDate = dateAux.getDate() + " de " + month[(dateAux.getMonth()+1).toString()] + " de " + dateAux.getFullYear() + " às " + dateAux.getHours() + "h" + dateAux.getMinutes();

    return stDate;
}

var monthForDate = {
     "Jan":"01"
    ,"Feb":"02"
    ,"Mar":"03"
    ,"Apr":"04"
    ,"May":"05"
    ,"Jun":"06"
    ,"Jul":"07"
    ,"Aug":"08"
    ,"Sep":"09"
    ,"Oct":"10"
    ,"Nov":"11"
    ,"Dec":"12"
}

jQuery.dhoneParseDate = function(GMT, year, month, day, hour, minute, second){
    if(!hour) hour = "00";
    if(!minute) minute = "00";
    if(!second) second = "00";

    var dateAux = new Date();

    if(!month && !day){
        dateAux = new Date(year);
    } else {
        dateAux = new Date(year+"-"+month+"-"+day+"T"+hour+":"+minute+":"+second);
    }

    //faz conversão de fuso
    var h = GMT;
    dateAux = new Date(dateAux.getTime() + (h*60*60*1000))

    return dateAux;
}

jQuery.getInitials = function(name){
    var staux = name.split(" ");
    var response = staux[0].substr(0,1).toUpperCase();
    if(staux.length > 1){
        response += staux[1].substr(0,1).toUpperCase();
    }
    return response;
}

var actualPagseguroVersion = 0;
jQuery.pagseguroLoad = function(callback){
    actualPagseguroVersion++;

    $("#directpaymentgateway").remove();
    window._PagSeguroDirectPayment = null;
    window.PagSeguroDirectPayment = null;
    pagsegurosession = null;
    Pagseguro = null;
    window.PagSeguro = null;
    PagSeguroDirectPayment = null;

    $.ajaxSetup({ cache: true });
    $.getScript(pagsegurojs, function() {
                $.ajaxSetup({ cache: false });
                $.server("getPagseguroToken", function(json){
                    outgoPagseguroToken = json.session.id;
                    PagSeguroDirectPayment.setSessionId(outgoPagseguroToken);
                    pagseguroLoad = true;

                    if(callback) callback();
                    //$.ticketPaymentMethodInit();
                },"modal");
    }).fail(function( jqxhr, settings, exception ) {
            //EXIBE ERRO NO CONSOLE
            console.log(exception);
            $.dhoneBack();
            setTimeout(function(){
                $.showMsg("Alerta", "Não foi possível acessar a plataforma de pagamento, tente novamente mais tarde.");
            },500);
            //alert(exception);
    });
}

jQuery.leftZeros = function(number, size){
    numberSt = number + "";
    if(numberSt.length < size){
        return $.leftZeros("0"+number, size);
    } else {
        return number;
    }
}


/*
    <div class="radio left checked" go-radio="paymentMethod" go-value="creditCard" checked="checked">
        <button class="btn white"><i class="mdi mdi-checkbox-blank-circle"></i></button>
        <label>Cartão de crédito</label>
    </div>
*/
jQuery.dhoneRadio = function(){
    $(".radio").dhoneBind(function(radio){
        var self = $(radio);
        var attr = self.attr('checked');

        if (!(typeof attr !== typeof undefined && attr !== false)) {
            var radioSelector = self.attr("go-radio");
            $('.radio[go-radio="'+radioSelector+'"][checked]').removeClass("checked");
            $('.radio[go-radio="'+radioSelector+'"][checked]').removeAttr("checked");
            self.attr("checked", "checked");
            self.addClass("checked");
        }

        if(self.attr("callback")){
            eval(self.attr("callback"));
        }
    });
}

jQuery.radioValue = function(radioName){
    return $('.radio[go-radio="'+radioName+'"][checked]').attr("go-value");
}

jQuery.dhonePhone = function(input){
    self = $(input);
    console.log(self.val().length);

    if(self.val().length == 15){
        self.mask("(99) 99999-9999");
        self.attr("mask-15", "mask");
    } else {
        self.mask("(99) 9999-9999?9");
    }

    $(input).bind("keyup", function(){
        //(84) 9999-9999
        //123456789012345
        val = self.val();
        if (val[val.length-1] != "_" && val.length == 15){
            self.mask("(99) 99999-9999");
            self.attr("mask-15", "mask");
        } else {
            if(self.attr("mask-15")){
                self.mask("(99) 9999-9999?9");
                self.removeAttr("mask-15");
            }
        }
    });
}

jQuery.fn.dhoneTrim = function() {
    return this.each(function(){
        if ($(this).val()){
            st = $(this).val();
            st2 = st.replace(/  +/g, ' ');
            if(st != st2){
                $(this).val(st2);
            }  
        }
    });
}