var pushToken = "";
var push;

function dhonePush(){
	push = PushNotification.init({
        "android": {
            "senderID": "339480509056"
        },
        "ios": {
            "sound": true,
            "vibration": true,
            "badge": true
        },
        "windows": {}
    });

    push.on('registration', function(data) {
        pushToken = data.registrationId;
        push_token = pushToken;
        $.sendPushToken();
    });

    push.on('error', function(e) {
        console.log("push error = " + e.message);
    });

    push.on('notification', function(data) {
        if (data.additionalData.foreground){
        	//exibir alerta dentro do app ao receber notificação
            $.alertOpen(data.title, data.message);
        } else if (data.additionalData.coldstart){
        	//abrindo o app usando o botão do push
            window.localStorage.setItem("push", "PUSH");
            $.dhoneInitPush();
        } else {
        	//Abrindo em background
            window.localStorage.setItem("push", "PUSH");
        }
        
        //Setando o valor da badge.
        push.setApplicationIconBadgeNumber(function(){
            console.log("Notificação recebida.");
            console.log(data);
        }, function(){
            console.log("Erro ao atualizar o número de notificações.");
            console.log(data);
        }, data.badge);
   });
}