//função que carrega scripts de paginas como Start e Update
function LoadedFunction(spt, act, upd, par) {
    var scriptName  = spt;
    var actionRef   = act;
    var updateRef   = upd;
    var paramiters  = par;

    this.load       = function(action) {
        $.getScript("./js/actions/"+scriptName+".js", function() {
            // if(theme=="dark"){
            //     $(".loader").attr("src",darkLoader);
            // }
            eval(actionRef+"();");
            $.addUpdate(action, eval(updateRef), paramiters);
        }).fail(function( jqxhr, settings, exception ) {
            //EXIBE ERRO NO CONSOLE
            console.log(exception);
            //alert(exception);
        });

    }


}


//Obj de dominio de uma página
function Page(name) {
    this.pageName   = name;
    var loaded      = false;
    var loadedHtml  = false;
    var html        = false;
    this.actions    = false;
    var hasAside    = null; // indica se a página tem menu lateral
    var father      = null;
    var dynamicFather= false;
    var headerFade = false;
    var tabs        = false;

    var header      = null;
    var content     = "content";
    var bottom      = null;

    this.setHeaderFade = function(bool) {
        headerFade = ((!bool)?false:bool);
    }

    this.hasHeaderFade = function() {
        return headerFade;
    }

    this.setTabs = function(bool) {
        tabs = ((!bool)?false:bool);
    }

    this.hasTabs = function() {
        return tabs;
    }

    this.setDynamicFather = function(bool) {
        dynamicFather = ((!bool)?false:bool);
    }

    this.getDynamicFather = function() {
        return dynamicFather;
    } 

    this.setFather = function(pageName) {
        father = pageName;
    }

    this.getFather = function() {
        return father;
    }

    this.setHeader = function(headerId) {
        header = headerId;
    }
    this.getHeader = function() {
        return header;
    }

    this.setContent = function(contentId) {
        content = contentId;
    }
    this.getContent = function() {
        return content;
    }

    this.setBottom = function(bottomId) {
        bottom = bottomId;
    }
    this.getBottom = function() {
        return bottom;
    }

    this.setAside = function(bool) {
        hasAside = bool;
    }

    this.hasAside = function() {
        return hasAside;
    }

    this.setLoaded = function() {
        loaded = true;
    }

    this.setUnlooaded = function() {
        loaded = false;
    }

    this.isLoaded = function() {
        return loaded;
    }

    this.setHtmlLoaded = function() {
        loadedHtml = true;
    }

    this.setHtmlUnloaded = function() {
        loadedHtml = false;
        this.setUnlooaded();
    }

    this.isHtmlLoaded = function() {
        return loadedHtml;
    }

    this.setActions = function(LoadedFunction) {
        this.actions = LoadedFunction;
    }

    this.startActions = function() {
        if (!this.isLoaded()) {
            this.setLoaded();
            if (this.actions) {
                this.actions.load(this.pageName);
            }
        }
        
    }

    //verifica se o html de uma página foi carregado, se não carrega
    this.loadHtml = function(callBack, pageAnim, pageSens) {
        if (!this.isHtmlLoaded()) {
            this.setHtmlLoaded();
            var pageName    = this.pageName;
            //pageNow         = this.pageName;
            $.post("./js/html/"+this.getHtml()+".html", function(data) {
                data = '<div id="'+pageName+'" class="screen-size">' + data + '</div>';
                data = $(data);
                if(theme=="dark"){
                    data.find(".loader").attr("src",darkLoader);
                }
                callBack(data, pageName, pageAnim, pageSens);
                $.runUpdates(pageName);
            });

        }else {
            callBack($(""), this.pageName, pageAnim, pageSens);
            $.runUpdates(this.pageName);
        }


    }

    this.setHtml = function(newHtml) {
        html = newHtml;
    }
    this.getHtml = function() {
        return html;
    }

}


//configuração geral das paginas do app
function PagesConfig() {
    var pages               = [];
    var pageList            = [];
    var defaultPage         = "home";
    var hasAside            = true;
    var asideSize           = 50;
    this.jPages             = [];
    var defaultHeader       = null;
    var loadingMessages     = {"pull": "Puxe para atualizar", "release": "Solte para atualizar", "loading": "Carregando..."};
    var history             = [];

    this.actualPageHasTabs = function(){
        return pages[pageNow].hasTabs();
    }
    this.addPage = function(pag) {
        if (pag.hasAside() == null) {
            pag.setAside(hasAside);
        }
        pages[pag.pageName] = pag;
        pageList.push(pag.pageName);
    }
    this.unloadPage = function(pageName) {
        //if (pageName != this.getDefaultPage()) {
            this.jPages[pageName].remove();
            delete this.jPages[pageName];
            pages[pageName].setHtmlUnloaded();
        //}
    }
    this.unloadParengPages = function(qtd){
        var hl = history.length;
        var hpages = history.splice(hl-qtd-1, qtd);
        for(index in hpages){
            console.log(hpages[index]);
            this.unloadPage(hpages[index].split("#")[1]);
            //configs.unloadPage(oldPageName);
        }
        this.setPageFather(pageNow,history.length<=1?defaultPage:history[history.length-2].split("#")[1]);
        console.log(pages[pageNow].getFather());
    }

    this.loadScripts = function(action) {
        pages[action].startActions();
    }
    this.loadHtml = function(action, callBack, pageAnim, pageSens) {
        if (pageList.indexOf(action) > -1) {
            pages[action].loadHtml(callBack, pageAnim, pageSens);
        }else {
            pages[defaultPage].loadHtml(callBack, pageAnim, pageSens);
        }

    }

    this.addHistory = function(page) {
        history.push(page);
    }

    this.getHistory = function() {
        return history;
    }

    this.clearHistory = function() {
        history = [];
    }

    this.historyGoBack = function() {
        if (history.length > 0) {
            var hash = history[history.length-1].split("#");
            hash.splice(0, 1);


            if(hash.length == 1){
                hash.push("no");
                hash.push("back");
            }else if(hash.length == 2) {
                hash.push("back");
            }else if(hash.length == 3) {
                hash[2] = "back";
            }else if(hash.length > 3) {
                hash[2] = "back";
            }


            var backPage = (("#"+configs.getPageFather(hash[0]) == "#null")?"#"+configs.getDefaultPage():"#"+configs.getPageFather(hash[0]));
            hash.splice(0, 1);

            for (i in hash) {
                backPage += "#" + hash[i];
            }
        }else {
            if (defaultPage == configs.getPageNow()) {
                var backPage = "[close]";
            }else {
                var backPage = "#"+defaultPage+"#no#back";
            }
        }

        history.splice(history.length-1, 1);
        return backPage;
    }

    this.setDefaultHeader = function(className) {
        defaultHeader = className;
    }
    this.getDefaultHeader = function() {
        return defaultHeader;
    }

    this.getContentSizeOnAside = function() {
        return asideSize;
    }
    this.setContentSizeOnAside = function(size) {
        asideSize = size;
    }

    this.setDefaultPage = function(pageName) {
        defaultPage = pageName;
    }
    this.getDefaultPage = function() {
        return defaultPage;
    }

    this.setAside = function(bool) {
        hasAside = bool;

    }

    this.pageHasAside = function(pageName) {
        if (pages[pageName]) {
            return pages[pageName].hasAside();
        }else {
            return hasAside;
        }
    }

    //desuso
    this.setLoadingMessages = function(pull, release, loading) {
        loadingMessages["pull"]     = pull;
        loadingMessages["release"]  = release;
        loadingMessages["loading"]  = loading;

    }

    //desuso
    this.getLoadingMessage = function(msg) {
        return loadingMessages[msg];
    }

    this.getHeaderSize = function(pageName) {
        if (!pages[pageName]) {
            pageName = this.getDefaultPage();
        }


        var headerSize = 0;
        if(!pages[pageName].hasHeaderFade()){
            headerSize += 50;
            if($.isIos()){
                headerSize += 20;
            }
        }
        if(pages[pageName].hasTabs()){
            headerSize += 50;
        }

        console.log("headersize = "+headerSize);
        return headerSize;

        //CODIGO ANTIGO ABAIXO
        if(pageName == "agenda" || pageName == "ticketEvent" || pageName == "eventInsideListAdd" || pageName == "menu" || pageName == "menuinside"){
            if($.isIos()){
                return 70;
            } else {
                return 50;
            }
        }

        if (!pages[pageName]) {
            pageName = this.getDefaultPage();
        }
        
        switch(pages[pageName].getHeader()) {
            case false: {
                return 0;
                break;
            }
            case null: {
                if (this.getDefaultHeader() != null) {
                    var header = this.jPages[pageName].find("."+this.getDefaultHeader());
                    if (header != null) {
                        return header.height();
                    }else {
                        return 0;
                    }

                }else {
                    return 0;
                }
                break;
            }
            default: {
                var header = this.jPages[pageName].find("#"+pages[pageName].getHeader());
                if (header != null) {
                    return $("#"+pages[pageName].getHeader()).height();
                    
                }else {
                    if (this.getDefaultHeader() != null) {
                        var header = this.jPages[pageName].find("."+this.getDefaultHeader());
                        if (header != null) {
                            return header.height();
                        }else {
                            return 0;
                        }

                    }else {
                        return 0;
                    }

                }
                break;
            }
        }



    }

    this.getPageFather = function(pageName) {
        return pages[pageName].getFather();

    }

    this.setPageFather = function(pageName, newFatherName) {
        return pages[pageName].setFather(newFatherName);
    }

    this.getPageDynamicFather = function(pageName) {
        return pages[pageName].getDynamicFather();
    }

    //pega a pagina atual
    this.getPageNow = function() {
        pageName = pageNow;

        if (!pages[pageName]) {
            pageName = this.getDefaultPage();
        }

        return pageName;

    }
}


//função chamada quando uma página é criada no app. chama o método de start setado no config para a página se ela o tiver
jQuery.startAction = function(action) {
    //
    $.dhoneGeneralEvents(asideTouchStartPos);
    configs.loadScripts(action);
    $.dhoneUpdate(true);
}