var MENU_JSON = null;

// Inicia os eventos da Agenda
jQuery.menuStart = function() {
    $("#btnClearProduct").hide();
    $.post("./js/components/loading.html", function(loadingComponent) {
        loadingComponent = $(loadingComponent);
        if(theme == "dark")
            loadingComponent.find(".loader").attr("src", "img/loader-black.gif");
        $("#menuCategory").html(loadingComponent);

        //$.server("index.php?tipo=menu", $.loadMenu);
        $.server("getmenu/"+clientId, $.loadMenu);
        $("#menuFindProduct").bind("keyup", $.findProductMenu);
        $("#menuFindProduct").dhonePlaceHolder("O que você procura?");

        $("#btnClearProduct").dhoneBind(function(e) {
            $("#menuFindProduct").val("").trigger("blur");
            $.buildMenu();
            $(e).hide();
            $("#menuFindProduct").focus();
        });

    });
    
}


//desuso
jQuery.menuUpdate = function() {}

//preenche as categorias do cardápio
jQuery.buildMenu = function() {
    html = "";
    for (var categoryId in MENU_JSON) {
        var category_name = MENU_JSON[categoryId]["name"];
        var menuLinkGoinside = "href=\"javascript: void(0);\" tfunc=\"$.dhoneNavigate('#menuinside#slide#go#"+categoryId+"');\"";

        html += '<div class="btn-action touch" '+menuLinkGoinside+'>'+
                    //'<a '+menuLinkGoinside+'>'+                    
                        '<h3>'+category_name+' <i class="mdi mdi-chevron-right arrow right"></i></h3>'+
                    //'</a>' +
                 '</div>';

    }

    if ($.trim(html) == "") {
        $.post("./js/components/menunoitems.html", function(data) {
            $("#menuCategory").html(data);
            $.dhoneStartCTEvents("#menuCategory");
        });
    }else {
        $("#menuCategory").html(html);
        $.dhoneStartCTEvents("#menuCategory");
    }

}

jQuery.loadMenu = function(JSON) {

    MENU_JSON = JSON;
    $.buildMenu();

    //preload das imagens internas dos produtos
    for (var categoryId in MENU_JSON) {
        var category = MENU_JSON[categoryId];
        for (var product in category) {
            $.dhonePreloadPush(serverURL+clientFolder+'/img/cardapio/product/'+category[product]["photo"]);
        }
    }

}

//pesquisa de produto
jQuery.findProductMenu = function() {

    if ($.trim($(this).val()) == "") {
        $("#btnClearProduct").hide();
        $.buildMenu();
        return false;
    }

    $("#btnClearProduct").show();

    var searchedWord = $.trim($(this).val()).toLowerCase();
    var categoryList = $.extend(true, {}, MENU_JSON);
    
    var html = "";

    console.log(categoryList);

    for (var categoryId in categoryList) {
        var category = categoryList[categoryId];

        delete category["name"];
        var prices = category["prices"];
        delete category["prices"];
        var description = $.formatText(category["description"]);
        delete category["description"];

        console.log(category);

        for (var product in category) {

            if (category[product]["name"].toLowerCase().indexOf(searchedWord) < 0) {
                continue;
            }

            //Remove NULL
            var pricesAux = [];
            for(var index in category[product]["prices"]){
                if(category[product]["prices"][index][1]!=null){
                    pricesAux.push(category[product]["prices"][index]);
                }
            }
            category[product]["prices"] = pricesAux;
            
            var uniquePrice = "";

            var isUnique = false;
            var uniquePrice = "";
            for (var priceTypeId in category[product]["prices"]){
                if (category[product]["prices"][priceTypeId][0] == "Único") {
                    isUnique = true;
                    uniquePrice = category[product]["prices"][priceTypeId][1];
                    break;
                }
            }


            if (isUnique) {
                var priceList = "";
                uniquePrice = '<strong class="price client-color right">R$ '+uniquePrice+'</strong>';
            }else {
                var priceList = "<p>";
                for (var i in category[product]["prices"]) {
                    priceList += category[product]["prices"][i][0]+'<strong class="price client-color right">R$ '+category[product]["prices"][i][1]+'</strong><br>';
                }
                priceList = priceList.substr(0, priceList.length-4)+"</p>";

            }

            var descrption = "";
            if ($.trim(category[product]["description"]) != "") {
                descrption = "<p>"+$.formatText(category[product]["description"])+"</p>";
            }

            html += '<div class="col-12">'+
                        '<h2>'+category[product]["name"]+uniquePrice+'</h2>'+
                        priceList+
                        descrption+
                        //((category[product]["photo"] != null)?'<div class="img-box mb-20"><img src="'+category[product]["photo"]+'" onload="$(this).fadeIn(fadeTime,function(){$(this).parent().css(\'background-color\',\'initial\');});" class="img-nobox full radius '+((descrption == "")?" ":"")+'"><div style="clear:both;"></div></div>':'')+
                        ((category[product]["photo"] != null)?'<div class="img-box mb-20"><img src="'+category[product]["photo"]+'" style="display:initial !important;" class="img-nobox full radius '+((descrption == "")?" ":"")+'"><div style="clear:both;"></div></div>':'')+
                    '<hr /></div>';



            /*
            html += '<article class="box">'+
                        '<div class="small-padding left">'+
                            '<h2 class="bottom-five">'+category[product]["name"]+uniquePrice+'</h2>'+
                            priceList+
                            descrption+
                            ((category[product]["photo"] != null)?'<img src="'+serverURL+clientFolder+'/img/cardapio/product/'+category[product]["photo"]+'" class="full-size radius bottom-five">':'')+
                        '</div>'+
                    '</article>';*/

        }


    }

    if ($.trim(html) == "") {
        $.post("./js/components/menunoitems.html", function(data) {
            $("#menuCategory").html(data);
            $.dhoneStartCTEvents("#menuCategory");
        });
    }else {
        $("#menuCategory").html('<div class="container">'+html+'</div>');
        $.dhoneStartCTEvents("#menuCategory");
    }

}