jQuery.menuInsideStart = function() {
    $.menuInsideUpdateInfos();

}


jQuery.menuInsideUpdate = function() {
    $.menuInsideUpdateInfos();

}


//preenche a lista de produtos
jQuery.menuInsideUpdateInfos = function() {
    var hash = window.location.hash;
    hash = hash.split("#");
    hash.splice(0, 4);

    if(!configs.jPages["menuinside"]) return;
    configs.jPages["menuinside"].find(".content").scrollTop(0);

    var categoryId     = hash[0];
    var category        = $.extend(true, {}, MENU_JSON[categoryId]);

    $("#menuInsideTitle").html(category["name"]);
    $(".header-title").dotdotdot({watch: true, wrap: 'letter'});
    delete category["name"];
    var prices = category["prices"];
    delete category["prices"];
    var description = $.formatText(category["description"]);
    delete category["description"];

    if(description){
        $("#categoryDescription").html(description);
        $("#categoryDescriptionContainer").show();
    } else {
        $("#categoryDescriptionContainer").hide();
    }

    //alert(prices.length);
    var html = "";
    for (var product in category) {

        //Remove NULL
        var pricesAux = [];
        for(var index in category[product]["prices"]){
            if(category[product]["prices"][index][1]!=null){
                pricesAux.push(category[product]["prices"][index]);
            }
        }
        category[product]["prices"] = pricesAux;

        var uniquePrice = "";

        var isUnique = false;
        var uniquePrice = "";
        for (var priceTypeId in category[product]["prices"]){
            if (category[product]["prices"][priceTypeId][0] == "Único") {
                isUnique = true;
                uniquePrice = category[product]["prices"][priceTypeId][1];
                break;
            }


        }


        if (isUnique) {
            var priceList = "";
            uniquePrice = '<strong class="price client-color right">R$ '+uniquePrice+'</strong>';
        }else {
            var priceList = "<p class='clear'>";
            var entered = false;
            for (var i in category[product]["prices"]) {
                entered = true;
                priceList += category[product]["prices"][i][0]+'<strong class="price client-color right">R$ '+category[product]["prices"][i][1]+'</strong><br>';
            }
            if(entered) priceList = priceList.substr(0, priceList.length-4)+"</p>";
            else priceList = "";

        }

        var descrption = "";
        if ($.trim(category[product]["description"]) != "") {
            descrption = "<p class='clear'>"+$.formatText(category[product]["description"])+"</p>";
        }


        html += '<div class="col-12">'+
                    '<div class="row"><div class="col-8"><h3>'+category[product]["name"]+'</h3></div>'+"<div class='col-4'>"+uniquePrice+"</div></div>"+
                    priceList+
                    descrption+
                    ((category[product]["photo"] != null)?'<div class="img-box full mb-20"><img src="'+category[product]["photo"]+'" onload="$.menuLoadImg(this);" class="img-nobox full radius '+((descrption == "")?" ":"")+'"><div style="clear:both;"></div></div>':'')+
                '<hr /></div>';

    }

    if ($.trim(html) == "") {

        html = '<div class="content scrollable no-connection-display">'+
                    '<div class="error">'+
                        '<i class="mdi mdi-emoticon-sad icon-error"></i>'+
                        '<h2>Nenhum produto encontrado.</h2>'+
                        '<p>Que tal passar mais tarde?</p>'+
                    '</div>'+
                '</div>';

    }

    $("#menuInsideContent").html(html);



}

jQuery.menuLoadImg = function(self){
    var self2 = self;
    setTimeout(function(){
        $(self2).fadeIn(fadeTime,function(){
            $(self2).parent().css('background-color','initial');
        });
    }, 520);
}
