var photoGalleryPageSize = 10;
var photoGalleryActualPage = 1;
jQuery.photoGalleryInit = function(){
	$.server("photoGallery/"+clientId+"?page="+photoGalleryActualPage+"&max="+photoGalleryPageSize, $.loadPhotoGallery, true);
}

jQuery.photoGalleryUpdate = function(){

}

var actualEvent;
var agendaPhotoGallery = [];
jQuery.loadPhotoGallery = function(json){
	agendaPhotoGallery = json;

	var more = false;
	if(json.length > photoGalleryPageSize){
		more = true;
		json.splice(photoGalleryPageSize,1);;
	}

	for(position in json){
		$.photoGalleryEntry(json[position]);
	}

	if(more){
		$("#photoGalleryMore").show();
	}

    if(json.length <= 0){
        $.post("./js/components/menunoitems.html", function(data) {
            $("#photoGalleryContainer").html(data);
        });
    }

    $("#photoGalleryLoad").hide();
    $("#photoGalleryContainer").fadeIn();

}

var photoGalleryLoadMode = false;
jQuery.photoGalleryMore = function(){
	if(photoGalleryLoadMode) return;
    photoGalleryLoadMode = true;

	//$("#photoGalleryMore").hide();
    $("#photoGalleryModeLabel").hide();
    $("#photoGalleryMoreLoader").show();

	photoGalleryActualPage = photoGalleryActualPage + 1;

	$.server("photoGallery/"+clientId+"?page="+photoGalleryActualPage+"&max="+photoGalleryPageSize, function(json){
        $("#photoGalleryMore").hide();
        $("#photoGalleryModeLabel").show();
        $("#photoGalleryMoreLoader").hide();
        $.loadPhotoGallery(json);

        photoGalleryLoadMode = false;
    }, "modal");

}

jQuery.photoGalleryEntry = function(entry){
	var eventId = entry.event_id;
	var header = '<div class="col-12">'
			        +'<h3 class="no-mb">'+entry.event_title+'</h3>'
			        +'<small class="left clear mb-10">'+entry.event_date+'</small>'
			    +'</div>';
    $("#photoGalleryContainer").append(header);

    var maxPhotos = 5;
    if(entry.photos.length == 6){
        maxPhotos = 6;
    }
    var imagesGallery = [];
    var imagesGalleryThumb = [];
    var imagesGalleryId = [];

    for (i in entry.photos) {
        if(i >= maxPhotos) break;
        //imagesGallery.push(serverURL+clientFolder+'/img/agenda/gallery/'+entry.photos[i]);
        if(entry.photos[i] != null){
            if(entry.photos_gallery){
                imagesGallery.push(entry.photos_gallery[i]);
            } else {
                imagesGallery.push(entry.photos[i]);
            }
            imagesGalleryThumb.push(entry.photos[i]);

            imagesGalleryId.push(entry.photoId[i]);
        }
    }

    //CODIGO DE CORREÇÕES ------------------------*******************************<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<>>>>>>
    var screenWidth = $.getWindowSize()['w'];
    var gallerySizeX = (screenWidth-25)/3;
    var gallerySizeY = gallerySizeX - 15;

    //$("#eventInsideGalery").html();
    for (i in imagesGallery) {
        //if(entry.photos[i]==null) continue;

        //var tag = '<span class="col-3 mb-15 thumb-gallery-correction" ref="'+i+'" style="width:'+gallerySizeX+'px;height:'+gallerySizeY+'px;">'+
        var tag = '<span class="col-4 mb-15 thumb-gallery-correction" ref="'+i+'">'+
                        '<div class="img-box radius" style="width:100%;height:'+gallerySizeY+'px;">'+
        //                    '<img class="full radius" src="'+serverURL+clientFolder+'/img/agenda/gallery/thumb_'+entry.photos[i]+'" />'+
                            '<img class="full radius img-nobox" onload="$(this).fadeIn(fadeTime);" src="'+imagesGalleryThumb[i]+'" style="height:'+gallerySizeY+'px;width:'+gallerySizeX+'px;" />'+
                        ' </div>'+
                    '</span>';
        var imgGallery = $(tag);

        imgGallery.dhoneBind(function(obj){
            actualEvent = entry
            var start = parseInt($(obj).attr("ref"));//+1;
            actualPhotoId = imagesGalleryId[start];
            actualPhotoUrl = imagesGallery[start];
            actualPhotoPosition = start;
            $.dhoneNavigate("#photoDetail#slide#go");
            //var start = parseInt($(obj).attr("ref"))+1;
            //$("body").dGallery(imagesGallery, start);
        });
        //setTimeout(function(){
            $("#photoGalleryContainer").append(imgGallery);
        //}, 400);
    }

    if(entry.photos.length > 6){
        /*
        var tag = '<span class="col-3 mb-15 thumb-gallery-correction" ref="'+i+'">'+
                        '<div class="img-box radius">'+
                            '<a>'+
                                '<img class="full radius" src="img/plus-gallery.png">'+
                            '</a>'+
                        '</div>'+
                    '</span>';
        */
        var tag = 	'<span class="col-4 mb-15 thumb-gallery-correction">'
				   +    '<div class="img-box radius" style="width:100%;height:'+gallerySizeY+'px;">'
				   +        '<div class="mask-more-photo"><span>+'+(entry.photos.length - 6)+'</span></div>'
				   +        '<img class="full radius" src="'+entry.photos[7]+'" style="height:'+gallerySizeY+'px;">'
				   +    '</div>'
				   +'</span>'
        var imgGallery = $(tag);

        //imgGallery.bind("click", function() {
        imgGallery.dhoneBind(function(obj){
        	actualEvent = entry;
            $.dhoneNavigate("#album#slide#go");
        });
            $("#photoGalleryContainer").append(imgGallery);
    }

}

var photoGalleryLoaded = [true,false];
jQuery.photoGallerySellectTab = function(tab){
    var actualTab = $("#photoGalleryTabs").attr("ref");
    if(parseInt(actualTab)!=tab){
        $("#photoGalleryTab"+actualTab).find("a").removeClass("client-color");
        $("#photoGalleryTab"+actualTab).removeClass("active");
        $("#photoGalleryTab").animate({marginLeft:((tab*50)+"%")},300,function(){
            $("#photoGalleryTabs").attr("ref", tab);
            $("#photoGalleryTab"+tab).find("a").addClass("client-color");
            $("#photoGalleryTab"+tab).addClass("active");
        });

        if(tab == 1){
            $("#photoGalleryPhotos").fadeOut(function(){
                if(youtubeLoaded) $("#photoGalleryVideos").fadeIn();
            });

            if(!photoGalleryLoaded[tab]){
                photoGalleryLoaded[tab] = true;
                $.youtubestart();
            }
        }
        if(tab == 0){
            $("#photoGalleryVideos").fadeOut(function(){
                $("#photoGalleryPhotos").fadeIn();
            });
        }
    }
}

// ============================================================= YOUTUBE =====================================================<<<<<<<<<<<<<<<<<<<<<

var youtubeMax = 10;
jQuery.youtubestart = function() {
    $.server("institutional/"+clientId, function(inst){
        var youtubeSearch = "";
        if(inst.youtube_link && inst.youtube_link.indexOf("youtube") > -1){
            if(inst.youtube_link.indexOf("channel") > -1){
                youtubeSearch = "id=" + inst.youtube_link.split("/").pop();
            } else {
                youtubeSearch = "forUsername=" + inst.youtube_link.split("/").pop();
            }
        } else { 
            youtubeSearch = "forUsername=" + inst.youtube_link;
        }

        if(!inst.youtube_link){
            $.youtubeInit(new Array());
            return;
        }

        console.log(youtubeSearch);
        $.getJSON("https://www.googleapis.com/youtube/v3/channels?"+youtubeSearch+"&key=AIzaSyD-70I4D-sBMoJsrVtHNgrRH2b-x6Kj7Vc&part=contentDetails",function(json){
            if(json.items.length > 0){
                var playlist = json.items[0].contentDetails.relatedPlaylists.uploads;
                $.getJSON("https://www.googleapis.com/youtube/v3/playlistItems?playlistId="+playlist+"&key=AIzaSyD-70I4D-sBMoJsrVtHNgrRH2b-x6Kj7Vc&part=snippet&maxResults="+youtubeMax, function(json2){
                    var videos = [];
                    for(index in json2.items){
                        var video = {
                            "title":json2.items[index].snippet.title
                            ,"thumb":json2.items[index].snippet.thumbnails.high.url
                            ,"dateRaw":json2.items[index].snippet.publishedAt
                            ,"date":$.dhoneParseDateUTCLiteral(json2.items[index].snippet.publishedAt)
                            ,"videoId":json2.items[index].snippet.resourceId.videoId
                        };
                        videos.push(video);
                    }

                    $.youtubeInit(videos);
                });
            }
        });
    },"modal");
}

var youtubeLoaded = false;
jQuery.youtubeInit = function(videos){
    h = (size['w']-40)*3/4; //calculo da altura baseado na proporção da imagem do youtube

    if(videos.length <= 0){
        $.post("./js/components/noevents.html", function(html) {
             $("#youtubeContainer").html(html);
             $("#photoGalleryVideos").show();
        });
    } else {
        var html = "";
        for(index in videos){
            html += '<div class="col-12">\
                        <h3 id="" class="no-mb">'+videos[index].title+'</h3>\
                        <small id="" class="left clear mb-10">'+videos[index].date+'</small>\
                    </div>\
                    <div class="col-12"><div class="video" tfunc="$.openUrl(\'https://www.youtube.com/watch?v='+videos[index].videoId+'\', true);">\
                        <img src="'+videos[index].thumb+'" alt="" style="height:'+h+'px;" />\
                        <i class="mdi mdi-youtube-play"></i>\
                    </div></div>';
        }
        $("#youtubeContainer").html(html);
        $.dhoneStartCTEvents("#youtubeContainer");
        $("#photoGalleryVideos").fadeIn();
    }
    youtubeLoaded = true;
}