configs.setDefaultPage("agenda");
configs.setDefaultHeader("header");
configs.setLoadingMessages("", "", "");

var newPage = new Page("agenda");
newPage.setAside(true);
var newPageActions = new LoadedFunction("agenda", "$.dhoneEventListEvent", "$.agendaUpdate");
newPage.setHtml("agenda");
newPage.setTabs(true);
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("agendaTags");
newPage.setAside(false);
var newPageActions = new LoadedFunction("agendaTags", "$.agendaTagsStart", "$.agendaTagsUpdate");
newPage.setHtml("agendaTags");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("youtube");
newPage.setAside(true);
var newPageActions = new LoadedFunction("youtube", "$.youtubestart", "$.youtubeupdate");
newPage.setHtml("youtube");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("photoDetail");
newPage.setAside(false);
var newPageActions = new LoadedFunction("photoDetail", "$.photoDetailInit", "$.photoDetailUpdate");
newPage.setHtml("photoDetail");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("photoDetailAlbum");
newPage.setAside(false);
var newPageActions = new LoadedFunction("photoDetail", "$.photoDetailInit", "$.photoDetailUpdate");
newPage.setHtml("photoDetail");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("album");
newPage.setAside(false);
var newPageActions = new LoadedFunction("album", "$.albumInit", "$.albumUpdate");
newPage.setHtml("album");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("photoGallery");
newPage.setAside(true);
var newPageActions = new LoadedFunction("photoGallery", "$.photoGalleryInit", "$.photoGalleryUpdate");
newPage.setHtml("photoGallery");
newPage.setTabs(true);
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("profileTickets");
newPage.setAside(true);
newPage.setTabs(true);
var newPageActions = new LoadedFunction("profileTickets", "$.profileTicketsInit", "$.profileTicketsUpdate");
newPage.setHtml("profileTickets");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("ticketPurchase");
newPage.setAside(false);
//newPage.setFather("eventInsideList");
var newPageActions = new LoadedFunction("ticketPurchase", "$.ticketPurchaseNew", "$.ticketPurchaseUpdate");
newPage.setHtml("ticketPurchase");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("ticketPaymentMethod");
newPage.setAside(false);
var newPageActions = new LoadedFunction("ticketPaymentMethod", "$.ticketPaymentInit", "$.ticketPaymentUpdate");
newPage.setHtml("ticketPaymentMethod");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("tickets");
newPage.setAside(false);
var newPageActions = new LoadedFunction("tickets", "$.ticketsNew", "$.ticketsUpdate");
newPage.setHtml("tickets");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("myCardsAdd");
newPage.setAside(false);
var newPageActions = new LoadedFunction("myCardsAdd", "$.dhoneAddCard", "$.dhoneAddCard");
newPage.setHtml("myCardsAdd");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("myCards");
newPage.setAside(false);
var newPageActions = new LoadedFunction("myCards", "$.dhoneMyCards", "$.dhoneMyCards");
newPage.setHtml("myCards");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("news");
newPage.setAside(true);
var newPageActions = new LoadedFunction("news", "$.newsStart", "$.newsUpdate");
newPage.setHtml("news");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("newsinside");
newPage.setAside(false);
var newPageActions = new LoadedFunction("newsinside", "$.newsinsideStart", "$.newsinsideUpdate");
newPage.setHtml("newsinside");
newPage.setActions(newPageActions);
newPage.setDynamicFather(true);
configs.addPage(newPage);

var newPage = new Page("inside-list");
newPage.setHtml("inside-list");
configs.addPage(newPage);

var newPage = new Page("test");
newPage.setHtml("test");
configs.addPage(newPage);

var newPage = new Page("agenda-category");
newPage.setHtml("agenda-category");
configs.addPage(newPage);

var newPage = new Page("new-profile");
newPage.setHtml("new-profile");
configs.addPage(newPage);

var newPage = new Page("buyer");
newPage.setHtml("buyer");
configs.addPage(newPage);

var newPage = new Page("buyer-qr");
newPage.setHtml("buyer-qr");
configs.addPage(newPage);

// var newPage = new Page("participants");
// newPage.setHtml("participants");
// configs.addPage(newPage);

var newPage = new Page("agenda-publisher");
newPage.setHtml("agenda-publisher");
configs.addPage(newPage);

var newPage = new Page("participants-qr");
newPage.setHtml("participants-qr");
configs.addPage(newPage);

var newPage = new Page("cta-login");
newPage.setHtml("cta-login");
configs.addPage(newPage);

var newPage = new Page("choose-location");
newPage.setHtml("choose-location");
configs.addPage(newPage);

var newPage = new Page("reserve-table");
newPage.setHtml("reserve-table");
configs.addPage(newPage);

var newPage = new Page("rating");
newPage.setHtml("rating");
configs.addPage(newPage);

var newPage = new Page("prize");
newPage.setHtml("prize");
configs.addPage(newPage);

var newPage = new Page("prize-inside");
newPage.setHtml("prize-inside");
configs.addPage(newPage);

var newPage = new Page("eventInsideParticipants");
newPage.setAside(false);
newPage.setDynamicFather(true);
newPage.setTabs(true);
var newPageActions = new LoadedFunction("eventInsideParticipants", "$.eventInsideParticipantsStart", "$.eventInsideParticipantsUpdate");
newPage.setHtml("eventInsideParticipants");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("eventInsideCheckin");
newPage.setAside(false);
newPage.setDynamicFather(true);
//newPage.setTabs(true);
var newPageActions = new LoadedFunction("eventInsideCheckin", "$.eventInsideCheckinStart", "$.eventInsideCheckinUpdate");
newPage.setHtml("eventInsideCheckin");
newPage.setActions(newPageActions);
configs.addPage(newPage);


var newPage = new Page("eventInsideRel");
newPage.setAside(false);
newPage.setDynamicFather(true);
newPage.setTabs(true);
var newPageActions = new LoadedFunction("eventInsideRel", "$.eventInsideRelStart", "$.eventInsideRelUpdate");
newPage.setHtml("eventInsideRel");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("eventLikeList");
newPage.setAside(false);
newPage.setDynamicFather(true);
var newPageActions = new LoadedFunction("eventLikeList", "$.eventLikeListStart", "$.eventLikeListUpdate");
newPage.setHtml("eventInsideLikes");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("listPromotersDetails");
newPage.setAside(false);
newPage.setDynamicFather(true);
var newPageActions = new LoadedFunction("listPromotersDetails", "$.listPromotersDetailsStart", "$.listPromotersDetailsUpdate");
newPage.setHtml("eventInsideLikes");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("eventInsideListAdd");
newPage.setAside(false);
newPage.setDynamicFather(true);
//newPage.setFather("eventInsideList");
var newPageActions = new LoadedFunction("eventInsideListAdd", "$.eventInsideListAddStart", "$.eventInsideListAddUpdate");
newPage.setHtml("eventInsideListAdd");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("eventInside");
newPage.setAside(false);
newPage.setDynamicFather(true);
newPage.setHeaderFade(true);
//newPage.setFather("agenda");
var newPageActions = new LoadedFunction("eventinside", "$.eventInsideStart", "$.eventInsideUpdate");
newPage.setHtml("eventinside");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("notificationEventInside");
newPage.setAside(false);
newPage.setDynamicFather(true);
newPage.setHeaderFade(true);
//newPage.setFather("notifications");
var newPageActions = new LoadedFunction("eventinside", "$.notificationEventInsideStart", "$.notificationEventInsideUpdate");
newPage.setHtml("eventinside");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("eventInsideList");
newPage.setAside(false);
//newPage.setFather("eventInside");
newPage.setDynamicFather(true);
var newPageActions = new LoadedFunction("eventInsideList", "$.eventInsideListStart", "$.eventInsideListUpdate");
newPage.setHtml("eventInsideList");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("notificationEventInsideList");
newPage.setAside(false);
newPage.setDynamicFather(true);
//newPage.setFather("notifications");
var newPageActions = new LoadedFunction("eventInsideList", "$.notificationEventInsideListStart", "$.notificationEventInsideListUpdate");
newPage.setHtml("eventInsideList");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("ticketEvent");//open page
newPage.setAside(false);
newPage.setDynamicFather(true);
//newPage.setFather("eventInside");//open page
var newPageActions = new LoadedFunction("ticketEvent", "$.ticketEventStart", "$.ticketEventUpdate");
newPage.setHtml("ticketEvent");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("notifications");
newPage.setAside(true);
var newPageActions = new LoadedFunction("notifications", "$.notificationsStart", "$.notificationsUpdate");
newPage.setHtml("notifications");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("history-actions");
newPage.setAside(false);
newPage.setFather("profile");
var newPageActions = new LoadedFunction("history-actions", "$.historyActionsStart", "$.historyActionsUpdate");
newPage.setHtml("history-actions");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("edit-profile");
newPage.setAside(false);
newPage.setFather("profile");
var newPageActions = new LoadedFunction("edit-profile", "$.editProfileStart", "$.editProfileUpdate");
newPage.setHtml("edit-profile");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("profile");
newPage.setHeaderFade(true);
var newPageActions = new LoadedFunction("profile", "$.profileStart", "$.profileUpdate");
newPage.setHtml("profile");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("institucional");
//newPage.setAside(true);
newPage.setHeaderFade(true);
var newPageActions = new LoadedFunction("institutional", "$.institutionalEvent", "$.institutionalUpdate");
newPage.setHtml("institucional");
newPage.setActions(newPageActions);
configs.addPage(newPage);


var newPage = new Page("facebook");
//newPage.setAside(true);
var newPageActions = new LoadedFunction("facebook", "$.facebookStart", "$.facebookUpdate");
newPage.setHtml("facebook");
newPage.setActions(newPageActions);
configs.addPage(newPage);



var newPage = new Page("menu");
//newPage.setAside(true);
var newPageActions = new LoadedFunction("menu", "$.menuStart", "$.menuUpdate");
newPage.setHtml("menu");
newPage.setActions(newPageActions);
configs.addPage(newPage);

var newPage = new Page("menuinside");
newPage.setAside(false);
newPage.setFather("menu");
var newPageActions = new LoadedFunction("menuinside", "$.menuInsideStart", "$.menuInsideUpdate");
newPage.setHtml("menuinside");
newPage.setActions(newPageActions);
configs.addPage(newPage);
