var slideAnimationSpeed = 220;					// Velocidade padrão das animações
var slideComponent      = "general-content";	// Dentro de onde as animações vão ocorrer
var container           = $("#"+slideComponent);// Obj jquery onde as animações vão ocorrer
var currentPage;								// Componente da pagina que esta chegando
var oldPage             = null;					// Componente da pagina que estava sendo exibida
var oldPageName         = null;
var firstExecution      = "";					// Identifica se o aplicativo acabou de abrir para na executar animação

var crossBrowserTransitionEnd = 'transitionend otransitionend webkitTransitionEnd'; //evento de fim de animação css crossbrowser

//volta para a pagina definida como padrão no dhone
jQuery.goHome = function() {
    window.location.hash = "#"+configs.getDefaultPage()+"#slide#back";
    return false;
}

//função padrão de navegação interna do app
jQuery.dhoneNavigate = function(link) {
    link = encodeURI(link);

    if(link.split("#")[1] != pageNow){
        if(isOpenMenu){
            $.slideMenu(size, configs.getContentSizeOnAside(), 150);

            $("#asideAnimation").one(crossBrowserTransitionEnd,function(e) {
                window.location.hash = link;
            });
        }
        else {
            var htmltransparent = '<div class="transparent-fg" />';
            configs.jPages[configs.getPageNow()].append(htmltransparent);
            window.location.hash = link;
        }
    } else {
        if(isOpenMenu){ $.slideMenu(size, configs.getContentSizeOnAside(), 150); }
        //fim do carregamento do módulo
        loadingModules = false;
    }
    
    return false;
}

//função que trata a mudança de pagina recebendo a URL no seguinte formato
//#PAGE #ANIMATION #SENTIDO
jQuery.pageChange = function() {

    var hash = window.location.hash;
    var hashText = hash;
    hash = hash.split("#");
    hash.splice(0, 1);

    var pageName = hash[0];
    var pageAnim = "no";
    var pageSens = "go";

    if (hash.length == 2) {
        pageAnim = hash[1];
    }else if(hash.length == 3) {
        pageAnim = hash[1];
        pageSens = hash[2];
    }else if(hash.length > 3) {
        pageAnim = hash[1];
        pageSens = hash[2];
    }

    if ($.trim(hashText) != "" && pageSens != "back") {
        configs.addHistory(hashText);
    }

    if (pageName == configs.getDefaultPage()) {
        configs.clearHistory();
    }

    //Seta o pai da pagina interna que titer dynamicFather == true
    if (pageName && configs.getPageDynamicFather(pageName) == true && pageSens != "back") {
        configs.setPageFather(pageName, pageNow);
    }

    oldPageName = pageNow;
    pageNow = pageName;

    configs.loadHtml(pageName, $.animateTransition, pageAnim, pageSens);
}


jQuery.dhoneBack = function() {
    $(".bg-hover").removeClass("bg-hover");
    
    if(modalOppened){
        $.modalHide();
    } else {
        var hash = configs.historyGoBack();

        if (hash == "[close]") {
            if (dhoneDevice != "browser") {
                navigator.app.exitApp();
            }else {
                console.log("Finished");
                return false;
            }
        }

        window.location.hash = hash;
        setTimeout(function(){
            console.log(hash.split("#")[1]);
            configs.jPages[hash.split("#")[1]].find(".transparent-fg").hide();
        },410);
        //hash.split("#")[1]
    }
}


//Gerenciador de animação. tem todas as animações estão incluidas nele
jQuery.animateTransition = function(page, action, animation, sense) {

    if (!configs.jPages[action]) {
        page.addClass("page");
        configs.jPages[action] = page;
        container.append(page);
    }

    if (firstExecution == "") {
        firstExecution = action;
        currentPage = configs.jPages[action];
        $.noAnimationStartApp(sense, action);
        //fim do carregamento do módulo
        loadingModules = false;
        return;

    }

    oldPage = currentPage;
    currentPage = configs.jPages[action];

    if (firstExecution != action) {
        currentPage.css("position", "absolute");
    }

    //add a referencia para a animação aqui
    if (oldPage != null) {
        switch(animation) {
            case "slide": {
                $.slideAnimation(sense, action);
                break;
            }
            default: {
                $.noAnimation(sense, action);
                break;
            }
        }
    }

    //fim do carregamento do módulo
    loadingModules = false;
}

//função chamada apenas ao abrir o app
jQuery.noAnimationStartApp = function(sense, action) {
    currentPage.addClass("centerP");
    //Inicia as acoes das paginas quando esta entrando nela
    if (sense != "back") {
        $.startAction(action);
    }

}

//transição sem animação
jQuery.noAnimation = function(sense, action) {
    switch(sense) {
        case "back": {
            oldPage.removeClass("centerP");
            oldPage.addClass("rightP");
            currentPage.removeClass("rightP");
            configs.unloadPage(oldPageName); //aqui melhoria <<<<<<<<<<

            break;
        }
        default: {
            oldPage.addClass("rightP");

            currentPage.removeClass("rightP");
            currentPage.addClass("centerP");

            if (configs.getPageFather(action) != oldPageName) {
                if (oldPageName != configs.getDefaultPage()) {
                    configs.unloadPage(oldPageName);
                }
            }


           /* //Remove os pais
            while(configs.getPageFather(oldPageName) != null) {
                configs.jPages[configs.getPageFather(oldPageName)].addClass("rightP");
                oldPageName = configs.getPageFather(oldPageName);

            }*/

            break;
        }
    }

    //Inicia as acoes das paginas quando esta entrando nela
    if (sense != "back") {
        $.startAction(action);
    }

}


//transição slide
jQuery.slideAnimation = function(sense, action) {

    $(".screen-size").addAnimation(0, "ease");
    currentPage.removeClass("leftP rightP");


    switch(sense) {
        case "back": {
            //currentPage.addAnimation(300, "ease");

            setTimeout(function() {
                //currentPage.css("-webkit-filter", "brightness(1)");
                currentPage.find(".transparent-fg").addClass("animate");
                //currentPage.find(".transparent-fg").css("opacity", "0");
                $(".screen-size").addAnimation(300, "ease");
                oldPage.addClass("rightP");
                //currentPage.removeClass("leftP");
            }, 50);

            setTimeout(function() {
                configs.unloadPage(oldPageName);
            }, 410);


            break;
        }
        default: {
            currentPage.addClass("rightP");
            currentPage.css("-webkit-transform", "translate3d(0, 0, 0)");
            currentPage.css("transform", "translate3d(0, 0, 0)");
            
            setTimeout(function() {
                $(".screen-size").addAnimation(300, "ease");
                //oldPage.addClass("leftP");
                currentPage.removeClass("rightP");

                //oldPage.css("-webkit-filter", "brightness(0.2)");
                oldPage.find(".transparent-fg").addClass("animate");
                //oldPage.find(".transparent-fg").css("opacity", "0.8");

            }, 100);
            

            break;
        }

    }

    //Inicia as acoes das paginas quando esta entrando nela
    if (sense != "back") {
        $.startAction(action);
    }

}


/*!
 * jQuery.scrollTo
 * Copyright (c) 2007-2015 Ariel Flesler - aflesler ○ gmail • com | http://flesler.blogspot.com
 * Licensed under MIT
 * http://flesler.blogspot.com/2007/10/jqueryscrollto.html
 * @projectDescription Lightweight, cross-browser and highly customizable animated scrolling with jQuery
 * @author Ariel Flesler
 * @version 2.1.2
 */
;(function(factory) {
    'use strict';
    if (typeof define === 'function' && define.amd) {
        // AMD
        define(['jquery'], factory);
    } else if (typeof module !== 'undefined' && module.exports) {
        // CommonJS
        module.exports = factory(require('jquery'));
    } else {
        // Global
        factory(jQuery);
    }
})(function($) {
    'use strict';

    var $scrollTo = $.scrollTo = function(target, duration, settings) {
        return $(window).scrollTo(target, duration, settings);
    };

    $scrollTo.defaults = {
        axis:'xy',
        duration: 0,
        limit:true
    };

    function isWin(elem) {
        return !elem.nodeName ||
            $.inArray(elem.nodeName.toLowerCase(), ['iframe','#document','html','body']) !== -1;
    }       

    $.fn.scrollTo = function(target, duration, settings) {
        if (typeof duration === 'object') {
            settings = duration;
            duration = 0;
        }
        if (typeof settings === 'function') {
            settings = { onAfter:settings };
        }
        if (target === 'max') {
            target = 9e9;
        }

        settings = $.extend({}, $scrollTo.defaults, settings);
        // Speed is still recognized for backwards compatibility
        duration = duration || settings.duration;
        // Make sure the settings are given right
        var queue = settings.queue && settings.axis.length > 1;
        if (queue) {
            // Let's keep the overall duration
            duration /= 2;
        }
        settings.offset = both(settings.offset);
        settings.over = both(settings.over);

        return this.each(function() {
            // Null target yields nothing, just like jQuery does
            if (target === null) return;

            var win = isWin(this),
                elem = win ? this.contentWindow || window : this,
                $elem = $(elem),
                targ = target, 
                attr = {},
                toff;

            switch (typeof targ) {
                // A number will pass the regex
                case 'number':
                case 'string':
                    if (/^([+-]=?)?\d+(\.\d+)?(px|%)?$/.test(targ)) {
                        targ = both(targ);
                        // We are done
                        break;
                    }
                    // Relative/Absolute selector
                    targ = win ? $(targ) : $(targ, elem);
                    /* falls through */
                case 'object':
                    if (targ.length === 0) return;
                    // DOMElement / jQuery
                    if (targ.is || targ.style) {
                        // Get the real position of the target
                        toff = (targ = $(targ)).offset();
                    }
            }

            var offset = $.isFunction(settings.offset) && settings.offset(elem, targ) || settings.offset;

            $.each(settings.axis.split(''), function(i, axis) {
                var Pos = axis === 'x' ? 'Left' : 'Top',
                    pos = Pos.toLowerCase(),
                    key = 'scroll' + Pos,
                    prev = $elem[key](),
                    max = $scrollTo.max(elem, axis);

                if (toff) {// jQuery / DOMElement
                    attr[key] = toff[pos] + (win ? 0 : prev - $elem.offset()[pos]);

                    // If it's a dom element, reduce the margin
                    if (settings.margin) {
                        attr[key] -= parseInt(targ.css('margin'+Pos), 10) || 0;
                        attr[key] -= parseInt(targ.css('border'+Pos+'Width'), 10) || 0;
                    }

                    attr[key] += offset[pos] || 0;

                    if (settings.over[pos]) {
                        // Scroll to a fraction of its width/height
                        attr[key] += targ[axis === 'x'?'width':'height']() * settings.over[pos];
                    }
                } else {
                    var val = targ[pos];
                    // Handle percentage values
                    attr[key] = val.slice && val.slice(-1) === '%' ?
                        parseFloat(val) / 100 * max
                        : val;
                }

                // Number or 'number'
                if (settings.limit && /^\d+$/.test(attr[key])) {
                    // Check the limits
                    attr[key] = attr[key] <= 0 ? 0 : Math.min(attr[key], max);
                }

                // Don't waste time animating, if there's no need.
                if (!i && settings.axis.length > 1) {
                    if (prev === attr[key]) {
                        // No animation needed
                        attr = {};
                    } else if (queue) {
                        // Intermediate animation
                        animate(settings.onAfterFirst);
                        // Don't animate this axis again in the next iteration.
                        attr = {};
                    }
                }
            });

            animate(settings.onAfter);

            function animate(callback) {
                var opts = $.extend({}, settings, {
                    // The queue setting conflicts with animate()
                    // Force it to always be true
                    queue: true,
                    duration: duration,
                    complete: callback && function() {
                        callback.call(elem, targ, settings);
                    }
                });
                $elem.animate(attr, opts);
            }
        });
    };

    // Max scrolling position, works on quirks mode
    // It only fails (not too badly) on IE, quirks mode.
    $scrollTo.max = function(elem, axis) {
        var Dim = axis === 'x' ? 'Width' : 'Height',
            scroll = 'scroll'+Dim;

        if (!isWin(elem))
            return elem[scroll] - $(elem)[Dim.toLowerCase()]();

        var size = 'client' + Dim,
            doc = elem.ownerDocument || elem.document,
            html = doc.documentElement,
            body = doc.body;

        return Math.max(html[scroll], body[scroll]) - Math.min(html[size], body[size]);
    };

    function both(val) {
        return $.isFunction(val) || $.isPlainObject(val) ? val : { top:val, left:val };
    }

    // Add special hooks so that window scroll properties can be animated
    $.Tween.propHooks.scrollLeft = 
    $.Tween.propHooks.scrollTop = {
        get: function(t) {
            return $(t.elem)[t.prop]();
        },
        set: function(t) {
            var curr = this.get(t);
            // If interrupt is true and user scrolled, stop animating
            if (t.options.interrupt && t._last && t._last !== curr) {
                return $(t.elem).stop();
            }
            var next = Math.round(t.now);
            // Don't waste CPU
            // Browsers don't render floating point scroll
            if (curr !== next) {
                $(t.elem)[t.prop](next);
                t._last = this.get(t);
            }
        }
    };

    // AMD requirement
    return $scrollTo;
});